# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTIBILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

bl_info = {
    "name" : "RIG_CREATOR",
    "author" : "Edward Ureña", 
    "description" : "",
    "blender" : (4, 0, 0),
    "version" : (1, 0, 3),
    "location" : "",
    "warning" : "",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "Rigging" 
}


import bpy
import bpy.utils.previews
import os


addon_keymaps = {}
_icons = None


def property_exists(prop_path, glob, loc):
    try:
        eval(prop_path, glob, loc)
        return True
    except:
        return False


class SNA_OT_Operator_6Afd6(bpy.types.Operator):
    bl_idname = "sna.operator_6afd6"
    bl_label = "Operator"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Operator_5B117(bpy.types.Operator):
    bl_idname = "sna.operator_5b117"
    bl_label = "Operator"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        Armature = bpy.context.active_object
        bpy.ops.object.mode_set(mode='EDIT')
        selected_bones = [bone for bone in bpy.context.selected_editable_bones]
        selected_bones_Name = [bone.name for bone in bpy.context.selected_editable_bones]
        num_selected_bones = len(selected_bones)
        Chain = "Chain_"

        def App_Bones(Control, Bones, Cuantos = int(0)):
            for i in range(Cuantos):
                ultima_letra = Bones[-1].lower()  
                Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                if not Tiene_L_O_R:
                    Bone_Name = Control + Bones[:-3] + str(i)
                else:
                    Bone_Name = Control + Bones + "." + str(i)
                bpy.ops.armature.bone_primitive_add(name=Bone_Name)

        def Encontrar_Bone(Control, Bones, Varible = [], Cuantos = int(0)):
            for i in range(Cuantos):
                ultima_letra = Bones[-1].lower()  
                Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                if not Tiene_L_O_R:
                    Bone_Name = Control + Bones[:-3] + str(i)
                else:
                    Bone_Name = Control + Bones + "." + str(i)
                Varible.append(Armature.data.edit_bones.get(Bone_Name))

        def Posicionar_Bones(Bone, head, tail, roll, length, tengo_length = True):
            Bone.head = head
            Bone.tail = tail
            Bone.roll = roll
            if tengo_length == True:
                Bone.length = length
            else:
                print("no quiero length en el bone")

        def Posicionar_Bones_head(Bone, head, tail, roll, length, Bones_Select ,tengo_length = True ):
            for i in range(len(Bones_Select) -1):
                if (Bones_Select[i].head == Bones_Select[i+1].head or
                        Bones_Select[i].tail == Bones_Select[i+1].tail or 
                        Bones_Select[i].head == Bones_Select[i+1].tail or
                        Bones_Select[i].tail == Bones_Select[i+1].head):
                    Bone.head = head
                    Bone.tail = tail
                    Bone.roll = roll
                    if tengo_length == True:
                        Bone.length = length
                    else:
                        print("no quiero length en el bone")

        def pocioner_Bones_tail(Bone, head, tail, roll, length, tengo_length = True):
            Bone.head = head
            Bone.tail = tail
            Bone.length *= 2
            Bone.head = tail
            Bone.roll = roll
            if tengo_length == True:
                Bone.length = length
            else:
                print("no quiero length en el bone")
        #si estoy en Edit Bone
        if Armature and Armature.type == 'ARMATURE':
            Chain_Controles = []
            cantidad = int(len(selected_bones) - (len(selected_bones) / 3))
            head_bones = []
            App_Bones(Chain, selected_bones_Name[0], Cuantos = int(cantidad))
            Encontrar_Bone(Chain, selected_bones_Name[0], Chain_Controles, Cuantos = int(cantidad))
            print(cantidad)
            if Chain_Controles:
                for i in range(cantidad):
                    Posicionar_Bones(Chain_Controles[i], 
                                     selected_bones[i].head, 
                                     (selected_bones[i].head.x, selected_bones[i].head.y, 1), 
                                     selected_bones[i].roll, 
                                     selected_bones[i].length, 
                                     tengo_length = True)
            #bpy.ops.object.mode_set(mode='POSE')
        #
            #Pose_selected_bones = []
            #
            #for i in range(num_selected_bones):
            #    Control = selected_bones_Name[i]
            #    Bones = Armature.pose.bones.get(Control)
            #    Pose_selected_bones.append(Bones)
        #
        #
            #Pose_Chain_Controles = []
        #
            #for i in range(cantidad):
        #
        #
            #    Bones = selected_bones_Name[0]
        #
            #    ultima_letra = Bones[-1].lower()
        #
            #    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
        #
            #    if not Tiene_L_O_R:
            #        Bone_Name = Chain + Bones[:-3] + str(i)
            #    else:
            #        Bone_Name = Chain + Bones + "." + str(i)
        #
            #    Bones = Armature.pose.bones.get(Bone_Name)
            #    Pose_Chain_Controles.append(Bones)
        #
        #
            #if Pose_selected_bones:
        #
            #    Armature_2 = bpy.data.armatures["Armature"]["IK_FK"]
            #    propiedad_driver = Armature_2.driver_add("[""IK_FK""]")
        #
            #    # Configura el controlador del driver
            #    controlador = propiedad_driver.driver
            #    controlador.type = 'SCRIPTED'
            #    controlador.expression = "var"  # Puedes ajustar la expresión según sea necesario
        #
            #    # Agrega la variable a la expresión del controlador
            #    variable = controlador.variables.new()
            #    variable.name = "var"
            #    variable.type = 'TRANSFORMS'
            #    variable.targets[0].id_type = 'OBJECT'
            #    variable.targets[0].id = bpy.data.objects["Armature"]
            #    variable.targets[0].bone_target = "Bone_L.004"
            #    variable.targets[0].transform_type = 'LOC_Z' 
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def sna_paneles_3F663(layout_function, ):
    row_DF515 = layout_function.row(heading='', align=False)
    row_DF515.alert = False
    row_DF515.enabled = True
    row_DF515.active = True
    row_DF515.use_property_split = False
    row_DF515.use_property_decorate = False
    row_DF515.scale_x = 1.0
    row_DF515.scale_y = 1.0
    row_DF515.alignment = 'Left'.upper()
    row_DF515.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_DF515.prop(bpy.context.scene, 'sna_bool_rol_fk', text='Generator ROT FK', icon_value=(46 if bpy.context.scene.sna_bool_rol_fk else 45), emboss=False)
    if bpy.context.scene.sna_bool_rol_fk:
        grid_6CA93 = layout_function.grid_flow(columns=-535, row_major=False, even_columns=False, even_rows=False, align=False)
        grid_6CA93.enabled = True
        grid_6CA93.active = True
        grid_6CA93.use_property_split = False
        grid_6CA93.use_property_decorate = False
        grid_6CA93.alignment = 'Expand'.upper()
        grid_6CA93.scale_x = 1.0
        grid_6CA93.scale_y = 1.2000000476837158
        if not True: grid_6CA93.operator_context = "EXEC_DEFAULT"
        grid_C4D16 = grid_6CA93.grid_flow(columns=2, row_major=False, even_columns=False, even_rows=False, align=True)
        grid_C4D16.enabled = True
        grid_C4D16.active = True
        grid_C4D16.use_property_split = False
        grid_C4D16.use_property_decorate = False
        grid_C4D16.alignment = 'Expand'.upper()
        grid_C4D16.scale_x = 1.0
        grid_C4D16.scale_y = 1.0
        if not True: grid_C4D16.operator_context = "EXEC_DEFAULT"
        grid_C4D16.prop(bpy.context.scene, 'sna_parent', text='Parent_DEF', icon_value=691, emboss=True, toggle=True)
        grid_C4D16.prop(bpy.context.scene, 'sna_segments', text='Segments', icon_value=454, emboss=True, toggle=True)
        grid_007E5 = grid_6CA93.grid_flow(columns=-543, row_major=False, even_columns=False, even_rows=False, align=True)
        grid_007E5.enabled = True
        grid_007E5.active = True
        grid_007E5.use_property_split = False
        grid_007E5.use_property_decorate = False
        grid_007E5.alignment = 'Expand'.upper()
        grid_007E5.scale_x = 1.0
        grid_007E5.scale_y = 1.0
        if not True: grid_007E5.operator_context = "EXEC_DEFAULT"
        grid_007E5.prop(bpy.context.scene, 'sna_dedo', text='SCALE_ROT', icon_value=434, emboss=True, toggle=True)
        if bpy.context.scene.sna_dedo:
            grid_97301 = grid_007E5.grid_flow(columns=2, row_major=False, even_columns=False, even_rows=False, align=True)
            grid_97301.enabled = True
            grid_97301.active = True
            grid_97301.use_property_split = False
            grid_97301.use_property_decorate = False
            grid_97301.alignment = 'Expand'.upper()
            grid_97301.scale_x = 1.0
            grid_97301.scale_y = 1.0
            if not True: grid_97301.operator_context = "EXEC_DEFAULT"
            grid_97301.prop(bpy.context.scene, 'sna_cuantos_interaciones', text='QUIT_HUESO', icon_value=434, emboss=True, toggle=True)
            grid_97301.prop(bpy.context.scene, 'sna_ultimo', text='', icon_value=420, emboss=True, toggle=True)
        op = grid_6CA93.operator('sna.operator_f577f', text='Generator Rot Fk', icon_value=495, emboss=True, depress=False)
        grid_8686F = grid_6CA93.grid_flow(columns=1, row_major=False, even_columns=False, even_rows=False, align=True)
        grid_8686F.enabled = True
        grid_8686F.active = True
        grid_8686F.use_property_split = False
        grid_8686F.use_property_decorate = False
        grid_8686F.alignment = 'Expand'.upper()
        grid_8686F.scale_x = 1.0
        grid_8686F.scale_y = 1.0
        if not True: grid_8686F.operator_context = "EXEC_DEFAULT"
        grid_8686F.prop(bpy.context.scene, 'sna_name_fk', text='FK_NAME', icon_value=174, emboss=True, toggle=True)
        grid_8686F.prop(bpy.context.scene, 'sna_name_control', text='FK_CONTROL', icon_value=174, emboss=True, toggle=True)


class SNA_OT_Operator_F577F(bpy.types.Operator):
    bl_idname = "sna.operator_f577f"
    bl_label = "Operator"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        if property_exists("bpy.data.collections['RIG_CREATOR_Material']", globals(), locals()):
            Parent = bpy.context.scene.sna_parent
            Segments_ = bpy.context.scene.sna_segments
            Variable = None
            FK_ = bpy.context.scene.sna_name_fk
            CONTROL_ = bpy.context.scene.sna_name_control
            DEdo = bpy.context.scene.sna_dedo
            Cuantos_interaciones = bpy.context.scene.sna_cuantos_interaciones
            Ultimo = bpy.context.scene.sna_ultimo
            Armature = bpy.context.active_object
            bpy.ops.object.mode_set(mode='EDIT')
            selected_bones = [bone for bone in bpy.context.selected_editable_bones]
            selected_bones_Name = [bone.name for bone in bpy.context.selected_editable_bones]
            num_selected_bones = len(selected_bones)
            FK = FK_
            CONTROL = CONTROL_
            if DEdo == True:
                DEDOS = "DEDOS" + FK

            def App_Bones(Control, Bones, Cuantos = int(0)):
                for i in range(Cuantos):
                    ultima_letra = Bones[-1].lower()  
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = Control + Bones[:-3] + str(i)
                    else:
                        Bone_Name = Control + Bones + "." + str(i)
                    bpy.ops.armature.bone_primitive_add(name=Bone_Name)

            def Encontrar_Bone(Control, Bones, Varible = [], Cuantos = int(0)):
                for i in range(Cuantos):
                    ultima_letra = Bones[-1].lower()  
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = Control + Bones[:-3] + str(i)
                    else:
                        Bone_Name = Control + Bones + "." + str(i)
                    Varible.append(Armature.data.edit_bones.get(Bone_Name))

            def Posicionar_Bones(Bone, head, tail, roll, length, tengo_length = True):
                Bone.head = head
                Bone.tail = tail
                Bone.roll = roll
                if tengo_length == True:
                    Bone.length = length
                else:
                    print("no quiero length en el bone")

            def pocioner_Bones_tail(Bone, head, tail, roll, length, tengo_length = True):
                Bone.head = head
                Bone.tail = tail
                Bone.length *= 2
                Bone.head = tail
                Bone.roll = roll
                if tengo_length == True:
                    Bone.length = length
                else:
                    print("no quiero length en el bone")
            #si estoy en Edit Bone
            if Armature and Armature.type == 'ARMATURE':
                Control_Bone = []
                Fk_Controles = []
                DEDOS_CONTROL = []
                Emparentar_Bones_Def = Parent
                Segments = Segments_
                if selected_bones:
                    #def_controles
                    Numero_de_bones = num_selected_bones + 1
                    App_Bones(CONTROL, selected_bones_Name[0], Cuantos = int(Numero_de_bones))
                    Encontrar_Bone(CONTROL, selected_bones_Name[0], Control_Bone, Cuantos = int(Numero_de_bones))
                    for i in range(num_selected_bones):
                        Posicionar_Bones(Control_Bone[i], selected_bones[i].head, 
                                         selected_bones[i].tail, selected_bones[i].roll, 
                                         selected_bones[i].length / 4, tengo_length = True)
                    if Numero_de_bones > 1:
                        pocioner_Bones_tail(Control_Bone[-1], selected_bones[-1].head, 
                                            selected_bones[-1].tail, selected_bones[-1].roll, selected_bones[-1].length / 4, 
                                            tengo_length = True)
                    else:
                        pocioner_Bones_tail(Control_Bone[-1], selected_bones[0].head, 
                                            selected_bones[0].tail, selected_bones[0].roll, selected_bones[0].length / 4, 
                                            tengo_length = True)
                    if Control_Bone:
                        for i in range(Numero_de_bones):
                            Control_Bone[i].use_deform = False
                    #FK Controles:
                    Numero_de_bones = num_selected_bones + 1
                    App_Bones(FK, selected_bones_Name[0], Cuantos = int(Numero_de_bones))
                    Encontrar_Bone(FK, selected_bones_Name[0], Fk_Controles, Cuantos = int(Numero_de_bones))
                    for i in range(num_selected_bones):
                        Posicionar_Bones(Fk_Controles[i], selected_bones[i].head, 
                                         selected_bones[i].tail, selected_bones[i].roll, 
                                         selected_bones[i].length, tengo_length = False)
                    if Numero_de_bones > 1:
                        pocioner_Bones_tail(Fk_Controles[-1], selected_bones[-1].head, 
                                            selected_bones[-1].tail, selected_bones[-1].roll, selected_bones[-1].length / 4, 
                                            tengo_length = False)
                    else:
                        pocioner_Bones_tail(Fk_Controles[-1], selected_bones[0].head, 
                                            selected_bones[0].tail, selected_bones[0].roll, selected_bones[0].length / 4, 
                                            tengo_length = False)
                    if Fk_Controles:
                        for i in range(Numero_de_bones):
                            Fk_Controles[i].use_deform = False
                    if Fk_Controles:
                        for i in range(num_selected_bones):
                            Fk_Controles[i + 1].parent = Fk_Controles[i]
                            if num_selected_bones > 1:
                                if Fk_Controles[i + 1].parent != None:
                                    Fk_Controles[i + 1].use_connect = True
                    if Control_Bone and Fk_Controles:
                        for i in range(num_selected_bones):
                            Control_Bone[i].parent = Fk_Controles[i]
                        Control_Bone[-1].parent = Fk_Controles[-2]
                    if Emparentar_Bones_Def == True:
                        selected_bones[0].parent = Control_Bone[0]
                        selected_bones[0].use_connect = False
                    else:
                        print("Nop")
                    if Segments == True:
                        if num_selected_bones > 1:
                            Fk_Controles[-1].parent = selected_bones[-1]
                            Fk_Controles[-1].use_connect = True
                        else:
                            Fk_Controles[1].parent = selected_bones[0]
                            Fk_Controles[1].use_connect = True
                    else:
                        print("Nop")
                    if DEdo == True:
                        length_Get = 0
                        for i in range(num_selected_bones):
                            length_Get += selected_bones[i].length
                        App_Bones(DEDOS, selected_bones_Name[0], Cuantos = int(2))
                        Encontrar_Bone(DEDOS, selected_bones_Name[0], DEDOS_CONTROL, Cuantos = int(2))
                        Posicionar_Bones(DEDOS_CONTROL[0], selected_bones[0].head, 
                                         selected_bones[0].tail, selected_bones[0].roll, 
                                         selected_bones[0].length / 2, tengo_length = True)
                        Posicionar_Bones(DEDOS_CONTROL[1], selected_bones[0].head, 
                                         selected_bones[0].tail, selected_bones[0].roll, 
                                         length_Get, tengo_length = True)
                        if DEDOS_CONTROL[1]:
                            DEDOS_CONTROL[1].length += (selected_bones[-1].length / 2) 
                        Fk_Controles[0].parent = DEDOS_CONTROL[1]
                        DEDOS_CONTROL[1].parent = DEDOS_CONTROL[0]
                        for i in range(2):
                            DEDOS_CONTROL[i].use_deform = False
                bpy.ops.object.mode_set(mode='POSE')
                Pose_selected_bones = []
                for i in range(num_selected_bones):
                    Control = selected_bones_Name[i]
                    Bones = Armature.pose.bones.get(Control)
                    Pose_selected_bones.append(Bones)
                Pose_Control_Bone = []
                for i in range(num_selected_bones + 1):
                    Bones = selected_bones_Name[0]
                    ultima_letra = Bones[-1].lower()
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = CONTROL + Bones[:-3] + str(i)
                    else:
                        Bone_Name = CONTROL + Bones + "." + str(i)
                    Bones = Armature.pose.bones.get(Bone_Name)
                    Pose_Control_Bone.append(Bones)
                Pose_Fk_Controles = []
                for i in range(num_selected_bones + 1):
                    Bones = selected_bones_Name[0]
                    ultima_letra = Bones[-1].lower()
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = FK + Bones[:-3] + str(i)
                    else:
                        Bone_Name = FK + Bones + "." + str(i)
                    Bones = Armature.pose.bones.get(Bone_Name)
                    Pose_Fk_Controles.append(Bones)
                if DEdo == True:
                    Pose_DEDOS = []
                    for i in range(num_selected_bones + 1):
                        Bones = selected_bones_Name[0]
                        ultima_letra = Bones[-1].lower()
                        Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                        if not Tiene_L_O_R:
                            Bone_Name = DEDOS + Bones[:-3] + str(i)
                        else:
                            Bone_Name = DEDOS + Bones + "." + str(i)
                        Bones = Armature.pose.bones.get(Bone_Name)
                        Pose_DEDOS.append(Bones)
                if  Emparentar_Bones_Def == True:
                    if Pose_selected_bones and Pose_Control_Bone and Pose_Fk_Controles:
                        for i in range(num_selected_bones):
                            constraint = Pose_selected_bones[i].constraints.new(type='COPY_TRANSFORMS')
                            constraint.target = Armature
                            constraint.subtarget = str(Pose_Control_Bone[i].name)
                        for i in range(num_selected_bones):
                            constraint = Pose_selected_bones[i].constraints.new(type='STRETCH_TO')
                            constraint.target = Armature
                            constraint.subtarget = Pose_Control_Bone[i + 1].name
                        if Pose_Fk_Controles[-1]:
                            constraint = Pose_Fk_Controles[-1].constraints.new(type='COPY_TRANSFORMS')
                            constraint.target = Armature
                            constraint.subtarget = Pose_Control_Bone[-1].name
                if Segments == True:
                    for i in range(num_selected_bones):    
                        bpy.data.armatures[Armature.name].bones[Pose_selected_bones[i].name].bbone_segments = 36    
                if Pose_selected_bones and Pose_Control_Bone and Pose_Fk_Controles:
                    if bpy.data.objects["Materiales_RIG_CREATOR.3"] and bpy.data.objects["Materiales_RIG_CREATOR.1"]:
                        for i in range(num_selected_bones + 1):
                            Pose_Control_Bone[i].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.3"]
                            Pose_Control_Bone[i].color.palette = 'THEME09' 
                        for i in range(num_selected_bones):
                            Pose_Fk_Controles[i].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.1"]
                            Pose_Fk_Controles[i].color.palette = 'THEME03' 
                            Pose_Fk_Controles[i].custom_shape_translation[1] = Pose_Fk_Controles[i].length / 2
                if DEdo == True:
                    if Pose_DEDOS:
                        Pose_DEDOS[1].lock_scale[0] = True
                        Pose_DEDOS[1].lock_scale[2] = True
                        Pose_DEDOS[1].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.0"]
                        Pose_DEDOS[1].custom_shape_rotation_euler[0] = -3.141592653589793 / 2
                        Pose_DEDOS[1].custom_shape_scale_xyz[1] = 0 
                        Pose_DEDOS[1].custom_shape_scale_xyz[0] *= 5 
                        Pose_DEDOS[0].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.2"]
                        Pose_DEDOS[1].color.palette = 'THEME04'
                        Pose_DEDOS[0].color.palette = 'THEME01'
                        for i in range(num_selected_bones):
                            constraint = Pose_Fk_Controles[i].constraints.new(type='COPY_SCALE')
                            constraint.target = Armature
                            constraint.subtarget = Pose_DEDOS[0].name
                        if Cuantos_interaciones == 0 or Cuantos_interaciones >= num_selected_bones:
                            for i in range(num_selected_bones):
                                constraint = Pose_Fk_Controles[i].constraints.new(type='TRANSFORM')
                                constraint.target = Armature
                                constraint.subtarget = Pose_DEDOS[1].name
                                constraint.target_space = 'LOCAL'
                                constraint.owner_space = 'LOCAL'
                                constraint.map_from = 'SCALE'
                                constraint.from_min_y_scale = 0.2
                                constraint.from_max_y_scale = 1.8
                                constraint.map_to = 'ROTATION'
                                constraint.map_to_x_from = 'Y'
                                constraint.to_min_x_rot = 3.141592653589793
                                constraint.to_max_x_rot = -3.141592653589793
                        else:
                            for i in range(num_selected_bones -1):
                                constraint = Pose_Fk_Controles[i + Cuantos_interaciones].constraints.new(type='TRANSFORM')
                                constraint.target = Armature
                                constraint.subtarget = Pose_DEDOS[1].name
                                constraint.target_space = 'LOCAL'
                                constraint.owner_space = 'LOCAL'
                                constraint.map_from = 'SCALE'
                                constraint.from_min_y_scale = 0.2
                                constraint.from_max_y_scale = 1.8
                                constraint.map_to = 'ROTATION'
                                constraint.map_to_x_from = 'Y'
                                constraint.to_min_x_rot = 3.141592653589793
                                constraint.to_max_x_rot = -3.141592653589793
                        if Ultimo == False:
                            constraint_to_remove = None
                            for constraint in Pose_Fk_Controles[-1].constraints:
                                if constraint.type == 'TRANSFORM':
                                    constraint_to_remove = constraint
                            if constraint_to_remove:
                                Pose_Fk_Controles[-1].constraints.remove(constraint_to_remove)
                        else:
                            if Segments == True:
                                constraint_to_remove = None
                                for constraint in Pose_Fk_Controles[-1].constraints:
                                    if constraint.type == 'TRANSFORM':
                                        constraint_to_remove = constraint
                                if constraint_to_remove:
                                    Pose_Fk_Controles[-1].constraints.remove(constraint_to_remove)
                                constraint = Pose_Fk_Controles[-1].constraints.new(type='TRANSFORM')
                                constraint.target = Armature
                                constraint.subtarget = Pose_DEDOS[1].name
                                constraint.target_space = 'LOCAL'
                                constraint.owner_space = 'LOCAL'
                                constraint.map_from = 'SCALE'
                                constraint.from_min_y_scale = 0.2
                                constraint.from_max_y_scale = 1.8
                                constraint.map_to = 'ROTATION'
                                constraint.map_to_x_from = 'Y'
                                constraint.to_min_x_rot = 3.141592653589793
                                constraint.to_max_x_rot = -3.141592653589793
                                constraint.influence = 0.5
                            else:
                                pass
        else:
            nombre_coleccion = "RIG_CREATOR_Material"
            nueva_coleccion = bpy.data.collections.new(nombre_coleccion)
            bpy.context.scene.collection.children.link(nueva_coleccion)
            colección_op = bpy.data.collections.get(nombre_coleccion)
            if colección_op:
                for i in range(4):
                    nombre_empty = "Materiales_RIG_CREATOR" + "." + str(i)
                    # Crear un nuevo objeto Empty
                    empty = bpy.data.objects.new(nombre_empty, None)
                    # Asignar tipo personalizado a Empty
                    if i == 0:
                        empty.empty_display_type = 'SINGLE_ARROW'
                    elif i == 1:
                        empty.empty_display_type = 'CIRCLE'
                    elif i == 2:
                        empty.empty_display_type = 'CUBE'
                    elif i == 3:
                        empty.empty_display_type = 'SPHERE'
                    # Añadir el Empty a la colección
                    colección_op.objects.link(empty)
            bpy.data.collections[nombre_coleccion].hide_viewport = False
            bpy.data.collections[nombre_coleccion].hide_render = False
            Parent = bpy.context.scene.sna_parent
            Segments_ = bpy.context.scene.sna_segments
            FK_ = bpy.context.scene.sna_name_fk
            CONTROL_ = bpy.context.scene.sna_name_control
            DEdo = bpy.context.scene.sna_dedo
            Cuantos_interaciones = bpy.context.scene.sna_cuantos_interaciones
            Ultimo = bpy.context.scene.sna_ultimo
            Armature = bpy.context.active_object
            bpy.ops.object.mode_set(mode='EDIT')
            selected_bones = [bone for bone in bpy.context.selected_editable_bones]
            selected_bones_Name = [bone.name for bone in bpy.context.selected_editable_bones]
            num_selected_bones = len(selected_bones)
            FK = FK_
            CONTROL = CONTROL_
            if DEdo == True:
                DEDOS = "DEDOS" + FK

            def App_Bones(Control, Bones, Cuantos = int(0)):
                for i in range(Cuantos):
                    ultima_letra = Bones[-1].lower()  
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = Control + Bones[:-3] + str(i)
                    else:
                        Bone_Name = Control + Bones + "." + str(i)
                    bpy.ops.armature.bone_primitive_add(name=Bone_Name)

            def Encontrar_Bone(Control, Bones, Varible = [], Cuantos = int(0)):
                for i in range(Cuantos):
                    ultima_letra = Bones[-1].lower()  
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = Control + Bones[:-3] + str(i)
                    else:
                        Bone_Name = Control + Bones + "." + str(i)
                    Varible.append(Armature.data.edit_bones.get(Bone_Name))

            def Posicionar_Bones(Bone, head, tail, roll, length, tengo_length = True):
                Bone.head = head
                Bone.tail = tail
                Bone.roll = roll
                if tengo_length == True:
                    Bone.length = length
                else:
                    print("no quiero length en el bone")

            def pocioner_Bones_tail(Bone, head, tail, roll, length, tengo_length = True):
                Bone.head = head
                Bone.tail = tail
                Bone.length *= 2
                Bone.head = tail
                Bone.roll = roll
                if tengo_length == True:
                    Bone.length = length
                else:
                    print("no quiero length en el bone")
            #si estoy en Edit Bone
            if Armature and Armature.type == 'ARMATURE':
                Control_Bone = []
                Fk_Controles = []
                DEDOS_CONTROL = []
                Emparentar_Bones_Def = Parent
                Segments = Segments_
                if selected_bones:
                    #def_controles
                    Numero_de_bones = num_selected_bones + 1
                    App_Bones(CONTROL, selected_bones_Name[0], Cuantos = int(Numero_de_bones))
                    Encontrar_Bone(CONTROL, selected_bones_Name[0], Control_Bone, Cuantos = int(Numero_de_bones))
                    for i in range(num_selected_bones):
                        Posicionar_Bones(Control_Bone[i], selected_bones[i].head, 
                                         selected_bones[i].tail, selected_bones[i].roll, 
                                         selected_bones[i].length / 4, tengo_length = True)
                    if Numero_de_bones > 1:
                        pocioner_Bones_tail(Control_Bone[-1], selected_bones[-1].head, 
                                            selected_bones[-1].tail, selected_bones[-1].roll, selected_bones[-1].length / 4, 
                                            tengo_length = True)
                    else:
                        pocioner_Bones_tail(Control_Bone[-1], selected_bones[0].head, 
                                            selected_bones[0].tail, selected_bones[0].roll, selected_bones[0].length / 4, 
                                            tengo_length = True)
                    if Control_Bone:
                        for i in range(Numero_de_bones):
                            Control_Bone[i].use_deform = False
                    #FK Controles:
                    Numero_de_bones = num_selected_bones + 1
                    App_Bones(FK, selected_bones_Name[0], Cuantos = int(Numero_de_bones))
                    Encontrar_Bone(FK, selected_bones_Name[0], Fk_Controles, Cuantos = int(Numero_de_bones))
                    for i in range(num_selected_bones):
                        Posicionar_Bones(Fk_Controles[i], selected_bones[i].head, 
                                         selected_bones[i].tail, selected_bones[i].roll, 
                                         selected_bones[i].length, tengo_length = False)
                    if Numero_de_bones > 1:
                        pocioner_Bones_tail(Fk_Controles[-1], selected_bones[-1].head, 
                                            selected_bones[-1].tail, selected_bones[-1].roll, selected_bones[-1].length / 4, 
                                            tengo_length = False)
                    else:
                        pocioner_Bones_tail(Fk_Controles[-1], selected_bones[0].head, 
                                            selected_bones[0].tail, selected_bones[0].roll, selected_bones[0].length / 4, 
                                            tengo_length = False)
                    if Fk_Controles:
                        for i in range(Numero_de_bones):
                            Fk_Controles[i].use_deform = False
                    if Fk_Controles:
                        for i in range(num_selected_bones):
                            Fk_Controles[i + 1].parent = Fk_Controles[i]
                            if num_selected_bones > 1:
                                if Fk_Controles[i + 1].parent != None:
                                    Fk_Controles[i + 1].use_connect = True
                    if Control_Bone and Fk_Controles:
                        for i in range(num_selected_bones):
                            Control_Bone[i].parent = Fk_Controles[i]
                        Control_Bone[-1].parent = Fk_Controles[-2]
                    if Emparentar_Bones_Def == True:
                        selected_bones[0].parent = Control_Bone[0]
                        selected_bones[0].use_connect = False
                    else:
                        print("Nop")
                    if Segments == True:
                        if num_selected_bones > 1:
                            Fk_Controles[-1].parent = selected_bones[-1]
                            Fk_Controles[-1].use_connect = True
                        else:
                            Fk_Controles[1].parent = selected_bones[0]
                            Fk_Controles[1].use_connect = True
                    else:
                        print("Nop")
                    if DEdo == True:
                        length_Get = 0
                        for i in range(num_selected_bones):
                            length_Get += selected_bones[i].length
                        App_Bones(DEDOS, selected_bones_Name[0], Cuantos = int(2))
                        Encontrar_Bone(DEDOS, selected_bones_Name[0], DEDOS_CONTROL, Cuantos = int(2))
                        Posicionar_Bones(DEDOS_CONTROL[0], selected_bones[0].head, 
                                         selected_bones[0].tail, selected_bones[0].roll, 
                                         selected_bones[0].length / 2, tengo_length = True)
                        Posicionar_Bones(DEDOS_CONTROL[1], selected_bones[0].head, 
                                         selected_bones[0].tail, selected_bones[0].roll, 
                                         length_Get, tengo_length = True)
                        if DEDOS_CONTROL[1]:
                            DEDOS_CONTROL[1].length += (selected_bones[-1].length / 2) 
                        Fk_Controles[0].parent = DEDOS_CONTROL[1]
                        DEDOS_CONTROL[1].parent = DEDOS_CONTROL[0]
                        for i in range(2):
                            DEDOS_CONTROL[i].use_deform = False
                bpy.ops.object.mode_set(mode='POSE')
                Pose_selected_bones = []
                for i in range(num_selected_bones):
                    Control = selected_bones_Name[i]
                    Bones = Armature.pose.bones.get(Control)
                    Pose_selected_bones.append(Bones)
                Pose_Control_Bone = []
                for i in range(num_selected_bones + 1):
                    Bones = selected_bones_Name[0]
                    ultima_letra = Bones[-1].lower()
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = CONTROL + Bones[:-3] + str(i)
                    else:
                        Bone_Name = CONTROL + Bones + "." + str(i)
                    Bones = Armature.pose.bones.get(Bone_Name)
                    Pose_Control_Bone.append(Bones)
                Pose_Fk_Controles = []
                for i in range(num_selected_bones + 1):
                    Bones = selected_bones_Name[0]
                    ultima_letra = Bones[-1].lower()
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = FK + Bones[:-3] + str(i)
                    else:
                        Bone_Name = FK + Bones + "." + str(i)
                    Bones = Armature.pose.bones.get(Bone_Name)
                    Pose_Fk_Controles.append(Bones)
                if DEdo == True:
                    Pose_DEDOS = []
                    for i in range(num_selected_bones + 1):
                        Bones = selected_bones_Name[0]
                        ultima_letra = Bones[-1].lower()
                        Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                        if not Tiene_L_O_R:
                            Bone_Name = DEDOS + Bones[:-3] + str(i)
                        else:
                            Bone_Name = DEDOS + Bones + "." + str(i)
                        Bones = Armature.pose.bones.get(Bone_Name)
                        Pose_DEDOS.append(Bones)
                if  Emparentar_Bones_Def == True:
                    if Pose_selected_bones and Pose_Control_Bone and Pose_Fk_Controles:
                        for i in range(num_selected_bones):
                            constraint = Pose_selected_bones[i].constraints.new(type='COPY_TRANSFORMS')
                            constraint.target = Armature
                            constraint.subtarget = str(Pose_Control_Bone[i].name)
                        for i in range(num_selected_bones):
                            constraint = Pose_selected_bones[i].constraints.new(type='STRETCH_TO')
                            constraint.target = Armature
                            constraint.subtarget = Pose_Control_Bone[i + 1].name
                        if Pose_Fk_Controles[-1]:
                            constraint = Pose_Fk_Controles[-1].constraints.new(type='COPY_TRANSFORMS')
                            constraint.target = Armature
                            constraint.subtarget = Pose_Control_Bone[-1].name
                if Segments == True:
                    for i in range(num_selected_bones):    
                        bpy.data.armatures[Armature.name].bones[Pose_selected_bones[i].name].bbone_segments = 36    
                if Pose_selected_bones and Pose_Control_Bone and Pose_Fk_Controles:
                    if bpy.data.objects["Materiales_RIG_CREATOR.3"] and bpy.data.objects["Materiales_RIG_CREATOR.1"]:
                        for i in range(num_selected_bones + 1):
                            Pose_Control_Bone[i].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.3"]
                            Pose_Control_Bone[i].color.palette = 'THEME09' 
                        for i in range(num_selected_bones):
                            Pose_Fk_Controles[i].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.1"]
                            Pose_Fk_Controles[i].color.palette = 'THEME03' 
                            Pose_Fk_Controles[i].custom_shape_translation[1] = Pose_Fk_Controles[i].length / 2
                if DEdo == True:
                    if Pose_DEDOS:
                        Pose_DEDOS[1].lock_scale[0] = True
                        Pose_DEDOS[1].lock_scale[2] = True
                        Pose_DEDOS[1].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.0"]
                        Pose_DEDOS[1].custom_shape_rotation_euler[0] = -3.141592653589793 / 2
                        Pose_DEDOS[1].custom_shape_scale_xyz[1] = 0 
                        Pose_DEDOS[1].custom_shape_scale_xyz[0] *= 5 
                        Pose_DEDOS[0].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.2"]
                        Pose_DEDOS[1].color.palette = 'THEME04'
                        Pose_DEDOS[0].color.palette = 'THEME01'
                        for i in range(num_selected_bones):
                            constraint = Pose_Fk_Controles[i].constraints.new(type='COPY_SCALE')
                            constraint.target = Armature
                            constraint.subtarget = Pose_DEDOS[0].name
                        if Cuantos_interaciones == 0 or Cuantos_interaciones >= num_selected_bones:
                            for i in range(num_selected_bones):
                                constraint = Pose_Fk_Controles[i].constraints.new(type='TRANSFORM')
                                constraint.target = Armature
                                constraint.subtarget = Pose_DEDOS[1].name
                                constraint.target_space = 'LOCAL'
                                constraint.owner_space = 'LOCAL'
                                constraint.map_from = 'SCALE'
                                constraint.from_min_y_scale = 0.2
                                constraint.from_max_y_scale = 1.8
                                constraint.map_to = 'ROTATION'
                                constraint.map_to_x_from = 'Y'
                                constraint.to_min_x_rot = 3.141592653589793
                                constraint.to_max_x_rot = -3.141592653589793
                        else:
                            for i in range(num_selected_bones -1):
                                constraint = Pose_Fk_Controles[i + Cuantos_interaciones].constraints.new(type='TRANSFORM')
                                constraint.target = Armature
                                constraint.subtarget = Pose_DEDOS[1].name
                                constraint.target_space = 'LOCAL'
                                constraint.owner_space = 'LOCAL'
                                constraint.map_from = 'SCALE'
                                constraint.from_min_y_scale = 0.2
                                constraint.from_max_y_scale = 1.8
                                constraint.map_to = 'ROTATION'
                                constraint.map_to_x_from = 'Y'
                                constraint.to_min_x_rot = 3.141592653589793
                                constraint.to_max_x_rot = -3.141592653589793
                        if Ultimo == False:
                            constraint_to_remove = None
                            for constraint in Pose_Fk_Controles[-1].constraints:
                                if constraint.type == 'TRANSFORM':
                                    constraint_to_remove = constraint
                            if constraint_to_remove:
                                Pose_Fk_Controles[-1].constraints.remove(constraint_to_remove)
                        else:
                            if Segments == True:
                                constraint_to_remove = None
                                for constraint in Pose_Fk_Controles[-1].constraints:
                                    if constraint.type == 'TRANSFORM':
                                        constraint_to_remove = constraint
                                if constraint_to_remove:
                                    Pose_Fk_Controles[-1].constraints.remove(constraint_to_remove)
                                constraint = Pose_Fk_Controles[-1].constraints.new(type='TRANSFORM')
                                constraint.target = Armature
                                constraint.subtarget = Pose_DEDOS[1].name
                                constraint.target_space = 'LOCAL'
                                constraint.owner_space = 'LOCAL'
                                constraint.map_from = 'SCALE'
                                constraint.from_min_y_scale = 0.2
                                constraint.from_max_y_scale = 1.8
                                constraint.map_to = 'ROTATION'
                                constraint.map_to_x_from = 'Y'
                                constraint.to_min_x_rot = 3.141592653589793
                                constraint.to_max_x_rot = -3.141592653589793
                                constraint.influence = 0.5
                            else:
                                pass
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_PT_RIG_CREATOR_B0A49(bpy.types.Panel):
    bl_label = 'RIG CREATOR'
    bl_idname = 'SNA_PT_RIG_CREATOR_B0A49'
    bl_space_type = 'PROPERTIES'
    bl_region_type = 'WINDOW'
    bl_context = 'data'
    bl_category = 'RIG CREATOR'
    bl_order = 0
    bl_options = {'DEFAULT_CLOSED'}
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        box_BA5C4 = layout.box()
        box_BA5C4.alert = False
        box_BA5C4.enabled = True
        box_BA5C4.active = True
        box_BA5C4.use_property_split = False
        box_BA5C4.use_property_decorate = False
        box_BA5C4.alignment = 'Expand'.upper()
        box_BA5C4.scale_x = 1.0
        box_BA5C4.scale_y = 1.0
        if not True: box_BA5C4.operator_context = "EXEC_DEFAULT"
        layout_function = box_BA5C4
        sna_function_interface_E8A7B(layout_function, )
        if bpy.context.active_pose_bone:
            grid_E6E19 = layout.grid_flow(columns=-500, row_major=False, even_columns=False, even_rows=False, align=False)
            grid_E6E19.enabled = True
            grid_E6E19.active = True
            grid_E6E19.use_property_split = False
            grid_E6E19.use_property_decorate = False
            grid_E6E19.alignment = 'Expand'.upper()
            grid_E6E19.scale_x = 1.0
            grid_E6E19.scale_y = 1.0
            if not True: grid_E6E19.operator_context = "EXEC_DEFAULT"
            grid_E6E19.separator(factor=1.0)
            box_2A4A0 = grid_E6E19.box()
            box_2A4A0.alert = False
            box_2A4A0.enabled = True
            box_2A4A0.active = True
            box_2A4A0.use_property_split = False
            box_2A4A0.use_property_decorate = False
            box_2A4A0.alignment = 'Expand'.upper()
            box_2A4A0.scale_x = 1.0
            box_2A4A0.scale_y = 1.0
            if not True: box_2A4A0.operator_context = "EXEC_DEFAULT"
            layout_function = box_2A4A0
            sna_paneles_3F663(layout_function, )
            grid_E6E19.separator(factor=1.0)
            box_936D2 = grid_E6E19.box()
            box_936D2.alert = False
            box_936D2.enabled = True
            box_936D2.active = True
            box_936D2.use_property_split = False
            box_936D2.use_property_decorate = False
            box_936D2.alignment = 'Expand'.upper()
            box_936D2.scale_x = 1.0
            box_936D2.scale_y = 1.0
            if not True: box_936D2.operator_context = "EXEC_DEFAULT"
            layout_function = box_936D2
            sna_paneles_25E10(layout_function, )
            grid_E6E19.separator(factor=1.0)
            box_7A3B9 = grid_E6E19.box()
            box_7A3B9.alert = False
            box_7A3B9.enabled = True
            box_7A3B9.active = True
            box_7A3B9.use_property_split = False
            box_7A3B9.use_property_decorate = False
            box_7A3B9.alignment = 'Expand'.upper()
            box_7A3B9.scale_x = 1.0
            box_7A3B9.scale_y = 1.0
            if not True: box_7A3B9.operator_context = "EXEC_DEFAULT"
            layout_function = box_7A3B9
            sna_paneles_F912C(layout_function, )
            grid_E6E19.separator(factor=1.0)
            box_FAA77 = grid_E6E19.box()
            box_FAA77.alert = False
            box_FAA77.enabled = True
            box_FAA77.active = True
            box_FAA77.use_property_split = False
            box_FAA77.use_property_decorate = False
            box_FAA77.alignment = 'Expand'.upper()
            box_FAA77.scale_x = 1.0
            box_FAA77.scale_y = 1.0
            if not True: box_FAA77.operator_context = "EXEC_DEFAULT"
            layout_function = box_FAA77
            sna_function_interface_4B3D0(layout_function, )
            grid_E6E19.separator(factor=1.0)
            box_09C9F = grid_E6E19.box()
            box_09C9F.alert = False
            box_09C9F.enabled = True
            box_09C9F.active = True
            box_09C9F.use_property_split = False
            box_09C9F.use_property_decorate = False
            box_09C9F.alignment = 'Expand'.upper()
            box_09C9F.scale_x = 1.0
            box_09C9F.scale_y = 1.0
            if not True: box_09C9F.operator_context = "EXEC_DEFAULT"
            layout_function = box_09C9F
            sna_paneles_8FEB4(layout_function, )


class SNA_OT_Operator_5Eecc(bpy.types.Operator):
    bl_idname = "sna.operator_5eecc"
    bl_label = "Operator"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        if property_exists("bpy.data.collections['RIG_CREATOR_Material']", globals(), locals()):
            Parent = bpy.context.scene.sna_parent_only_control
            Segments_ = bpy.context.scene.sna_segments_only_control
            CONTROL_ = bpy.context.scene.sna_control_only
            DUplicar = bpy.context.scene.sna_duplicar_only_control
            Sin_SElect = bpy.context.scene.sna_sin_select
            Armature = bpy.context.active_object
            bpy.ops.object.mode_set(mode='EDIT')
            selected_bones = [bone for bone in bpy.context.selected_editable_bones]
            selected_bones_Name = [bone.name for bone in bpy.context.selected_editable_bones]
            num_selected_bones = len(selected_bones)
            CONTROL = CONTROL_
            Sub_CONTROL = "Sub_" + CONTROL
            Dup_CONTROL = "DUP_" + CONTROL
            SIN_Selected = "Def_" + CONTROL

            def App_Bones(Control, Bones, Cuantos = int(0)):
                for i in range(Cuantos):
                    ultima_letra = Bones[-1].lower()  
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = Control + Bones[:-3] + str(i)
                    else:
                        Bone_Name = Control + Bones + "." + str(i)
                    bpy.ops.armature.bone_primitive_add(name=Bone_Name)

            def Encontrar_Bone(Control, Bones, Varible = [], Cuantos = int(0)):
                for i in range(Cuantos):
                    ultima_letra = Bones[-1].lower()  
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = Control + Bones[:-3] + str(i)
                    else:
                        Bone_Name = Control + Bones + "." + str(i)
                    Varible.append(Armature.data.edit_bones.get(Bone_Name))

            def Posicionar_Bones(Bone, head, tail, roll, length, tengo_length = True):
                Bone.head = head
                Bone.tail = tail
                Bone.roll = roll
                if tengo_length == True:
                    Bone.length = length
                else:
                    print("no quiero length en el bone")

            def pocioner_Bones_tail(Bone, head, tail, roll, length, tengo_length = True):
                Bone.head = head
                Bone.tail = tail
                Bone.length *= 2
                Bone.head = tail
                Bone.roll = roll
                if tengo_length == True:
                    Bone.length = length
                else:
                    print("no quiero length en el bone")
            #si estoy en Edit Bone
            if Armature and Armature.type == 'ARMATURE':
                Control_Bone = []
                sub_Control_Bone = []
                Dup_Control_Bone = []
                SIN_Selected_Bone = []
                Emparentar_Bones_Def = Parent
                Segments = Segments_
                Dup = DUplicar
                Sin_SELECT = Sin_SElect
                if selected_bones:
                    #def_controles
                    Numero_de_bones = num_selected_bones + 1
                    App_Bones(CONTROL, selected_bones_Name[0], Cuantos = int(Numero_de_bones))
                    Encontrar_Bone(CONTROL, selected_bones_Name[0], Control_Bone, Cuantos = int(Numero_de_bones))
                    for i in range(num_selected_bones):
                        Posicionar_Bones(Control_Bone[i], selected_bones[i].head, 
                                         selected_bones[i].tail, selected_bones[i].roll, 
                                         selected_bones[i].length / 4, tengo_length = True)
                    if Numero_de_bones > 1:
                        pocioner_Bones_tail(Control_Bone[-1], selected_bones[-1].head, 
                                            selected_bones[-1].tail, selected_bones[-1].roll, selected_bones[-1].length / 4, 
                                            tengo_length = True)
                    else:
                        pocioner_Bones_tail(Control_Bone[-1], selected_bones[0].head, 
                                            selected_bones[0].tail, selected_bones[0].roll, selected_bones[0].length / 4, 
                                            tengo_length = True)
                    #sub_control  
                    App_Bones(Sub_CONTROL, selected_bones_Name[0], Cuantos = int(1))
                    Encontrar_Bone(Sub_CONTROL, selected_bones_Name[0], sub_Control_Bone, Cuantos = int(1))
                    if Numero_de_bones > 1:
                        pocioner_Bones_tail(sub_Control_Bone[0], selected_bones[-1].head, 
                                            selected_bones[-1].tail, selected_bones[-1].roll, selected_bones[-1].length, 
                                            tengo_length = True)
                    else:
                        pocioner_Bones_tail(sub_Control_Bone[0], selected_bones[0].head, 
                                            selected_bones[0].tail, selected_bones[0].roll, selected_bones[0].length, 
                                            tengo_length = True)
                    #Dup
                    if Dup == True:
                        App_Bones(Dup_CONTROL, selected_bones_Name[0], Cuantos = int(Numero_de_bones))
                        Encontrar_Bone(Dup_CONTROL, selected_bones_Name[0], Dup_Control_Bone, Cuantos = int(Numero_de_bones))
                        for i in range(num_selected_bones):
                            Posicionar_Bones(Dup_Control_Bone[i], selected_bones[i].head, 
                                             selected_bones[i].tail, selected_bones[i].roll, 
                                             selected_bones[i].length / 4, tengo_length = True)
                        if Numero_de_bones > 1:
                            pocioner_Bones_tail(Dup_Control_Bone[-1], selected_bones[-1].head, 
                                                selected_bones[-1].tail, selected_bones[-1].roll, selected_bones[-1].length / 4, 
                                                tengo_length = True)
                        else:
                            pocioner_Bones_tail(Dup_Control_Bone[-1], selected_bones[0].head, 
                                                selected_bones[0].tail, selected_bones[0].roll, selected_bones[0].length / 4, 
                                                tengo_length = True)
                    #sin_select_bone
                    if Sin_SELECT == True:
                        App_Bones(SIN_Selected, selected_bones_Name[0], Cuantos = int(num_selected_bones))
                        Encontrar_Bone(SIN_Selected, selected_bones_Name[0], SIN_Selected_Bone, Cuantos = int(num_selected_bones))
                        for i in range(num_selected_bones):
                            Posicionar_Bones(SIN_Selected_Bone[i], selected_bones[i].head, 
                                             selected_bones[i].tail, selected_bones[i].roll, 
                                             selected_bones[i].length, tengo_length = True)
                        for i in range(num_selected_bones):
                            SIN_Selected_Bone[i].use_deform = False
                        if Segments == True:
                            for i in range(num_selected_bones - 1):
                                    SIN_Selected_Bone[i + 1].parent = SIN_Selected_Bone[i]
                                    SIN_Selected_Bone[i + 1].use_connect = True
                                    SIN_Selected_Bone[0].use_connect = False
                            SIN_Selected_Bone[0].parent = Control_Bone[0]
                        else:
                            for i in range(num_selected_bones):
                                SIN_Selected_Bone[i].parent = Control_Bone[i]
                    if Dup_Control_Bone:
                            for i in range(Numero_de_bones):
                                Dup_Control_Bone[i].use_deform = False
                            for i in range(Numero_de_bones):
                                Control_Bone[i].parent = Dup_Control_Bone[i]
                    if Control_Bone:
                        for i in range(Numero_de_bones):
                            Control_Bone[i].use_deform = False
                    if Emparentar_Bones_Def == True:
                        if Sin_SELECT == False:
                            selected_bones[0].parent = Control_Bone[0]
                            selected_bones[0].use_connect = False
                    else:
                        print("Nop")
                    if sub_Control_Bone:
                        sub_Control_Bone[0].use_deform = False
                        if Sin_SELECT == True:
                            if Segments == True:
                                sub_Control_Bone[0].parent = SIN_Selected_Bone[-1]
                                sub_Control_Bone[0].use_connect = True
                        else:
                             if Segments == True:
                                sub_Control_Bone[0].parent = selected_bones[-1]
                                sub_Control_Bone[0].use_connect = True
                #pose mode
                bpy.ops.object.mode_set(mode='POSE')
                Pose_selected_bones = []
                for i in range(num_selected_bones):
                    Control = selected_bones_Name[i]
                    Bones = Armature.pose.bones.get(Control)
                    Pose_selected_bones.append(Bones)
                Pose_Control_Bone = []
                for i in range(num_selected_bones + 1):
                    Bones = selected_bones_Name[0]
                    ultima_letra = Bones[-1].lower()
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = CONTROL + Bones[:-3] + str(i)
                    else:
                        Bone_Name = CONTROL + Bones + "." + str(i)
                    Bones = Armature.pose.bones.get(Bone_Name)
                    Pose_Control_Bone.append(Bones)
                Pose_sub_Control_Bone = []
                for i in range(num_selected_bones + 1):
                    Bones = selected_bones_Name[0]
                    ultima_letra = Bones[-1].lower()
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = Sub_CONTROL + Bones[:-3] + str(i)
                    else:
                        Bone_Name = Sub_CONTROL + Bones + "." + str(i)
                    Bones = Armature.pose.bones.get(Bone_Name)
                    Pose_sub_Control_Bone.append(Bones)
                pose_SIN_Selected_Bone = []
                for i in range(num_selected_bones):
                    Bones = selected_bones_Name[0]
                    ultima_letra = Bones[-1].lower()
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = SIN_Selected + Bones[:-3] + str(i)
                    else:
                        Bone_Name = SIN_Selected + Bones + "." + str(i)
                    Bones = Armature.pose.bones.get(Bone_Name)
                    pose_SIN_Selected_Bone.append(Bones)
                if  Emparentar_Bones_Def == True:
                    if Pose_selected_bones and Pose_Control_Bone:
                        if Sin_SELECT == True:
                            for i in range(num_selected_bones):
                                constraint = pose_SIN_Selected_Bone[i].constraints.new(type='COPY_TRANSFORMS')
                                constraint.target = Armature
                                constraint.subtarget = Pose_Control_Bone[i].name
                            for i in range(num_selected_bones):
                                constraint = pose_SIN_Selected_Bone[i].constraints.new(type='STRETCH_TO')
                                constraint.target = Armature
                                constraint.subtarget = Pose_Control_Bone[i + 1].name
                        else:
                            for i in range(num_selected_bones):
                                constraint = Pose_selected_bones[i].constraints.new(type='COPY_TRANSFORMS')
                                constraint.target = Armature
                                constraint.subtarget = Pose_Control_Bone[i].name
                            for i in range(num_selected_bones):
                                constraint = Pose_selected_bones[i].constraints.new(type='STRETCH_TO')
                                constraint.target = Armature
                                constraint.subtarget = Pose_Control_Bone[i + 1].name
                        if Pose_sub_Control_Bone:
                           constraint = Pose_sub_Control_Bone[0].constraints.new(type='COPY_TRANSFORMS')
                           constraint.target = Armature
                           constraint.subtarget = Pose_Control_Bone[-1].name
                if Segments == True:
                    for i in range(num_selected_bones):
                        if Sin_SELECT == True:
                            bpy.data.armatures[Armature.name].bones[pose_SIN_Selected_Bone[i].name].bbone_segments = 36
                        else:   
                            bpy.data.armatures[Armature.name].bones[Pose_selected_bones[i].name].bbone_segments = 36    
                if Pose_selected_bones and Pose_Control_Bone:
                    if bpy.data.objects["Materiales_RIG_CREATOR.3"] and bpy.data.objects["Materiales_RIG_CREATOR.3"]:
                        for i in range(num_selected_bones + 1):
                            if Segments == False:
                                Pose_Control_Bone[i].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.2"]
                                Pose_Control_Bone[i].color.palette = 'THEME04'
                            else:
                                Pose_Control_Bone[i].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.3"]
                                Pose_Control_Bone[i].color.palette = 'THEME09'
        else:
            nombre_coleccion = "RIG_CREATOR_Material"
            nueva_coleccion = bpy.data.collections.new(nombre_coleccion)
            bpy.context.scene.collection.children.link(nueva_coleccion)
            colección_op = bpy.data.collections.get(nombre_coleccion)
            if colección_op:
                for i in range(4):
                    nombre_empty = "Materiales_RIG_CREATOR" + "." + str(i)
                    # Crear un nuevo objeto Empty
                    empty = bpy.data.objects.new(nombre_empty, None)
                    # Asignar tipo personalizado a Empty
                    if i == 0:
                        empty.empty_display_type = 'SINGLE_ARROW'
                    elif i == 1:
                        empty.empty_display_type = 'CIRCLE'
                    elif i == 2:
                        empty.empty_display_type = 'CUBE'
                    elif i == 3:
                        empty.empty_display_type = 'SPHERE'
                    # Añadir el Empty a la colección
                    colección_op.objects.link(empty)
            bpy.data.collections[nombre_coleccion].hide_viewport = False
            bpy.data.collections[nombre_coleccion].hide_render = False
            Parent = bpy.context.scene.sna_parent_only_control
            Segments_ = bpy.context.scene.sna_segments_only_control
            CONTROL_ = bpy.context.scene.sna_control_only
            DUplicar = bpy.context.scene.sna_duplicar_only_control
            Sin_SElect = bpy.context.scene.sna_sin_select
            Armature = bpy.context.active_object
            bpy.ops.object.mode_set(mode='EDIT')
            selected_bones = [bone for bone in bpy.context.selected_editable_bones]
            selected_bones_Name = [bone.name for bone in bpy.context.selected_editable_bones]
            num_selected_bones = len(selected_bones)
            CONTROL = CONTROL_
            Sub_CONTROL = "Sub_" + CONTROL
            Dup_CONTROL = "DUP_" + CONTROL
            SIN_Selected = "Def_" + CONTROL

            def App_Bones(Control, Bones, Cuantos = int(0)):
                for i in range(Cuantos):
                    ultima_letra = Bones[-1].lower()  
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = Control + Bones[:-3] + str(i)
                    else:
                        Bone_Name = Control + Bones + "." + str(i)
                    bpy.ops.armature.bone_primitive_add(name=Bone_Name)

            def Encontrar_Bone(Control, Bones, Varible = [], Cuantos = int(0)):
                for i in range(Cuantos):
                    ultima_letra = Bones[-1].lower()  
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = Control + Bones[:-3] + str(i)
                    else:
                        Bone_Name = Control + Bones + "." + str(i)
                    Varible.append(Armature.data.edit_bones.get(Bone_Name))

            def Posicionar_Bones(Bone, head, tail, roll, length, tengo_length = True):
                Bone.head = head
                Bone.tail = tail
                Bone.roll = roll
                if tengo_length == True:
                    Bone.length = length
                else:
                    print("no quiero length en el bone")

            def pocioner_Bones_tail(Bone, head, tail, roll, length, tengo_length = True):
                Bone.head = head
                Bone.tail = tail
                Bone.length *= 2
                Bone.head = tail
                Bone.roll = roll
                if tengo_length == True:
                    Bone.length = length
                else:
                    print("no quiero length en el bone")
            #si estoy en Edit Bone
            if Armature and Armature.type == 'ARMATURE':
                Control_Bone = []
                sub_Control_Bone = []
                Dup_Control_Bone = []
                SIN_Selected_Bone = []
                Emparentar_Bones_Def = Parent
                Segments = Segments_
                Dup = DUplicar
                Sin_SELECT = Sin_SElect
                if selected_bones:
                    #def_controles
                    Numero_de_bones = num_selected_bones + 1
                    App_Bones(CONTROL, selected_bones_Name[0], Cuantos = int(Numero_de_bones))
                    Encontrar_Bone(CONTROL, selected_bones_Name[0], Control_Bone, Cuantos = int(Numero_de_bones))
                    for i in range(num_selected_bones):
                        Posicionar_Bones(Control_Bone[i], selected_bones[i].head, 
                                         selected_bones[i].tail, selected_bones[i].roll, 
                                         selected_bones[i].length / 4, tengo_length = True)
                    if Numero_de_bones > 1:
                        pocioner_Bones_tail(Control_Bone[-1], selected_bones[-1].head, 
                                            selected_bones[-1].tail, selected_bones[-1].roll, selected_bones[-1].length / 4, 
                                            tengo_length = True)
                    else:
                        pocioner_Bones_tail(Control_Bone[-1], selected_bones[0].head, 
                                            selected_bones[0].tail, selected_bones[0].roll, selected_bones[0].length / 4, 
                                            tengo_length = True)
                    #sub_control  
                    App_Bones(Sub_CONTROL, selected_bones_Name[0], Cuantos = int(1))
                    Encontrar_Bone(Sub_CONTROL, selected_bones_Name[0], sub_Control_Bone, Cuantos = int(1))
                    if Numero_de_bones > 1:
                        pocioner_Bones_tail(sub_Control_Bone[0], selected_bones[-1].head, 
                                            selected_bones[-1].tail, selected_bones[-1].roll, selected_bones[-1].length, 
                                            tengo_length = True)
                    else:
                        pocioner_Bones_tail(sub_Control_Bone[0], selected_bones[0].head, 
                                            selected_bones[0].tail, selected_bones[0].roll, selected_bones[0].length, 
                                            tengo_length = True)
                    #Dup
                    if Dup == True:
                        App_Bones(Dup_CONTROL, selected_bones_Name[0], Cuantos = int(Numero_de_bones))
                        Encontrar_Bone(Dup_CONTROL, selected_bones_Name[0], Dup_Control_Bone, Cuantos = int(Numero_de_bones))
                        for i in range(num_selected_bones):
                            Posicionar_Bones(Dup_Control_Bone[i], selected_bones[i].head, 
                                             selected_bones[i].tail, selected_bones[i].roll, 
                                             selected_bones[i].length / 4, tengo_length = True)
                        if Numero_de_bones > 1:
                            pocioner_Bones_tail(Dup_Control_Bone[-1], selected_bones[-1].head, 
                                                selected_bones[-1].tail, selected_bones[-1].roll, selected_bones[-1].length / 4, 
                                                tengo_length = True)
                        else:
                            pocioner_Bones_tail(Dup_Control_Bone[-1], selected_bones[0].head, 
                                                selected_bones[0].tail, selected_bones[0].roll, selected_bones[0].length / 4, 
                                                tengo_length = True)
                    #sin_select_bone
                    if Sin_SELECT == True:
                        App_Bones(SIN_Selected, selected_bones_Name[0], Cuantos = int(num_selected_bones))
                        Encontrar_Bone(SIN_Selected, selected_bones_Name[0], SIN_Selected_Bone, Cuantos = int(num_selected_bones))
                        for i in range(num_selected_bones):
                            Posicionar_Bones(SIN_Selected_Bone[i], selected_bones[i].head, 
                                             selected_bones[i].tail, selected_bones[i].roll, 
                                             selected_bones[i].length, tengo_length = True)
                        for i in range(num_selected_bones):
                            SIN_Selected_Bone[i].use_deform = False
                        if Segments == True:
                            for i in range(num_selected_bones - 1):
                                    SIN_Selected_Bone[i + 1].parent = SIN_Selected_Bone[i]
                                    SIN_Selected_Bone[i + 1].use_connect = True
                                    SIN_Selected_Bone[0].use_connect = False
                            SIN_Selected_Bone[0].parent = Control_Bone[0]
                        else:
                            for i in range(num_selected_bones):
                                SIN_Selected_Bone[i].parent = Control_Bone[i]
                    if Dup_Control_Bone:
                            for i in range(Numero_de_bones):
                                Dup_Control_Bone[i].use_deform = False
                            for i in range(Numero_de_bones):
                                Control_Bone[i].parent = Dup_Control_Bone[i]
                    if Control_Bone:
                        for i in range(Numero_de_bones):
                            Control_Bone[i].use_deform = False
                    if Emparentar_Bones_Def == True:
                        if Sin_SELECT == False:
                            selected_bones[0].parent = Control_Bone[0]
                            selected_bones[0].use_connect = False
                    else:
                        print("Nop")
                    if sub_Control_Bone:
                        sub_Control_Bone[0].use_deform = False
                        if Sin_SELECT == True:
                            if Segments == True:
                                sub_Control_Bone[0].parent = SIN_Selected_Bone[-1]
                                sub_Control_Bone[0].use_connect = True
                        else:
                             if Segments == True:
                                sub_Control_Bone[0].parent = selected_bones[-1]
                                sub_Control_Bone[0].use_connect = True
                #pose mode
                bpy.ops.object.mode_set(mode='POSE')
                Pose_selected_bones = []
                for i in range(num_selected_bones):
                    Control = selected_bones_Name[i]
                    Bones = Armature.pose.bones.get(Control)
                    Pose_selected_bones.append(Bones)
                Pose_Control_Bone = []
                for i in range(num_selected_bones + 1):
                    Bones = selected_bones_Name[0]
                    ultima_letra = Bones[-1].lower()
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = CONTROL + Bones[:-3] + str(i)
                    else:
                        Bone_Name = CONTROL + Bones + "." + str(i)
                    Bones = Armature.pose.bones.get(Bone_Name)
                    Pose_Control_Bone.append(Bones)
                Pose_sub_Control_Bone = []
                for i in range(num_selected_bones + 1):
                    Bones = selected_bones_Name[0]
                    ultima_letra = Bones[-1].lower()
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = Sub_CONTROL + Bones[:-3] + str(i)
                    else:
                        Bone_Name = Sub_CONTROL + Bones + "." + str(i)
                    Bones = Armature.pose.bones.get(Bone_Name)
                    Pose_sub_Control_Bone.append(Bones)
                pose_SIN_Selected_Bone = []
                for i in range(num_selected_bones):
                    Bones = selected_bones_Name[0]
                    ultima_letra = Bones[-1].lower()
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = SIN_Selected + Bones[:-3] + str(i)
                    else:
                        Bone_Name = SIN_Selected + Bones + "." + str(i)
                    Bones = Armature.pose.bones.get(Bone_Name)
                    pose_SIN_Selected_Bone.append(Bones)
                if  Emparentar_Bones_Def == True:
                    if Pose_selected_bones and Pose_Control_Bone:
                        if Sin_SELECT == True:
                            for i in range(num_selected_bones):
                                constraint = pose_SIN_Selected_Bone[i].constraints.new(type='COPY_TRANSFORMS')
                                constraint.target = Armature
                                constraint.subtarget = Pose_Control_Bone[i].name
                            for i in range(num_selected_bones):
                                constraint = pose_SIN_Selected_Bone[i].constraints.new(type='STRETCH_TO')
                                constraint.target = Armature
                                constraint.subtarget = Pose_Control_Bone[i + 1].name
                        else:
                            for i in range(num_selected_bones):
                                constraint = Pose_selected_bones[i].constraints.new(type='COPY_TRANSFORMS')
                                constraint.target = Armature
                                constraint.subtarget = Pose_Control_Bone[i].name
                            for i in range(num_selected_bones):
                                constraint = Pose_selected_bones[i].constraints.new(type='STRETCH_TO')
                                constraint.target = Armature
                                constraint.subtarget = Pose_Control_Bone[i + 1].name
                        if Pose_sub_Control_Bone:
                           constraint = Pose_sub_Control_Bone[0].constraints.new(type='COPY_TRANSFORMS')
                           constraint.target = Armature
                           constraint.subtarget = Pose_Control_Bone[-1].name
                if Segments == True:
                    for i in range(num_selected_bones):
                        if Sin_SELECT == True:
                            bpy.data.armatures[Armature.name].bones[pose_SIN_Selected_Bone[i].name].bbone_segments = 36
                        else:   
                            bpy.data.armatures[Armature.name].bones[Pose_selected_bones[i].name].bbone_segments = 36    
                if Pose_selected_bones and Pose_Control_Bone:
                    if bpy.data.objects["Materiales_RIG_CREATOR.3"] and bpy.data.objects["Materiales_RIG_CREATOR.3"]:
                        for i in range(num_selected_bones + 1):
                            if Segments == False:
                                Pose_Control_Bone[i].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.2"]
                                Pose_Control_Bone[i].color.palette = 'THEME04'
                            else:
                                Pose_Control_Bone[i].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.3"]
                                Pose_Control_Bone[i].color.palette = 'THEME09'
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def sna_paneles_25E10(layout_function, ):
    row_A6F70 = layout_function.row(heading='', align=False)
    row_A6F70.alert = False
    row_A6F70.enabled = True
    row_A6F70.active = True
    row_A6F70.use_property_split = False
    row_A6F70.use_property_decorate = False
    row_A6F70.scale_x = 1.0
    row_A6F70.scale_y = 1.0
    row_A6F70.alignment = 'Left'.upper()
    row_A6F70.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_A6F70.prop(bpy.context.scene, 'sna_ver_def', text='Generator CONTROL DEF', icon_value=(46 if bpy.context.scene.sna_ver_def else 45), emboss=False)
    if bpy.context.scene.sna_ver_def:
        grid_ADD56 = layout_function.grid_flow(columns=-673, row_major=False, even_columns=False, even_rows=False, align=False)
        grid_ADD56.enabled = True
        grid_ADD56.active = True
        grid_ADD56.use_property_split = False
        grid_ADD56.use_property_decorate = False
        grid_ADD56.alignment = 'Expand'.upper()
        grid_ADD56.scale_x = 1.0
        grid_ADD56.scale_y = 1.2000000476837158
        if not True: grid_ADD56.operator_context = "EXEC_DEFAULT"
        grid_7B9E8 = grid_ADD56.grid_flow(columns=3, row_major=False, even_columns=False, even_rows=False, align=True)
        grid_7B9E8.enabled = True
        grid_7B9E8.active = True
        grid_7B9E8.use_property_split = False
        grid_7B9E8.use_property_decorate = False
        grid_7B9E8.alignment = 'Expand'.upper()
        grid_7B9E8.scale_x = 1.0
        grid_7B9E8.scale_y = 1.0
        if not True: grid_7B9E8.operator_context = "EXEC_DEFAULT"
        grid_7B9E8.prop(bpy.context.scene, 'sna_parent_only_control', text='Parent_DEF', icon_value=691, emboss=True, toggle=True)
        grid_7B9E8.prop(bpy.context.scene, 'sna_segments_only_control', text='Segments', icon_value=454, emboss=True, toggle=True)
        grid_7B9E8.prop(bpy.context.scene, 'sna_duplicar_only_control', text='', icon_value=598, emboss=True, toggle=True)
        grid_ADD56.prop(bpy.context.scene, 'sna_sin_select', text='NOT TOUCH SELECTION', icon_value=463, emboss=True, toggle=True)
        op = grid_ADD56.operator('sna.operator_5eecc', text='Generator CONTROL DEF', icon_value=495, emboss=True, depress=False)
        grid_ADD56.prop(bpy.context.scene, 'sna_control_only', text='CONTROL_', icon_value=174, emboss=True, toggle=True)


class SNA_OT_Operator_01Bc7(bpy.types.Operator):
    bl_idname = "sna.operator_01bc7"
    bl_label = "Operator"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        if property_exists("bpy.data.collections['RIG_CREATOR_Material']", globals(), locals()):
            FK_ = bpy.context.scene.sna_fk
            VIEW_OBJECT = bpy.context.scene.sna_view_object
            Copy_Transforms_FK = bpy.context.scene.sna_copy_transforms_fk
            Armature = bpy.context.active_object
            bpy.ops.object.mode_set(mode='EDIT')
            selected_bones = [bone for bone in bpy.context.selected_editable_bones]
            selected_bones_Name = [bone.name for bone in bpy.context.selected_editable_bones]
            num_selected_bones = len(selected_bones)
            FK = FK_

            def App_Bones(Control, Bones, Cuantos = int(0)):
                for i in range(Cuantos):
                    ultima_letra = Bones[-1].lower()  
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = Control + Bones[:-3] + str(i)
                    else:
                        Bone_Name = Control + Bones + "." + str(i)
                    bpy.ops.armature.bone_primitive_add(name=Bone_Name)

            def Encontrar_Bone(Control, Bones, Varible = [], Cuantos = int(0)):
                for i in range(Cuantos):
                    ultima_letra = Bones[-1].lower()  
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = Control + Bones[:-3] + str(i)
                    else:
                        Bone_Name = Control + Bones + "." + str(i)
                    Varible.append(Armature.data.edit_bones.get(Bone_Name))

            def Posicionar_Bones(Bone, head, tail, roll, length, tengo_length = True):
                Bone.head = head
                Bone.tail = tail
                Bone.roll = roll
                if tengo_length == True:
                    Bone.length = length
                else:
                    print("no quiero length en el bone")

            def pocioner_Bones_tail(Bone, head, tail, roll, length, tengo_length = True):
                Bone.head = head
                Bone.tail = tail
                Bone.length *= 2
                Bone.head = tail
                Bone.roll = roll
                if tengo_length == True:
                    Bone.length = length
                else:
                    print("no quiero length en el bone")
            #si estoy en Edit Bone
            if Armature and Armature.type == 'ARMATURE':
                Fk_Controles = []
                if selected_bones:
                    #FK Controles:
                    Numero_de_bones = num_selected_bones + 1
                    App_Bones(FK, selected_bones_Name[0], Cuantos = int(num_selected_bones))
                    Encontrar_Bone(FK, selected_bones_Name[0], Fk_Controles, Cuantos = int(num_selected_bones))
                    for i in range(num_selected_bones):
                        Posicionar_Bones(Fk_Controles[i], selected_bones[i].head, 
                                         selected_bones[i].tail, selected_bones[i].roll, 
                                         selected_bones[i].length, tengo_length = False)
                    if Fk_Controles:
                        for i in range(num_selected_bones):
                            Fk_Controles[i].use_deform = False
                    if Fk_Controles:
                        for i in range(num_selected_bones -1):
                            Fk_Controles[i + 1].parent = Fk_Controles[i]
                            Fk_Controles[i + 1].use_connect = True
                bpy.ops.object.mode_set(mode='POSE')
                Pose_selected_bones = []
                for i in range(num_selected_bones):
                    Control = selected_bones_Name[i]
                    Bones = Armature.pose.bones.get(Control)
                    Pose_selected_bones.append(Bones)
                Pose_Fk_Controles = []
                for i in range(num_selected_bones + 1):
                    Bones = selected_bones_Name[0]
                    ultima_letra = Bones[-1].lower()
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = FK + Bones[:-3] + str(i)
                    else:
                        Bone_Name = FK + Bones + "." + str(i)
                    Bones = Armature.pose.bones.get(Bone_Name)
                    Pose_Fk_Controles.append(Bones)
                if Pose_selected_bones and Pose_Fk_Controles:
                    if Copy_Transforms_FK == True:
                        for i in range(num_selected_bones):
                                    constraint = Pose_selected_bones[i].constraints.new(type='COPY_TRANSFORMS')
                                    constraint.target = Armature
                                    constraint.subtarget = Pose_Fk_Controles[i].name
                    if bpy.data.objects["Materiales_RIG_CREATOR.3"] and bpy.data.objects["Materiales_RIG_CREATOR.1"]:
                        for i in range(num_selected_bones):
                            if VIEW_OBJECT == True:
                                Pose_Fk_Controles[i].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.1"]
                                Pose_Fk_Controles[i].custom_shape_translation[1] = Pose_Fk_Controles[i].length / 2
                                Pose_Fk_Controles[i].color.palette = 'THEME03'
        else:
            nombre_coleccion = "RIG_CREATOR_Material"
            nueva_coleccion = bpy.data.collections.new(nombre_coleccion)
            bpy.context.scene.collection.children.link(nueva_coleccion)
            colección_op = bpy.data.collections.get(nombre_coleccion)
            if colección_op:
                for i in range(4):
                    nombre_empty = "Materiales_RIG_CREATOR" + "." + str(i)
                    # Crear un nuevo objeto Empty
                    empty = bpy.data.objects.new(nombre_empty, None)
                    # Asignar tipo personalizado a Empty
                    if i == 0:
                        empty.empty_display_type = 'SINGLE_ARROW'
                    elif i == 1:
                        empty.empty_display_type = 'CIRCLE'
                    elif i == 2:
                        empty.empty_display_type = 'CUBE'
                    elif i == 3:
                        empty.empty_display_type = 'SPHERE'
                    # Añadir el Empty a la colección
                    colección_op.objects.link(empty)
            bpy.data.collections[nombre_coleccion].hide_viewport = False
            bpy.data.collections[nombre_coleccion].hide_render = False
            FK_ = bpy.context.scene.sna_fk
            VIEW_OBJECT = bpy.context.scene.sna_view_object
            Copy_Transforms_FK = bpy.context.scene.sna_copy_transforms_fk
            Armature = bpy.context.active_object
            bpy.ops.object.mode_set(mode='EDIT')
            selected_bones = [bone for bone in bpy.context.selected_editable_bones]
            selected_bones_Name = [bone.name for bone in bpy.context.selected_editable_bones]
            num_selected_bones = len(selected_bones)
            FK = FK_

            def App_Bones(Control, Bones, Cuantos = int(0)):
                for i in range(Cuantos):
                    ultima_letra = Bones[-1].lower()  
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = Control + Bones[:-3] + str(i)
                    else:
                        Bone_Name = Control + Bones + "." + str(i)
                    bpy.ops.armature.bone_primitive_add(name=Bone_Name)

            def Encontrar_Bone(Control, Bones, Varible = [], Cuantos = int(0)):
                for i in range(Cuantos):
                    ultima_letra = Bones[-1].lower()  
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = Control + Bones[:-3] + str(i)
                    else:
                        Bone_Name = Control + Bones + "." + str(i)
                    Varible.append(Armature.data.edit_bones.get(Bone_Name))

            def Posicionar_Bones(Bone, head, tail, roll, length, tengo_length = True):
                Bone.head = head
                Bone.tail = tail
                Bone.roll = roll
                if tengo_length == True:
                    Bone.length = length
                else:
                    print("no quiero length en el bone")

            def pocioner_Bones_tail(Bone, head, tail, roll, length, tengo_length = True):
                Bone.head = head
                Bone.tail = tail
                Bone.length *= 2
                Bone.head = tail
                Bone.roll = roll
                if tengo_length == True:
                    Bone.length = length
                else:
                    print("no quiero length en el bone")
            #si estoy en Edit Bone
            if Armature and Armature.type == 'ARMATURE':
                Fk_Controles = []
                if selected_bones:
                    #FK Controles:
                    Numero_de_bones = num_selected_bones + 1
                    App_Bones(FK, selected_bones_Name[0], Cuantos = int(num_selected_bones))
                    Encontrar_Bone(FK, selected_bones_Name[0], Fk_Controles, Cuantos = int(num_selected_bones))
                    for i in range(num_selected_bones):
                        Posicionar_Bones(Fk_Controles[i], selected_bones[i].head, 
                                         selected_bones[i].tail, selected_bones[i].roll, 
                                         selected_bones[i].length, tengo_length = False)
                    if Fk_Controles:
                        for i in range(num_selected_bones):
                            Fk_Controles[i].use_deform = False
                    if Fk_Controles:
                        for i in range(num_selected_bones -1):
                            Fk_Controles[i + 1].parent = Fk_Controles[i]
                            Fk_Controles[i + 1].use_connect = True
                bpy.ops.object.mode_set(mode='POSE')
                Pose_selected_bones = []
                for i in range(num_selected_bones):
                    Control = selected_bones_Name[i]
                    Bones = Armature.pose.bones.get(Control)
                    Pose_selected_bones.append(Bones)
                Pose_Fk_Controles = []
                for i in range(num_selected_bones + 1):
                    Bones = selected_bones_Name[0]
                    ultima_letra = Bones[-1].lower()
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = FK + Bones[:-3] + str(i)
                    else:
                        Bone_Name = FK + Bones + "." + str(i)
                    Bones = Armature.pose.bones.get(Bone_Name)
                    Pose_Fk_Controles.append(Bones)
                if Pose_selected_bones and Pose_Fk_Controles:
                    if Copy_Transforms_FK == True:
                        for i in range(num_selected_bones):
                                    constraint = Pose_selected_bones[i].constraints.new(type='COPY_TRANSFORMS')
                                    constraint.target = Armature
                                    constraint.subtarget = Pose_Fk_Controles[i].name
                    if bpy.data.objects["Materiales_RIG_CREATOR.3"] and bpy.data.objects["Materiales_RIG_CREATOR.1"]:
                        for i in range(num_selected_bones):
                            if VIEW_OBJECT == True:
                                Pose_Fk_Controles[i].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.1"]
                                Pose_Fk_Controles[i].custom_shape_translation[1] = Pose_Fk_Controles[i].length / 2
                                Pose_Fk_Controles[i].color.palette = 'THEME03'
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def sna_function_interface_4B3D0(layout_function, ):
    row_B051B = layout_function.row(heading='', align=False)
    row_B051B.alert = False
    row_B051B.enabled = True
    row_B051B.active = True
    row_B051B.use_property_split = False
    row_B051B.use_property_decorate = False
    row_B051B.scale_x = 1.0
    row_B051B.scale_y = 1.0
    row_B051B.alignment = 'Left'.upper()
    row_B051B.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_B051B.prop(bpy.context.scene, 'sna_ver_fk', text='Generator FK', icon_value=(46 if bpy.context.scene.sna_ver_fk else 45), emboss=False)
    if bpy.context.scene.sna_ver_fk:
        grid_F1CD5 = layout_function.grid_flow(columns=-558, row_major=False, even_columns=False, even_rows=False, align=False)
        grid_F1CD5.enabled = True
        grid_F1CD5.active = True
        grid_F1CD5.use_property_split = False
        grid_F1CD5.use_property_decorate = False
        grid_F1CD5.alignment = 'Expand'.upper()
        grid_F1CD5.scale_x = 1.0
        grid_F1CD5.scale_y = 1.2000000476837158
        if not True: grid_F1CD5.operator_context = "EXEC_DEFAULT"
        grid_70583 = grid_F1CD5.grid_flow(columns=1, row_major=False, even_columns=False, even_rows=False, align=True)
        grid_70583.enabled = True
        grid_70583.active = True
        grid_70583.use_property_split = False
        grid_70583.use_property_decorate = False
        grid_70583.alignment = 'Expand'.upper()
        grid_70583.scale_x = 1.0
        grid_70583.scale_y = 1.2000000476837158
        if not True: grid_70583.operator_context = "EXEC_DEFAULT"
        grid_70583.prop(bpy.context.scene, 'sna_view_object', text='VIEW_OBJECT', icon_value=0, emboss=True, toggle=True)
        grid_70583.prop(bpy.context.scene, 'sna_copy_transforms_fk', text='Copy Transforms', icon_value=65, emboss=True, toggle=True)
        op = grid_F1CD5.operator('sna.operator_01bc7', text='Generator Fk', icon_value=495, emboss=True, depress=False)
        grid_F1CD5.prop(bpy.context.scene, 'sna_fk', text='FK', icon_value=0, emboss=True)


def sna_paneles_F912C(layout_function, ):
    row_E4D27 = layout_function.row(heading='', align=False)
    row_E4D27.alert = False
    row_E4D27.enabled = True
    row_E4D27.active = True
    row_E4D27.use_property_split = False
    row_E4D27.use_property_decorate = False
    row_E4D27.scale_x = 1.0
    row_E4D27.scale_y = 1.0
    row_E4D27.alignment = 'Left'.upper()
    row_E4D27.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_E4D27.prop(bpy.context.scene, 'sna_ver_ik', text='Generator IK', icon_value=(46 if bpy.context.scene.sna_ver_ik else 45), emboss=False)
    if bpy.context.scene.sna_ver_ik:
        grid_74BB8 = layout_function.grid_flow(columns=-558, row_major=False, even_columns=False, even_rows=False, align=False)
        grid_74BB8.enabled = True
        grid_74BB8.active = True
        grid_74BB8.use_property_split = False
        grid_74BB8.use_property_decorate = False
        grid_74BB8.alignment = 'Expand'.upper()
        grid_74BB8.scale_x = 1.0
        grid_74BB8.scale_y = 1.2000000476837158
        if not True: grid_74BB8.operator_context = "EXEC_DEFAULT"
        grid_AA35E = grid_74BB8.grid_flow(columns=3, row_major=False, even_columns=False, even_rows=False, align=True)
        grid_AA35E.enabled = True
        grid_AA35E.active = True
        grid_AA35E.use_property_split = False
        grid_AA35E.use_property_decorate = False
        grid_AA35E.alignment = 'Expand'.upper()
        grid_AA35E.scale_x = 1.0
        grid_AA35E.scale_y = 1.0
        if not True: grid_AA35E.operator_context = "EXEC_DEFAULT"
        grid_AA35E.prop(bpy.context.scene, 'sna_strech_ik', text='Strech_IK', icon_value=0, emboss=True, toggle=True)
        grid_AA35E.prop(bpy.context.scene, 'sna_tengo_pole_target', text='Pole_Target', icon_value=0, emboss=True, toggle=True)
        grid_AA35E.prop(bpy.context.scene, 'sna_damped_track_off', text='', icon_value=435, emboss=True, toggle=True)
        grid_74BB8.prop(bpy.context.scene, 'sna_copy_transforms', text='Copy Transforms', icon_value=65, emboss=True, toggle=True)
        op = grid_74BB8.operator('sna.operator_efb58', text='Generator IK', icon_value=495, emboss=True, depress=False)
        grid_74BB8.prop(bpy.context.scene, 'sna_ik_', text='IK', icon_value=0, emboss=True)
        if bpy.context.scene.sna_tengo_pole_target:
            grid_74BB8.prop(bpy.context.scene, 'sna_pole_angle', text='IK_Angle', icon_value=0, emboss=True)


class SNA_OT_Operator_Efb58(bpy.types.Operator):
    bl_idname = "sna.operator_efb58"
    bl_label = "Operator"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        if property_exists("bpy.data.collections['RIG_CREATOR_Material']", globals(), locals()):
            IK_ = bpy.context.scene.sna_ik_
            IK_Angle = bpy.context.scene.sna_pole_angle
            Strech_IK = bpy.context.scene.sna_strech_ik
            Tengo_Pole_target = bpy.context.scene.sna_tengo_pole_target
            DAMPED_TRACK_off = bpy.context.scene.sna_damped_track_off
            Copy_Transforms = bpy.context.scene.sna_copy_transforms
            Armature = bpy.context.active_object
            bpy.ops.object.mode_set(mode='EDIT')
            selected_bones = [bone for bone in bpy.context.selected_editable_bones]
            selected_bones_Name = [bone.name for bone in bpy.context.selected_editable_bones]
            num_selected_bones = len(selected_bones)
            IK = IK_
            IK_COntrole = "COLTROLES_" + IK

            def App_Bones(Control, Bones, Cuantos = int(0)):
                for i in range(Cuantos):
                    ultima_letra = Bones[-1].lower()  
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = Control + Bones[:-3] + str(i)
                    else:
                        Bone_Name = Control + Bones + "." + str(i)
                    bpy.ops.armature.bone_primitive_add(name=Bone_Name)

            def Encontrar_Bone(Control, Bones, Varible = [], Cuantos = int(0)):
                for i in range(Cuantos):
                    ultima_letra = Bones[-1].lower()  
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = Control + Bones[:-3] + str(i)
                    else:
                        Bone_Name = Control + Bones + "." + str(i)
                    Varible.append(Armature.data.edit_bones.get(Bone_Name))

            def Posicionar_Bones(Bone, head, tail, roll, length, tengo_length = True):
                Bone.head = head
                Bone.tail = tail
                Bone.roll = roll
                if tengo_length == True:
                    Bone.length = length
                else:
                    print("no quiero length en el bone")

            def pocioner_Bones_tail(Bone, head, tail, roll, length, tengo_length = True):
                Bone.head = head
                Bone.tail = tail
                Bone.length *= 2
                Bone.head = tail
                Bone.roll = roll
                if tengo_length == True:
                    Bone.length = length
                else:
                    print("no quiero length en el bone")
            #si estoy en Edit Bone
            if Armature and Armature.type == 'ARMATURE':
                IK_Bone = []
                Ik_Controles = []
                Nump = 0
                if Tengo_Pole_target == True:
                    Nump = 4
                else:
                    Nump = 3
                if selected_bones:
                    #IK
                    if num_selected_bones < 3:
                        Numero_de_bones = num_selected_bones + 1
                        App_Bones(IK, selected_bones_Name[0], Cuantos = int(Numero_de_bones))
                        Encontrar_Bone(IK, selected_bones_Name[0], IK_Bone, Cuantos = int(Numero_de_bones))
                        for i in range(num_selected_bones):
                            Posicionar_Bones(IK_Bone[i], selected_bones[i].head, 
                                             selected_bones[i].tail, selected_bones[i].roll, 
                                             selected_bones[i].length, tengo_length = False)
                        if Numero_de_bones > 1:
                            pocioner_Bones_tail(IK_Bone[-1], selected_bones[-1].head, 
                                                selected_bones[-1].tail, selected_bones[-1].roll, selected_bones[-1].length / 2, 
                                                tengo_length = True)
                        else:
                            pocioner_Bones_tail(IK_Bone[-1], selected_bones[0].head, 
                                                selected_bones[0].tail, selected_bones[0].roll, selected_bones[0].length / 2, 
                                                tengo_length = True)
                    else:
                        App_Bones(IK, selected_bones_Name[0], Cuantos = int(num_selected_bones))
                        Encontrar_Bone(IK, selected_bones_Name[0], IK_Bone, Cuantos = int(num_selected_bones))
                        for i in range(num_selected_bones):
                            Posicionar_Bones(IK_Bone[i], selected_bones[i].head, 
                                             selected_bones[i].tail, selected_bones[i].roll, 
                                             selected_bones[i].length, tengo_length = False)
                if selected_bones:
                    #Ik_Controles
                    Numero_de_bones = num_selected_bones + 1
                    App_Bones(IK_COntrole, selected_bones_Name[0], Cuantos = int(Nump))
                    Encontrar_Bone(IK_COntrole, selected_bones_Name[0], Ik_Controles, Cuantos = int(Nump))
                    for i in range(2):
                        Posicionar_Bones(Ik_Controles[i], selected_bones[0].head, 
                                         selected_bones[-1].tail, selected_bones[0].roll, 
                                         selected_bones[0].length / 2 , tengo_length = True)
                    if num_selected_bones < 3:
                        if Numero_de_bones > 1:
                            pocioner_Bones_tail(Ik_Controles[2], selected_bones[-1].head, 
                                                selected_bones[-1].tail, selected_bones[-1].roll, selected_bones[-1].length / 3, 
                                                tengo_length = True)
                        else:
                            pocioner_Bones_tail(Ik_Controles[2], selected_bones[0].head, 
                                                selected_bones[0].tail, selected_bones[0].roll, selected_bones[0].length / 3, 
                                                tengo_length = True)
                    else:
                        Posicionar_Bones(Ik_Controles[2], selected_bones[-1].head, 
                                         selected_bones[-1].tail, selected_bones[-1].roll, 
                                         selected_bones[-1].length / 2 , tengo_length = True)
                    if Tengo_Pole_target == True:
                        if Ik_Controles[3]:
                            Ik_Controles[3].head = IK_Bone[-2].head
                            Pocion_Normal = IK_Bone[-2].z_axis.normalized()
                            Pocion_Normal_1 = IK_Bone[-3].z_axis.normalized()
                            Normales = (Pocion_Normal + Pocion_Normal_1) / 2
                            Ik_Controles[3].tail = IK_Bone[-2].head + (Normales * -1)
                            Ik_Controles[3].length = 2
                            new_head = (Ik_Controles[3].head + Ik_Controles[3].tail) / 2
                            Ik_Controles[3].head = new_head
                            Ik_Controles[3].length = Ik_Controles[0].length
                    for i in range(Nump):
                        Ik_Controles[i].use_deform = False
                if IK_Bone:
                    if num_selected_bones < 3:
                        for i in range(Numero_de_bones):
                            IK_Bone[i].use_deform = False
                        for i in range(num_selected_bones):
                            IK_Bone[i + 1].parent = IK_Bone[i]
                            IK_Bone[i + 1].use_connect = True
                        IK_Bone[-1].use_connect = False
                        IK_Bone[-1].parent = None
                    else:
                        for i in range(num_selected_bones):
                            IK_Bone[i].use_deform = False
                        for i in range(num_selected_bones - 1):
                            IK_Bone[i + 1].parent = IK_Bone[i]
                            IK_Bone[i + 1].use_connect = True
                        IK_Bone[-1].use_connect = False
                        IK_Bone[-1].parent = None
                    if IK_Bone and Ik_Controles:
                        IK_Bone[0].parent = Ik_Controles[0]
                        IK_Bone[-1].parent = Ik_Controles[2]
                        if Tengo_Pole_target == True:
                            Ik_Controles[3].parent = Ik_Controles[1]
                bpy.ops.object.mode_set(mode='POSE')
                Pose_selected_bones = []
                for i in range(num_selected_bones):
                    Control = selected_bones_Name[i]
                    Bones = Armature.pose.bones.get(Control)
                    Pose_selected_bones.append(Bones)
                Pose_IK_Bone = []
                if num_selected_bones < 3:
                    for i in range(num_selected_bones + 1):
                        Bones = selected_bones_Name[0]
                        ultima_letra = Bones[-1].lower()
                        Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                        if not Tiene_L_O_R:
                            Bone_Name = IK + Bones[:-3] + str(i)
                        else:
                            Bone_Name = IK + Bones + "." + str(i)
                        Bones = Armature.pose.bones.get(Bone_Name)
                        Pose_IK_Bone.append(Bones)
                else:
                    for i in range(num_selected_bones):
                        Bones = selected_bones_Name[0]
                        ultima_letra = Bones[-1].lower()
                        Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                        if not Tiene_L_O_R:
                            Bone_Name = IK + Bones[:-3] + str(i)
                        else:
                            Bone_Name = IK + Bones + "." + str(i)
                        Bones = Armature.pose.bones.get(Bone_Name)
                        Pose_IK_Bone.append(Bones)
                pose_Ik_Controles = []
                for i in range(4):
                        Bones = selected_bones_Name[0]
                        ultima_letra = Bones[-1].lower()
                        Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                        if not Tiene_L_O_R:
                            Bone_Name = IK_COntrole + Bones[:-3] + str(i)
                        else:
                            Bone_Name = IK_COntrole + Bones + "." + str(i)
                        Bones = Armature.pose.bones.get(Bone_Name)
                        pose_Ik_Controles.append(Bones)
                if Pose_selected_bones:
                   if Pose_IK_Bone[-2]:
                       for i in range(num_selected_bones):
                            bpy.data.objects[Armature.name].pose.bones[Pose_IK_Bone[i].name].ik_stretch = 0.1
                       constraint = Pose_IK_Bone[-2].constraints.new(type='IK')
                       constraint.target = Armature
                       constraint.subtarget = Pose_IK_Bone[-1].name
                       if num_selected_bones < 3:
                            constraint.chain_count = num_selected_bones
                       else:
                            constraint.chain_count = num_selected_bones -1
                       if Strech_IK == True:
                           constraint.use_stretch = True
                       else:
                           constraint.use_stretch = False
                       if Tengo_Pole_target == True:
                            if constraint.target:
                                 constraint.pole_target = Armature
                                 constraint.pole_subtarget = pose_Ik_Controles[3].name
                                 constraint.pole_angle = IK_Angle
                if pose_Ik_Controles:
                    if Copy_Transforms == True:
                        if Pose_selected_bones and Pose_IK_Bone:
                            for i in range(num_selected_bones):
                                constraint = Pose_selected_bones[i].constraints.new(type='COPY_TRANSFORMS')
                                constraint.target = Armature
                                constraint.subtarget = Pose_IK_Bone[i].name
                    constraint = pose_Ik_Controles[1].constraints.new(type='COPY_TRANSFORMS')
                    constraint.target = Armature
                    constraint.subtarget = pose_Ik_Controles[0].name
                    if DAMPED_TRACK_off == True:
                        constraint = pose_Ik_Controles[0].constraints.new(type='DAMPED_TRACK')
                        constraint.target = Armature
                        constraint.subtarget = Pose_IK_Bone[-1].name
                    if bpy.data.objects["Materiales_RIG_CREATOR.3"] and bpy.data.objects["Materiales_RIG_CREATOR.2"]:
                        Armature_contex = bpy.data.objects[Armature.name].pose.bones
                        Armature_contex[Pose_IK_Bone[-1].name].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.2"]
                        Armature_contex[Pose_IK_Bone[-1].name].custom_shape_translation[1] = (Pose_IK_Bone[-1].length) / 2
                        Armature_contex[Pose_IK_Bone[-1].name].custom_shape_scale_xyz = [1, 1, 1]
                        Armature_contex[Pose_IK_Bone[-1].name].custom_shape_scale_xyz /= 2
                        Armature_contex[Pose_IK_Bone[-1].name].color.palette = 'THEME01'
                        Armature_contex[pose_Ik_Controles[0].name].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.2"]
                        Armature_contex[pose_Ik_Controles[0].name].custom_shape_translation[1] = Pose_selected_bones[0].length
                        Armature_contex[pose_Ik_Controles[0].name].custom_shape_scale_xyz = [1, 0, 1]
                        Armature_contex[pose_Ik_Controles[0].name].color.palette = 'THEME01'
                        if Tengo_Pole_target == True:
                            Armature_contex[pose_Ik_Controles[3].name].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.3"]
                            Armature_contex[pose_Ik_Controles[3].name].custom_shape_scale_xyz /= 2
                            Armature_contex[pose_Ik_Controles[3].name].color.palette = 'THEME04'
        else:
            nombre_coleccion = "RIG_CREATOR_Material"
            nueva_coleccion = bpy.data.collections.new(nombre_coleccion)
            bpy.context.scene.collection.children.link(nueva_coleccion)
            colección_op = bpy.data.collections.get(nombre_coleccion)
            if colección_op:
                for i in range(4):
                    nombre_empty = "Materiales_RIG_CREATOR" + "." + str(i)
                    # Crear un nuevo objeto Empty
                    empty = bpy.data.objects.new(nombre_empty, None)
                    # Asignar tipo personalizado a Empty
                    if i == 0:
                        empty.empty_display_type = 'SINGLE_ARROW'
                    elif i == 1:
                        empty.empty_display_type = 'CIRCLE'
                    elif i == 2:
                        empty.empty_display_type = 'CUBE'
                    elif i == 3:
                        empty.empty_display_type = 'SPHERE'
                    # Añadir el Empty a la colección
                    colección_op.objects.link(empty)
            bpy.data.collections[nombre_coleccion].hide_viewport = False
            bpy.data.collections[nombre_coleccion].hide_render = False
            IK_ = bpy.context.scene.sna_ik_
            IK_Angle = bpy.context.scene.sna_pole_angle
            Strech_IK = bpy.context.scene.sna_strech_ik
            Tengo_Pole_target = bpy.context.scene.sna_tengo_pole_target
            DAMPED_TRACK_off = bpy.context.scene.sna_damped_track_off
            Copy_Transforms = bpy.context.scene.sna_copy_transforms
            Armature = bpy.context.active_object
            bpy.ops.object.mode_set(mode='EDIT')
            selected_bones = [bone for bone in bpy.context.selected_editable_bones]
            selected_bones_Name = [bone.name for bone in bpy.context.selected_editable_bones]
            num_selected_bones = len(selected_bones)
            IK = IK_
            IK_COntrole = "COLTROLES_" + IK

            def App_Bones(Control, Bones, Cuantos = int(0)):
                for i in range(Cuantos):
                    ultima_letra = Bones[-1].lower()  
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = Control + Bones[:-3] + str(i)
                    else:
                        Bone_Name = Control + Bones + "." + str(i)
                    bpy.ops.armature.bone_primitive_add(name=Bone_Name)

            def Encontrar_Bone(Control, Bones, Varible = [], Cuantos = int(0)):
                for i in range(Cuantos):
                    ultima_letra = Bones[-1].lower()  
                    Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                    if not Tiene_L_O_R:
                        Bone_Name = Control + Bones[:-3] + str(i)
                    else:
                        Bone_Name = Control + Bones + "." + str(i)
                    Varible.append(Armature.data.edit_bones.get(Bone_Name))

            def Posicionar_Bones(Bone, head, tail, roll, length, tengo_length = True):
                Bone.head = head
                Bone.tail = tail
                Bone.roll = roll
                if tengo_length == True:
                    Bone.length = length
                else:
                    print("no quiero length en el bone")

            def pocioner_Bones_tail(Bone, head, tail, roll, length, tengo_length = True):
                Bone.head = head
                Bone.tail = tail
                Bone.length *= 2
                Bone.head = tail
                Bone.roll = roll
                if tengo_length == True:
                    Bone.length = length
                else:
                    print("no quiero length en el bone")
            #si estoy en Edit Bone
            if Armature and Armature.type == 'ARMATURE':
                IK_Bone = []
                Ik_Controles = []
                Nump = 0
                if Tengo_Pole_target == True:
                    Nump = 4
                else:
                    Nump = 3
                if selected_bones:
                    #IK
                    if num_selected_bones < 3:
                        Numero_de_bones = num_selected_bones + 1
                        App_Bones(IK, selected_bones_Name[0], Cuantos = int(Numero_de_bones))
                        Encontrar_Bone(IK, selected_bones_Name[0], IK_Bone, Cuantos = int(Numero_de_bones))
                        for i in range(num_selected_bones):
                            Posicionar_Bones(IK_Bone[i], selected_bones[i].head, 
                                             selected_bones[i].tail, selected_bones[i].roll, 
                                             selected_bones[i].length, tengo_length = False)
                        if Numero_de_bones > 1:
                            pocioner_Bones_tail(IK_Bone[-1], selected_bones[-1].head, 
                                                selected_bones[-1].tail, selected_bones[-1].roll, selected_bones[-1].length / 2, 
                                                tengo_length = True)
                        else:
                            pocioner_Bones_tail(IK_Bone[-1], selected_bones[0].head, 
                                                selected_bones[0].tail, selected_bones[0].roll, selected_bones[0].length / 2, 
                                                tengo_length = True)
                    else:
                        App_Bones(IK, selected_bones_Name[0], Cuantos = int(num_selected_bones))
                        Encontrar_Bone(IK, selected_bones_Name[0], IK_Bone, Cuantos = int(num_selected_bones))
                        for i in range(num_selected_bones):
                            Posicionar_Bones(IK_Bone[i], selected_bones[i].head, 
                                             selected_bones[i].tail, selected_bones[i].roll, 
                                             selected_bones[i].length, tengo_length = False)
                if selected_bones:
                    #Ik_Controles
                    Numero_de_bones = num_selected_bones + 1
                    App_Bones(IK_COntrole, selected_bones_Name[0], Cuantos = int(Nump))
                    Encontrar_Bone(IK_COntrole, selected_bones_Name[0], Ik_Controles, Cuantos = int(Nump))
                    for i in range(2):
                        Posicionar_Bones(Ik_Controles[i], selected_bones[0].head, 
                                         selected_bones[-1].tail, selected_bones[0].roll, 
                                         selected_bones[0].length / 2 , tengo_length = True)
                    if num_selected_bones < 3:
                        if Numero_de_bones > 1:
                            pocioner_Bones_tail(Ik_Controles[2], selected_bones[-1].head, 
                                                selected_bones[-1].tail, selected_bones[-1].roll, selected_bones[-1].length / 3, 
                                                tengo_length = True)
                        else:
                            pocioner_Bones_tail(Ik_Controles[2], selected_bones[0].head, 
                                                selected_bones[0].tail, selected_bones[0].roll, selected_bones[0].length / 3, 
                                                tengo_length = True)
                    else:
                        Posicionar_Bones(Ik_Controles[2], selected_bones[-1].head, 
                                         selected_bones[-1].tail, selected_bones[-1].roll, 
                                         selected_bones[-1].length / 2 , tengo_length = True)
                    if Tengo_Pole_target == True:
                        if Ik_Controles[3]:
                            Ik_Controles[3].head = IK_Bone[-2].head
                            Pocion_Normal = IK_Bone[-2].z_axis.normalized()
                            Pocion_Normal_1 = IK_Bone[-3].z_axis.normalized()
                            Normales = (Pocion_Normal + Pocion_Normal_1) / 2
                            Ik_Controles[3].tail = IK_Bone[-2].head + (Normales * -1)
                            Ik_Controles[3].length = 2
                            new_head = (Ik_Controles[3].head + Ik_Controles[3].tail) / 2
                            Ik_Controles[3].head = new_head
                            Ik_Controles[3].length = Ik_Controles[0].length
                    for i in range(Nump):
                        Ik_Controles[i].use_deform = False
                if IK_Bone:
                    if num_selected_bones < 3:
                        for i in range(Numero_de_bones):
                            IK_Bone[i].use_deform = False
                        for i in range(num_selected_bones):
                            IK_Bone[i + 1].parent = IK_Bone[i]
                            IK_Bone[i + 1].use_connect = True
                        IK_Bone[-1].use_connect = False
                        IK_Bone[-1].parent = None
                    else:
                        for i in range(num_selected_bones):
                            IK_Bone[i].use_deform = False
                        for i in range(num_selected_bones - 1):
                            IK_Bone[i + 1].parent = IK_Bone[i]
                            IK_Bone[i + 1].use_connect = True
                        IK_Bone[-1].use_connect = False
                        IK_Bone[-1].parent = None
                    if IK_Bone and Ik_Controles:
                        IK_Bone[0].parent = Ik_Controles[0]
                        IK_Bone[-1].parent = Ik_Controles[2]
                        if Tengo_Pole_target == True:
                            Ik_Controles[3].parent = Ik_Controles[1]
                bpy.ops.object.mode_set(mode='POSE')
                Pose_selected_bones = []
                for i in range(num_selected_bones):
                    Control = selected_bones_Name[i]
                    Bones = Armature.pose.bones.get(Control)
                    Pose_selected_bones.append(Bones)
                Pose_IK_Bone = []
                if num_selected_bones < 3:
                    for i in range(num_selected_bones + 1):
                        Bones = selected_bones_Name[0]
                        ultima_letra = Bones[-1].lower()
                        Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                        if not Tiene_L_O_R:
                            Bone_Name = IK + Bones[:-3] + str(i)
                        else:
                            Bone_Name = IK + Bones + "." + str(i)
                        Bones = Armature.pose.bones.get(Bone_Name)
                        Pose_IK_Bone.append(Bones)
                else:
                    for i in range(num_selected_bones):
                        Bones = selected_bones_Name[0]
                        ultima_letra = Bones[-1].lower()
                        Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                        if not Tiene_L_O_R:
                            Bone_Name = IK + Bones[:-3] + str(i)
                        else:
                            Bone_Name = IK + Bones + "." + str(i)
                        Bones = Armature.pose.bones.get(Bone_Name)
                        Pose_IK_Bone.append(Bones)
                pose_Ik_Controles = []
                for i in range(4):
                        Bones = selected_bones_Name[0]
                        ultima_letra = Bones[-1].lower()
                        Tiene_L_O_R = ultima_letra in ['r', 'l', 'L', 'R']
                        if not Tiene_L_O_R:
                            Bone_Name = IK_COntrole + Bones[:-3] + str(i)
                        else:
                            Bone_Name = IK_COntrole + Bones + "." + str(i)
                        Bones = Armature.pose.bones.get(Bone_Name)
                        pose_Ik_Controles.append(Bones)
                if Pose_selected_bones:
                   if Pose_IK_Bone[-2]:
                       for i in range(num_selected_bones):
                            bpy.data.objects[Armature.name].pose.bones[Pose_IK_Bone[i].name].ik_stretch = 0.1
                       constraint = Pose_IK_Bone[-2].constraints.new(type='IK')
                       constraint.target = Armature
                       constraint.subtarget = Pose_IK_Bone[-1].name
                       if num_selected_bones < 3:
                            constraint.chain_count = num_selected_bones
                       else:
                            constraint.chain_count = num_selected_bones -1
                       if Strech_IK == True:
                           constraint.use_stretch = True
                       else:
                           constraint.use_stretch = False
                       if Tengo_Pole_target == True:
                            if constraint.target:
                                 constraint.pole_target = Armature
                                 constraint.pole_subtarget = pose_Ik_Controles[3].name
                                 constraint.pole_angle = IK_Angle
                if pose_Ik_Controles:
                    if Copy_Transforms == True:
                        if Pose_selected_bones and Pose_IK_Bone:
                            for i in range(num_selected_bones):
                                constraint = Pose_selected_bones[i].constraints.new(type='COPY_TRANSFORMS')
                                constraint.target = Armature
                                constraint.subtarget = Pose_IK_Bone[i].name
                    constraint = pose_Ik_Controles[1].constraints.new(type='COPY_TRANSFORMS')
                    constraint.target = Armature
                    constraint.subtarget = pose_Ik_Controles[0].name
                    if DAMPED_TRACK_off == True:
                        constraint = pose_Ik_Controles[0].constraints.new(type='DAMPED_TRACK')
                        constraint.target = Armature
                        constraint.subtarget = Pose_IK_Bone[-1].name
                    if bpy.data.objects["Materiales_RIG_CREATOR.3"] and bpy.data.objects["Materiales_RIG_CREATOR.2"]:
                        Armature_contex = bpy.data.objects[Armature.name].pose.bones
                        Armature_contex[Pose_IK_Bone[-1].name].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.2"]
                        Armature_contex[Pose_IK_Bone[-1].name].custom_shape_translation[1] = (Pose_IK_Bone[-1].length) / 2
                        Armature_contex[Pose_IK_Bone[-1].name].custom_shape_scale_xyz = [1, 1, 1]
                        Armature_contex[Pose_IK_Bone[-1].name].custom_shape_scale_xyz /= 2
                        Armature_contex[Pose_IK_Bone[-1].name].color.palette = 'THEME01'
                        Armature_contex[pose_Ik_Controles[0].name].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.2"]
                        Armature_contex[pose_Ik_Controles[0].name].custom_shape_translation[1] = Pose_selected_bones[0].length
                        Armature_contex[pose_Ik_Controles[0].name].custom_shape_scale_xyz = [1, 0, 1]
                        Armature_contex[pose_Ik_Controles[0].name].color.palette = 'THEME01'
                        if Tengo_Pole_target == True:
                            Armature_contex[pose_Ik_Controles[3].name].custom_shape = bpy.data.objects["Materiales_RIG_CREATOR.3"]
                            Armature_contex[pose_Ik_Controles[3].name].custom_shape_scale_xyz /= 2
                            Armature_contex[pose_Ik_Controles[3].name].color.palette = 'THEME04'
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def sna_function_interface_E8A7B(layout_function, ):
    row_79433 = layout_function.row(heading='', align=False)
    row_79433.alert = False
    row_79433.enabled = True
    row_79433.active = True
    row_79433.use_property_split = False
    row_79433.use_property_decorate = False
    row_79433.scale_x = 1.0
    row_79433.scale_y = 1.0
    row_79433.alignment = 'Left'.upper()
    row_79433.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_79433.prop(bpy.context.scene, 'sna_reset_rig_creator', text='RESET RIg Creator', icon_value=(46 if bpy.context.scene.sna_reset_rig_creator else 45), emboss=False)
    if bpy.context.scene.sna_reset_rig_creator:
        grid_FAFC1 = layout_function.grid_flow(columns=-189, row_major=False, even_columns=False, even_rows=False, align=True)
        grid_FAFC1.enabled = True
        grid_FAFC1.active = True
        grid_FAFC1.use_property_split = False
        grid_FAFC1.use_property_decorate = False
        grid_FAFC1.alignment = 'Expand'.upper()
        grid_FAFC1.scale_x = 1.0
        grid_FAFC1.scale_y = 1.2000000476837158
        if not True: grid_FAFC1.operator_context = "EXEC_DEFAULT"
        if True:
            op = grid_FAFC1.operator('sna.operator_973e8', text='RESET', icon_value=241, emboss=True, depress=False)


class SNA_OT_Operator_973E8(bpy.types.Operator):
    bl_idname = "sna.operator_973e8"
    bl_label = "Operator"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        bpy.ops.object.mode_set(mode='EDIT')
        Armature = bpy.context.active_object
        Bones_get = Armature.data.edit_bones

        def Posicionar_Bones(Bone, head, tail, roll, length, tengo_length = True):
            Bone.head = head
            Bone.tail = tail
            Bone.roll = roll
            if tengo_length == True:
                Bone.length = length
            else:
                print("no quiero length en el bone")

        def pocioner_Bones_tail(Bone, head, tail, roll, length, tengo_length = True):
            Bone.head = head
            Bone.tail = tail
            Bone.length *= 2
            Bone.head = tail
            Bone.roll = roll
            if tengo_length == True:
                Bone.length = length
            else:
                print("no quiero length en el bone")

        def Encontral_Bones(Nombre_Bone_Base, repeticiones, append):
            for i in range(repeticiones):
                Nombre_Bone = f"{Nombre_Bone_Base}.{(i+1):03}"
                hueso = Bones_get.get(Nombre_Bone)
                append.append(hueso)
        if Armature or Armature.type == 'ARMATURE':
            #Root_Mover
            Root_Mover = Bones_get.get("Root_Mover")
            if Root_Mover:
                Posicionar_Bones(Root_Mover, [0, 0, 0], [0, -0.90508, 0], 0,
                                                 1, tengo_length = True)
            #Columna_Base
            Columna_base = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Columna.{i+1:03}") for i in range(6)):
                Encontral_Bones("Base_Columna", 6, Columna_base)
            if Columna_base:
                #Columna_Def
                Columna_Def = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Columna.{i+1:03}") for i in range(6)):
                    Encontral_Bones("Def_Columna", 6, Columna_Def)
                if Columna_base or Columna_Def:
                    for i in range(6):
                        if i < len(Columna_base) or i < len(Columna_Def):
                            Posicionar_Bones(Columna_Def[i], Columna_base[i].head, Columna_base[i].tail, Columna_base[i].roll,
                                             Columna_base[i].length, tengo_length = False)
                #Cabeza_Controles
                Cabeza_controles = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Columna.{i+1:03}") for i in range(6)):
                    Encontral_Bones("Control_Cabeza", 3, Cabeza_controles)
                if Cabeza_controles:
                    Posicionar_Bones(Cabeza_controles[0], Columna_base[5].head, Columna_base[5].tail, Columna_base[5].roll,
                                                 Columna_base[5].length, tengo_length = False)
                    Posicionar_Bones(Cabeza_controles[1], Columna_base[5].head, Columna_base[5].tail, Columna_base[5].roll,
                                                 Columna_base[5].length / 4, tengo_length = True)
                    pocioner_Bones_tail(Cabeza_controles[2], Columna_base[5].head, Columna_base[5].tail, Columna_base[5].roll, 
                                        Columna_base[5].length / 4, tengo_length = True)
                #Cuello_Controles
                Cuello_controles = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Columna.{i+1:03}") for i in range(6)):
                    Encontral_Bones("Control_Cuello", 3, Cuello_controles)
                if Cuello_controles:
                    Posicionar_Bones(Cuello_controles[0], Columna_base[4].head, Columna_base[4].tail, Columna_base[4].roll,
                                                     Columna_base[4].length, tengo_length = False)
                    Posicionar_Bones(Cuello_controles[2], Columna_base[4].head, Columna_base[4].tail, Columna_base[4].roll,
                                                 Columna_base[4].length / 4, tengo_length = True)
                    pocioner_Bones_tail(Cuello_controles[1], Columna_base[3].head, Columna_base[3].tail, Columna_base[3].roll, 
                                        Columna_base[4].length / 4, tengo_length = True)
                #Rot_Cabeza
                Rot_Cabeza = Bones_get.get("Rot_Cabeza")
                if Rot_Cabeza:
                    Posicionar_Bones(Rot_Cabeza, Columna_base[4].head, Columna_base[4].head, 0,
                                                     Columna_base[4].length / 2, tengo_length = True)
                #Control_Def_Columna
                Control_Def_Columna = [] 
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Columna.{i+1:03}") for i in range(6)):
                    Encontral_Bones("Control_Def_Columna", 4, Control_Def_Columna)
                if Control_Def_Columna:
                    for i in range(4):
                                Posicionar_Bones(Control_Def_Columna[i], Columna_base[i].head, Columna_base[i].tail, Columna_base[i].roll,
                                                 Columna_base[i].length / 4, tengo_length = True)
                #SubControl_Def_Columna
                SubControl_Def_Columna = [] 
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Columna.{i+1:03}") for i in range(6)):
                    Encontral_Bones("SubControl_Def_Columna", 2, SubControl_Def_Columna)
                if SubControl_Def_Columna or Control_Def_Columna:
                    for i in range(2):
                                Posicionar_Bones(SubControl_Def_Columna[i], Control_Def_Columna[2].head, Control_Def_Columna[2].tail, 
                                                 Control_Def_Columna[2].roll,
                                                 Control_Def_Columna[2].length / 4, tengo_length = False)
                #Hombros          
                Hombros = Bones_get.get("Hombros")   
                if Hombros:
                    Posicionar_Bones(Hombros, Columna_base[2].head, Columna_base[3].tail, 
                                                     Columna_base[2].roll,
                                                     Columna_base[2].length / 4, tengo_length = False) 
                #Control_UP_Columna
                Control_UP_Columna = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Columna.{i+1:03}") for i in range(6)):
                    Encontral_Bones("Control_UP_Columna", 2, Control_UP_Columna)
                if Control_UP_Columna:
                    for i in range(2):
                        Posicionar_Bones(Control_UP_Columna[i], Columna_base[i + 2].head, Columna_base[i + 2].tail, 
                                                 Columna_base[i + 2].roll,
                                                 Columna_base[i + 2].length / 4, tengo_length = False)
                #Cadera      
                Cadera =  Bones_get.get("Cadera")  
                if Cadera:
                    Posicionar_Bones(Cadera, Columna_base[1].tail, Columna_base[0].head, 
                                                     Columna_base[1].roll,
                                                     Columna_base[1].length / 4, tengo_length = False) 
                #Base_Cadera_L or Base_Cadera_R
                Base_Cadera_L = Bones_get.get("Base_Cadera_L") 
                Base_Cadera_R = Bones_get.get("Base_Cadera_R") 
                #Def_Cadera_L or Def_Cadera_L
                Def_Cadera_L = Bones_get.get("Def_Cadera_L") 
                Def_Cadera_R = Bones_get.get("Def_Cadera_R")
                if Def_Cadera_L or Def_Cadera_R:
                    Posicionar_Bones(Def_Cadera_L, Base_Cadera_L.head, Base_Cadera_L.tail, Base_Cadera_L.roll,
                                     Base_Cadera_L.length / 4, tengo_length = False) 
                    Posicionar_Bones(Def_Cadera_R, Base_Cadera_R.head, Base_Cadera_R.tail, Base_Cadera_R.roll,
                                     Base_Cadera_R.length / 4, tengo_length = False) 
                #Control_Down_Columna
                Control_Down_Columna = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Columna.{i+1:03}") for i in range(6)):
                    Encontral_Bones("Control_Down_Columna", 2, Control_Down_Columna)
                if Control_Down_Columna:
                    Posicionar_Bones(Control_Down_Columna[0], Columna_base[1].tail, Columna_base[1].head, Columna_base[1].roll,
                                     Columna_base[1].length / 4, tengo_length = False) 
                    Posicionar_Bones(Control_Down_Columna[1], Columna_base[0].tail, Columna_base[0].head, Columna_base[0].roll,
                                     Columna_base[0].length / 4, tengo_length = False) 
                #Root_Cadera
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Columna.{i+1:03}") for i in range(6)): 
                    Root_Cadera = Bones_get.get("Root_Cadera") 
                    if Root_Cadera:
                        Posicionar_Bones(Root_Cadera, Columna_base[0].head, Columna_base[0].head, Columna_base[0].roll,
                                         Columna_base[0].length, tengo_length = True) 
            #Base_Hombro_L or Base_Hombro_R
            Base_Hombro_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Hombro_L.{i+1:03}") for i in range(2)):
                Encontral_Bones("Base_Hombro_L", 2, Base_Hombro_L)
            Base_Hombro_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Hombro_R.{i+1:03}") for i in range(2)):
                Encontral_Bones("Base_Hombro_R", 2, Base_Hombro_R)
            if Base_Hombro_L or Base_Hombro_R:
                #Def_Hombros_L or Def_Hombros_R
                Def_Hombros_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Hombro_L.{i+1:03}") for i in range(2)):
                    Encontral_Bones("Def_Hombros_L", 2, Def_Hombros_L)
                Def_Hombros_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Hombro_R.{i+1:03}") for i in range(2)):
                    Encontral_Bones("Def_Hombros_R", 2, Def_Hombros_R)
                if Def_Hombros_L or Def_Hombros_R:
                    for i in range(2):
                        Posicionar_Bones(Def_Hombros_L[i], Base_Hombro_L[i].head, Base_Hombro_L[i].tail, Base_Hombro_L[i].roll,
                                     Base_Hombro_L[i].length, tengo_length = False) 
                        Posicionar_Bones(Def_Hombros_R[i], Base_Hombro_R[i].head, Base_Hombro_R[i].tail, Base_Hombro_R[i].roll,
                                     Base_Hombro_R[i].length, tengo_length = False) 
                #Control_Hombros_L or Control_Hombros_R
                Control_Hombros_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Hombro_L.{i+1:03}") for i in range(2)):
                    Encontral_Bones("Control_Hombros_L", 3, Control_Hombros_L)
                Control_Hombros_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Hombro_R.{i+1:03}") for i in range(2)):
                    Encontral_Bones("Control_Hombros_R", 3, Control_Hombros_R)
                if Control_Hombros_L or Control_Hombros_R:
                    Posicionar_Bones(Control_Hombros_L[0], Base_Hombro_L[1].head, Base_Hombro_L[1].tail, Base_Hombro_L[1].roll,
                                     Base_Hombro_L[1].length, tengo_length = False) 
                    Posicionar_Bones(Control_Hombros_L[1], Base_Hombro_L[1].head, Base_Hombro_L[1].head, Base_Hombro_L[1].roll,
                                     Base_Hombro_L[1].length /4, tengo_length = True)
                    pocioner_Bones_tail(Control_Hombros_L[2], Base_Hombro_L[1].head, Base_Hombro_L[1].tail, Base_Hombro_L[1].roll, 
                                        Base_Hombro_L[1].length / 4, tengo_length = True) 
                    Posicionar_Bones(Control_Hombros_R[0], Base_Hombro_R[1].head, Base_Hombro_R[1].tail, Base_Hombro_R[1].roll,
                                     Base_Hombro_R[1].length, tengo_length = False) 
                    Posicionar_Bones(Control_Hombros_R[1], Base_Hombro_R[1].head, Base_Hombro_R[1].tail, Base_Hombro_R[1].roll,
                                     Base_Hombro_R[1].length / 4, tengo_length = True) 
                    pocioner_Bones_tail(Control_Hombros_R[2], Base_Hombro_R[1].head, Base_Hombro_R[1].tail, Base_Hombro_R[1].roll, 
                                        Base_Hombro_R[1].length / 4, tengo_length = True) 
            #Base_Brazo_L or Base_Brazo_R
            Base_Brazo_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                Encontral_Bones("Base_Brazo_L", 3, Base_Brazo_L)
            Base_Brazo_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                Encontral_Bones("Base_Brazo_R", 3, Base_Brazo_R) 
            if Base_Brazo_L or Base_Brazo_R:
                #Root_Brazo_L or Root_Brazo_R
                Root_Brazo_L = Bones_get.get("Root_Brazo_L.001")
                Root_Brazo_R = Bones_get.get("Root_Brazo_R.001")
                if Root_Brazo_L or Root_Brazo_R:
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(Root_Brazo_L, Base_Brazo_L[0].head, Base_Brazo_L[0].tail, 
                                         Base_Brazo_L[0].roll, Base_Brazo_L[0].length / 4, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):    
                        Posicionar_Bones(Root_Brazo_R, Base_Brazo_R[0].head, Base_Brazo_R[0].tail, 
                                         Base_Brazo_R[0].roll, Base_Brazo_R[0].length / 4, tengo_length = True)
                #Def_Brazo_UP_L or Def_Brazo_UP_R
                Def_Brazo_UP_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                    Encontral_Bones("Def_Brazo_UP_L", 2, Def_Brazo_UP_L)
                else:
                    Def_Brazo_UP_L == None
                Def_Brazo_UP_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                    Encontral_Bones("Def_Brazo_UP_R", 2, Def_Brazo_UP_R)
                else:
                    Def_Brazo_UP_R == None
                if Def_Brazo_UP_L:
                    Posicionar_Bones(Def_Brazo_UP_L[0], Base_Brazo_L[0].head, ((Base_Brazo_L[0].tail + Base_Brazo_L[0].head) / 2), 
                                     Base_Brazo_L[0].roll,
                                     Base_Brazo_L[0].length, tengo_length = False) 
                    Posicionar_Bones(Def_Brazo_UP_L[1], ((Base_Brazo_L[0].tail + Base_Brazo_L[0].head) / 2),Base_Brazo_L[0].tail , 
                                     Base_Brazo_L[0].roll,
                                     Base_Brazo_L[0].length, tengo_length = False)
                if Def_Brazo_UP_R:
                    Posicionar_Bones(Def_Brazo_UP_R[0], Base_Brazo_R[0].head, ((Base_Brazo_R[0].tail + Base_Brazo_R[0].head) / 2), 
                                     Base_Brazo_R[0].roll,
                                     Base_Brazo_R[0].length, tengo_length = False) 
                    Posicionar_Bones(Def_Brazo_UP_R[1], ((Base_Brazo_R[0].tail + Base_Brazo_R[0].head) / 2),Base_Brazo_R[0].tail , 
                                     Base_Brazo_R[0].roll,
                                     Base_Brazo_R[0].length, tengo_length = False) 
                #Def_Brazo_DOWN_L or Def_Brazo_DOWN_R
                Def_Brazo_DOWN_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                    Encontral_Bones("Def_Brazo_DOWN_L", 2, Def_Brazo_DOWN_L)
                Def_Brazo_DOWN_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                    Encontral_Bones("Def_Brazo_DOWN_R", 2, Def_Brazo_DOWN_R)
                if Def_Brazo_DOWN_L or Def_Brazo_DOWN_R:
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(Def_Brazo_DOWN_L[0], Base_Brazo_L[1].head, ((Base_Brazo_L[1].tail + Base_Brazo_L[1].head) / 2), 
                                         Base_Brazo_L[1].roll,
                                         Base_Brazo_L[1].length, tengo_length = False) 
                        Posicionar_Bones(Def_Brazo_DOWN_L[1], ((Base_Brazo_L[1].tail + Base_Brazo_L[1].head) / 2),Base_Brazo_L[1].tail , 
                                         Base_Brazo_L[1].roll,
                                         Base_Brazo_L[1].length, tengo_length = False)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(Def_Brazo_DOWN_R[0], Base_Brazo_R[1].head, ((Base_Brazo_R[1].tail + Base_Brazo_R[1].head) / 2), 
                                         Base_Brazo_R[1].roll,
                                         Base_Brazo_R[1].length, tengo_length = False) 
                        Posicionar_Bones(Def_Brazo_DOWN_R[1], ((Base_Brazo_R[1].tail + Base_Brazo_R[1].head) / 2),Base_Brazo_R[1].tail , 
                                         Base_Brazo_R[1].roll,
                                         Base_Brazo_R[1].length, tengo_length = False)
                #Def_Mano_L or Def_Mano_R
                Def_Mano_L = Bones_get.get("Def_Mano_L.001") 
                Def_Mano_R = Bones_get.get("Def_Mano_R.001") 
                if Def_Mano_L or Def_Mano_R:
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(Def_Mano_L, Base_Brazo_L[2].head, Base_Brazo_L[2].tail, Base_Brazo_L[2].roll,
                                         Base_Brazo_L[2].length, tengo_length = False)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(Def_Mano_R, Base_Brazo_R[2].head, Base_Brazo_R[2].tail, Base_Brazo_R[2].roll,
                                         Base_Brazo_R[2].length, tengo_length = False)  
                #Control_Rot_Brazo_L or Control_Rot_Brazo_R
                Control_Rot_Brazo_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                    Encontral_Bones("Control_Rot_Brazo_L", 3, Control_Rot_Brazo_L)
                Control_Rot_Brazo_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                    Encontral_Bones("Control_Rot_Brazo_R", 3, Control_Rot_Brazo_R)
                if Control_Rot_Brazo_L or Control_Rot_Brazo_R:
                    for i in range(3):
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                            Posicionar_Bones(Control_Rot_Brazo_L[i], Base_Brazo_L[i].head, Base_Brazo_L[i].tail, Base_Brazo_L[i].roll,
                                         Base_Brazo_L[i].length, tengo_length = False)
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                            Posicionar_Bones(Control_Rot_Brazo_R[i], Base_Brazo_R[i].head, Base_Brazo_R[i].tail, Base_Brazo_R[i].roll,
                                         Base_Brazo_R[i].length, tengo_length = False)
                #Control_Def_Brazo_L or Control_Def_Brazo_R
                Control_Def_Brazo_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                    Encontral_Bones("Control_Def_Brazo_L", 2, Control_Def_Brazo_L)
                Control_Def_Brazo_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                    Encontral_Bones("Control_Def_Brazo_R", 2, Control_Def_Brazo_R)
                if Control_Def_Brazo_L or Control_Def_Brazo_R:
                    for i in range(2):
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                            Posicionar_Bones(Control_Def_Brazo_L[i], Base_Brazo_L[i].head, Base_Brazo_L[i].tail, Base_Brazo_L[i].roll,
                                         Base_Brazo_L[i].length, tengo_length = False)
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                            Posicionar_Bones(Control_Def_Brazo_R[i], Base_Brazo_R[i].head, Base_Brazo_R[i].tail, Base_Brazo_R[i].roll,
                                         Base_Brazo_R[i].length, tengo_length = False)
                #SubControl_Def_Brazo_L or SubControl_Def_Brazo_R
                SubControl_Def_Brazo_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                    Encontral_Bones("SubControl_Def_Brazo_L", 3, SubControl_Def_Brazo_L)
                SubControl_Def_Brazo_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                    Encontral_Bones("SubControl_Def_Brazo_R", 3, SubControl_Def_Brazo_R)
                if SubControl_Def_Brazo_L or SubControl_Def_Brazo_R:
                    for i in range(2):
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                            Posicionar_Bones(SubControl_Def_Brazo_L[i], Base_Brazo_L[i].head, Base_Brazo_L[i].tail, Base_Brazo_L[i].roll,
                                         Base_Brazo_L[0].length / 4, tengo_length = True)
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                            Posicionar_Bones(SubControl_Def_Brazo_R[i], Base_Brazo_R[i].head, Base_Brazo_R[i].tail, Base_Brazo_R[i].roll,
                                         Base_Brazo_R[0].length / 4, tengo_length = True)
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                    pocioner_Bones_tail(SubControl_Def_Brazo_L[2], Base_Brazo_L[1].head,  Base_Brazo_L[1].tail, 
                                         Base_Brazo_L[1].roll,  Base_Brazo_L[0].length / 4, tengo_length = True)
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                    pocioner_Bones_tail(SubControl_Def_Brazo_R[2], Base_Brazo_R[1].head,  Base_Brazo_R[1].tail, 
                                         Base_Brazo_R[1].roll,  Base_Brazo_R[0].length / 4, tengo_length = True)
                #Control_FK_Brazo_L or Control_FK_Brazo_R
                Control_FK_Brazo_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                    Encontral_Bones("Control_FK_Brazo_L", 3, Control_FK_Brazo_L)
                Control_FK_Brazo_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                    Encontral_Bones("Control_FK_Brazo_R", 3, Control_FK_Brazo_R)
                if Control_FK_Brazo_L or Control_FK_Brazo_R:
                    for i in range(3):
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                            Posicionar_Bones(Control_FK_Brazo_L[i], Base_Brazo_L[i].head, Base_Brazo_L[i].tail, Base_Brazo_L[i].roll,
                                         Base_Brazo_L[i].length, tengo_length = False)
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):    
                            Posicionar_Bones(Control_FK_Brazo_R[i], Base_Brazo_R[i].head, Base_Brazo_R[i].tail, Base_Brazo_R[i].roll,
                                         Base_Brazo_R[i].length, tengo_length = False)
                #Control_IK_Brazo_L or Control_IK_Brazo_R
                Control_IK_Brazo_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                    Encontral_Bones("Control_IK_Brazo_L", 3, Control_IK_Brazo_L)
                Control_IK_Brazo_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                    Encontral_Bones("Control_IK_Brazo_R", 3, Control_IK_Brazo_R)
                if Control_IK_Brazo_L or Control_IK_Brazo_R:
                    for i in range(3):
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                            Posicionar_Bones(Control_IK_Brazo_L[i], Base_Brazo_L[i].head, Base_Brazo_L[i].tail, Base_Brazo_L[i].roll,
                                         Base_Brazo_L[i].length, tengo_length = False)
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                            Posicionar_Bones(Control_IK_Brazo_R[i], Base_Brazo_R[i].head, Base_Brazo_R[i].tail, Base_Brazo_R[i].roll,
                                         Base_Brazo_R[i].length, tengo_length = False)
                #SubControl_IK_Brazo_L or SubControl_IK_Brazo_R
                SubControl_IK_Brazo_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                    Encontral_Bones("SubControl_IK_Brazo_L", 4, SubControl_IK_Brazo_L)
                SubControl_IK_Brazo_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                    Encontral_Bones("SubControl_IK_Brazo_R", 4, SubControl_IK_Brazo_R)
                if SubControl_IK_Brazo_L or SubControl_IK_Brazo_L:
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                        for i in range(2):
                            Posicionar_Bones(SubControl_IK_Brazo_L[i], Base_Brazo_L[0].head, Base_Brazo_L[2].head, Base_Brazo_L[0].roll,
                                             Base_Brazo_L[0].length / 2, tengo_length = True)
                        if SubControl_IK_Brazo_L[2]:
                            SubControl_IK_Brazo_L[2].head = Base_Brazo_L[1].head
                            Pocion_Normal = Base_Brazo_L[0].z_axis.normalized()
                            Pocion_Normal_1 = Base_Brazo_L[1].z_axis.normalized()
                            Normales = (Pocion_Normal + Pocion_Normal_1) / 2
                            SubControl_IK_Brazo_L[2].tail = Base_Brazo_L[1].head + (Normales * -1)
                            SubControl_IK_Brazo_L[2].length = 2
                            new_head = (SubControl_IK_Brazo_L[2].head + SubControl_IK_Brazo_L[2].tail) / 2
                            SubControl_IK_Brazo_L[2].head = new_head
                            SubControl_IK_Brazo_L[2].length = SubControl_IK_Brazo_L[0].length
                        Posicionar_Bones(SubControl_IK_Brazo_L[3], Base_Brazo_L[2].head, Base_Brazo_L[2].tail, Base_Brazo_L[2].roll,
                                             Base_Brazo_L[2].length / 2, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                        for i in range(2):
                            Posicionar_Bones(SubControl_IK_Brazo_R[i], Base_Brazo_R[0].head, Base_Brazo_R[2].tail, Base_Brazo_R[0].roll,
                                             Base_Brazo_R[0].length / 2, tengo_length = True)
                        if SubControl_IK_Brazo_R[2]:
                            SubControl_IK_Brazo_R[2].head = Base_Brazo_R[1].head
                            Pocion_Normal = Base_Brazo_R[0].z_axis.normalized()
                            Pocion_Normal_1 = Base_Brazo_R[1].z_axis.normalized()
                            Normales = (Pocion_Normal + Pocion_Normal_1) / 2
                            SubControl_IK_Brazo_R[2].tail = Base_Brazo_R[1].head + (Normales * -1)
                            SubControl_IK_Brazo_R[2].length = 2
                            new_head = (SubControl_IK_Brazo_R[2].head + SubControl_IK_Brazo_R[2].tail) / 2
                            SubControl_IK_Brazo_R[2].head = new_head
                            SubControl_IK_Brazo_R[2].length = SubControl_IK_Brazo_R[0].length
                        Posicionar_Bones(SubControl_IK_Brazo_R[3], Base_Brazo_R[2].head, Base_Brazo_R[2].tail, Base_Brazo_R[2].roll,
                                             Base_Brazo_R[2].length / 2, tengo_length = True)
                #SUbDef_Brazo_UP_L or SUbDef_Brazo_UP_R
                SUbDef_Brazo_UP_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                    Encontral_Bones("SUbDef_Brazo_UP_L", 4, SUbDef_Brazo_UP_L)    
                SUbDef_Brazo_UP_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                    Encontral_Bones("SUbDef_Brazo_UP_R", 4, SUbDef_Brazo_UP_R)   
                if SUbDef_Brazo_UP_L or SUbDef_Brazo_UP_R:
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(SUbDef_Brazo_UP_L[0], Base_Brazo_L[0].head, Base_Brazo_L[0].tail, Base_Brazo_L[0].roll,
                                     Base_Brazo_L[0].length / 8, tengo_length = True)
                        Posicionar_Bones(SUbDef_Brazo_UP_L[1], (Base_Brazo_L[0].head + Base_Brazo_L[0].tail) / 2, 
                                        Base_Brazo_L[0].tail, Base_Brazo_L[0].roll,
                                        Base_Brazo_L[0].length / 8, tengo_length = True)
                        for i in range(2):
                            pocioner_Bones_tail(SUbDef_Brazo_UP_L[i+2], Base_Brazo_L[0].head, Base_Brazo_L[0].tail, 
                                                Base_Brazo_L[0].roll, Base_Brazo_L[0].length / 8, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(SUbDef_Brazo_UP_R[0], Base_Brazo_R[0].head, Base_Brazo_R[0].tail, Base_Brazo_R[0].roll,
                                     Base_Brazo_R[0].length / 8, tengo_length = True)
                        Posicionar_Bones(SUbDef_Brazo_UP_R[1], (Base_Brazo_R[0].head + Base_Brazo_R[0].tail) / 2, 
                                        Base_Brazo_R[0].tail, Base_Brazo_R[0].roll,
                                        Base_Brazo_R[0].length / 8, tengo_length = True)
                        for i in range(2):
                            pocioner_Bones_tail(SUbDef_Brazo_UP_R[i+2], Base_Brazo_R[0].head, Base_Brazo_R[0].tail, 
                                                Base_Brazo_R[0].roll, Base_Brazo_R[0].length / 8, tengo_length = True)
                #SUbDef_Brazo_DOWN_L or SUbDef_Brazo_DOWN_R
                SUbDef_Brazo_DOWN_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                    Encontral_Bones("SUbDef_Brazo_DOWN_L", 4, SUbDef_Brazo_DOWN_L)    
                SUbDef_Brazo_DOWN_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                    Encontral_Bones("SUbDef_Brazo_DOWN_R", 4, SUbDef_Brazo_DOWN_R)
                if SUbDef_Brazo_DOWN_L or SUbDef_Brazo_DOWN_R:
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(SUbDef_Brazo_DOWN_L[0], Base_Brazo_L[1].head, Base_Brazo_L[1].tail, Base_Brazo_L[1].roll,
                                     Base_Brazo_L[1].length / 8, tengo_length = True)
                        Posicionar_Bones(SUbDef_Brazo_DOWN_L[1], (Base_Brazo_L[1].head + Base_Brazo_L[1].tail) / 2, 
                                        Base_Brazo_L[1].tail, Base_Brazo_L[1].roll,
                                        Base_Brazo_L[1].length / 8, tengo_length = True)
                        for i in range(2):
                            pocioner_Bones_tail(SUbDef_Brazo_DOWN_L[i+2], Base_Brazo_L[1].head, Base_Brazo_L[1].tail, 
                                                Base_Brazo_L[1].roll, Base_Brazo_L[1].length / 8, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(SUbDef_Brazo_DOWN_R[1], Base_Brazo_R[1].head, Base_Brazo_R[1].tail, Base_Brazo_R[1].roll,
                                     Base_Brazo_R[1].length / 8, tengo_length = True)
                        Posicionar_Bones(SUbDef_Brazo_DOWN_R[1], (Base_Brazo_R[1].head + Base_Brazo_R[1].tail) / 2, 
                                        Base_Brazo_R[1].tail, Base_Brazo_R[1].roll,
                                        Base_Brazo_R[1].length / 8, tengo_length = True)
                        for i in range(2):
                            pocioner_Bones_tail(SUbDef_Brazo_DOWN_R[i+2], Base_Brazo_R[1].head, Base_Brazo_R[1].tail, 
                                                Base_Brazo_R[1].roll, Base_Brazo_R[1].length / 8, tengo_length = True)
                #SUbDef_Mano_L or SUbDef_Mano_R
                SUbDef_Mano_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                    Encontral_Bones("SUbDef_Mano_L", 2, SUbDef_Mano_L)    
                SUbDef_Mano_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                    Encontral_Bones("SUbDef_Mano_R", 2, SUbDef_Mano_R)  
                if  SUbDef_Mano_L or SUbDef_Mano_R:
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_L.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(SUbDef_Mano_L[0], Base_Brazo_L[2].head, Base_Brazo_L[2].tail, Base_Brazo_L[2].roll,
                                     Base_Brazo_L[2].length / 4, tengo_length = True)
                        pocioner_Bones_tail(SUbDef_Mano_L[1], Base_Brazo_L[2].head, Base_Brazo_L[2].tail, 
                                                Base_Brazo_L[2].roll, Base_Brazo_L[2].length / 4, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Brazo_R.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(SUbDef_Mano_R[0], Base_Brazo_R[2].head, Base_Brazo_R[2].tail, Base_Brazo_R[2].roll,
                                     Base_Brazo_R[2].length / 4, tengo_length = True)
                        pocioner_Bones_tail(SUbDef_Mano_R[1], Base_Brazo_R[2].head, Base_Brazo_R[2].tail, 
                                                Base_Brazo_R[2].roll, Base_Brazo_R[2].length / 4, tengo_length = True)
            #DEDOS_BASE     
            Base_Purgar_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_L.{i+1:03}") for i in range(3)):
                Encontral_Bones("Base_Purgar_L", 3, Base_Purgar_L)
            Base_Purgar_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_R.{i+1:03}") for i in range(3)):
                Encontral_Bones("Base_Purgar_R", 3, Base_Purgar_R)
            if Base_Purgar_L or Base_Purgar_R:
                #Def_Purgar_L or Def_Purgar_R
                Def_Purgar_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_L.{i+1:03}") for i in range(3)):
                    Encontral_Bones("Def_Purgar_L", 3, Def_Purgar_L)
                Def_Purgar_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_R.{i+1:03}") for i in range(3)):
                    Encontral_Bones("Def_Purgar_R", 3, Def_Purgar_R)
                if Def_Purgar_L or Def_Purgar_R:
                    for i in range(3):
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_L.{i+1:03}") for i in range(3)):
                            Posicionar_Bones(Def_Purgar_L[i], Base_Purgar_L[i].head, Base_Purgar_L[i].tail, 
                                             Base_Purgar_L[i].roll, Base_Purgar_L[i].length, tengo_length = True)
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_R.{i+1:03}") for i in range(3)):
                            Posicionar_Bones(Def_Purgar_R[i], Base_Purgar_R[i].head, Base_Purgar_R[i].tail, 
                                             Base_Purgar_R[i].roll, Base_Purgar_R[i].length, tengo_length = True)
                #FK_Purgar_L or FK_Purgar_R       
                FK_Purgar_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_L.{i+1:03}") for i in range(3)):
                    Encontral_Bones("FK_Purgar_L", 3, FK_Purgar_L)
                FK_Purgar_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_R.{i+1:03}") for i in range(3)):
                    Encontral_Bones("FK_Purgar_R", 3, FK_Purgar_R)
                if FK_Purgar_L or FK_Purgar_R:
                    for i in range(3):
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_L.{i+1:03}") for i in range(3)):
                            Posicionar_Bones(FK_Purgar_L[i], Base_Purgar_L[i].head, Base_Purgar_L[i].tail, 
                                             Base_Purgar_L[i].roll, Base_Purgar_L[i].length, tengo_length = True)
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_R.{i+1:03}") for i in range(3)):   
                            Posicionar_Bones(FK_Purgar_R[i], Base_Purgar_R[i].head, Base_Purgar_R[i].tail, 
                                             Base_Purgar_R[i].roll, Base_Purgar_R[i].length, tengo_length = True)
                #SudDef_Purgar_L or SudDef_Purgar_R
                SudDef_Purgar_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_L.{i+1:03}") for i in range(3)):
                    Encontral_Bones("SudDef_Purgar_L", 3, SudDef_Purgar_L)
                SudDef_Purgar_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_R.{i+1:03}") for i in range(3)):
                    Encontral_Bones("SudDef_Purgar_R", 3, SudDef_Purgar_R)
                if SudDef_Purgar_L or SudDef_Purgar_R:
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_L.{i+1:03}") for i in range(3)):
                        for i in range(2):
                            Posicionar_Bones(SudDef_Purgar_L[i], Base_Purgar_L[i+1].head, Base_Purgar_L[i+1].tail, 
                                                 Base_Purgar_L[i+1].roll, Base_Purgar_L[i+1].length / 4, tengo_length = True)
                        pocioner_Bones_tail(SudDef_Purgar_L[2], Base_Purgar_L[2].head, Base_Purgar_L[2].tail, 
                                            Base_Purgar_L[2].roll, Base_Purgar_L[2].length / 4, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_R.{i+1:03}") for i in range(3)):  
                        for i in range(2):
                            Posicionar_Bones(SudDef_Purgar_R[i], Base_Purgar_R[i+1].head, Base_Purgar_R[i+1].tail, 
                                                 Base_Purgar_R[i+1].roll, Base_Purgar_R[i+1].length / 4, tengo_length = True) 
                        pocioner_Bones_tail(SudDef_Purgar_R[2], Base_Purgar_R[2].head, Base_Purgar_R[2].tail, 
                                            Base_Purgar_R[2].roll, Base_Purgar_R[2].length / 4, tengo_length = True)
                #SubFK_Purgar_L or SubFK_Purgar_R
                SubFK_Purgar_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_L.{i+1:03}") for i in range(3)):
                    Encontral_Bones("SubFK_Purgar_L", 2, SubFK_Purgar_L)
                SubFK_Purgar_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_R.{i+1:03}") for i in range(3)):
                    Encontral_Bones("SubFK_Purgar_R", 2, SubFK_Purgar_R)
                if SubFK_Purgar_L or SubFK_Purgar_R:
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_L.{i+1:03}") for i in range(3)):
                        Posicionar_Bones(SubFK_Purgar_L[0], Base_Purgar_L[1].head, Base_Purgar_L[1].tail, 
                                        Base_Purgar_L[1].roll, Base_Purgar_L[1].length / 2, tengo_length = True)
                        Posicionar_Bones(SubFK_Purgar_L[1], Base_Purgar_L[1].head, Base_Purgar_L[1].tail, 
                                        Base_Purgar_L[1].roll, (Base_Purgar_L[1].length + Base_Purgar_L[2].length), tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Purgar_R.{i+1:03}") for i in range(3)):  
                        Posicionar_Bones(SubFK_Purgar_R[0], Base_Purgar_R[1].head, Base_Purgar_R[1].tail, 
                                        Base_Purgar_R[1].roll, Base_Purgar_R[1].length / 2, tengo_length = True)
                        Posicionar_Bones(SubFK_Purgar_R[1], Base_Purgar_R[1].head, Base_Purgar_R[1].tail, 
                                        Base_Purgar_R[1].roll, (Base_Purgar_R[1].length + Base_Purgar_R[2].length), tengo_length = True)
            Base_Indice_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("Base_Indice_L", 4, Base_Indice_L)
            Base_Indice_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("Base_Indice_R", 4, Base_Indice_R)
            if Base_Indice_L or Base_Indice_R:
                #Def_Indice_L or Def_Indice_R
                Def_Indice_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("Def_Indice_L", 4, Def_Indice_L)
                Def_Indice_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("Def_Indice_R", 4, Def_Indice_R)
                if Def_Indice_L or Def_Indice_R:
                    for i in range(4):
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_L.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(Def_Indice_L[i], Base_Indice_L[i].head, Base_Indice_L[i].tail, 
                                             Base_Indice_L[i].roll, Base_Indice_L[i].length, tengo_length = True)
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_R.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(Def_Indice_R[i], Base_Indice_R[i].head, Base_Indice_R[i].tail, 
                                             Base_Indice_R[i].roll, Base_Indice_R[i].length, tengo_length = True)
                #FK_Indice_L or FK_Indice_R       
                FK_Indice_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("FK_Indice_L", 4, FK_Indice_L)
                FK_Indice_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("FK_Indice_R", 4, FK_Indice_R)
                if FK_Indice_L or FK_Indice_R:
                    for i in range(4):
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_L.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(FK_Indice_L[i], Base_Indice_L[i].head, Base_Indice_L[i].tail, 
                                             Base_Indice_L[i].roll, Base_Indice_L[i].length, tengo_length = True)
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_R.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(FK_Indice_R[i], Base_Indice_R[i].head, Base_Indice_R[i].tail, 
                                             Base_Indice_R[i].roll, Base_Indice_R[i].length, tengo_length = True)
                #SudDef_Indice_L or SudDef_Indice_R
                SudDef_Indice_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SudDef_Indice_L", 4, SudDef_Indice_L)
                SudDef_Indice_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SudDef_Indice_R", 4, SudDef_Indice_R)
                if SudDef_Indice_L or SudDef_Indice_R:
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_L.{i+1:03}") for i in range(4)):
                        for i in range(3):
                            Posicionar_Bones(SudDef_Indice_L[i], Base_Indice_L[i+1].head, Base_Indice_L[i+1].tail, 
                                                 Base_Indice_L[i+1].roll, Base_Indice_L[i+1].length / 4, tengo_length = True)
                        pocioner_Bones_tail(SudDef_Indice_L[3], Base_Indice_L[3].head, Base_Indice_L[3].tail, 
                                            Base_Indice_L[3].roll, Base_Indice_L[3].length / 4, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_R.{i+1:03}") for i in range(4)):
                        for i in range(3):
                            Posicionar_Bones(SudDef_Indice_R[i], Base_Indice_R[i+1].head, Base_Indice_R[i+1].tail, 
                                                 Base_Indice_R[i+1].roll, Base_Indice_R[i+1].length / 4, tengo_length = True) 
                        pocioner_Bones_tail(SudDef_Indice_R[3], Base_Indice_R[3].head, Base_Indice_R[3].tail, 
                                            Base_Indice_R[3].roll, Base_Indice_R[3].length / 4, tengo_length = True)
                #SubFK_Indice_L or SubFK_Indice_R
                SubFK_Indice_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SubFK_Indice_L", 2, SubFK_Indice_L)
                SubFK_Indice_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SubFK_Indice_R", 2, SubFK_Indice_R)
                if SubFK_Indice_L or SubFK_Indice_R:
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(SubFK_Indice_L[0], Base_Indice_L[1].head, Base_Indice_L[1].tail, 
                                        Base_Indice_L[1].roll, Base_Indice_L[1].length / 2, tengo_length = True)
                        Posicionar_Bones(SubFK_Indice_L[1], Base_Indice_L[1].head, Base_Indice_L[1].tail, 
                                        Base_Indice_L[1].roll, (Base_Indice_L[1].length + 
                                                                Base_Indice_L[2].length +
                                                                Base_Indice_L[3].length 
                                                                ), tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Indice_R.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(SubFK_Indice_R[0], Base_Indice_R[1].head, Base_Indice_R[1].tail, 
                                        Base_Indice_R[1].roll, Base_Indice_R[1].length / 2, tengo_length = True)
                        Posicionar_Bones(SubFK_Indice_R[1], Base_Indice_R[1].head, Base_Indice_R[1].tail, 
                                        Base_Indice_R[1].roll, (Base_Indice_R[1].length + 
                                                                Base_Indice_R[2].length +
                                                                Base_Indice_R[3].length 
                                                                ), tengo_length = True)
            Base_Corazon_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("Base_Corazon_L", 4, Base_Corazon_L)
            Base_Corazon_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("Base_Corazon_R", 4, Base_Corazon_R)
            if Base_Corazon_L or Base_Corazon_R:
                #Def_Corazon_L or Def_Corazon_R
                Def_Corazon_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("Def_Corazon_L", 4, Def_Corazon_L)
                Def_Corazon_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("Def_Corazon_R", 4, Def_Corazon_R)
                if Def_Corazon_L or Def_Corazon_R:
                    for i in range(4):
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_L.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(Def_Corazon_L[i], Base_Corazon_L[i].head, Base_Corazon_L[i].tail, 
                                             Base_Corazon_L[i].roll, Base_Corazon_L[i].length, tengo_length = True)
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_R.{i+1:03}") for i in range(4)):   
                            Posicionar_Bones(Def_Corazon_R[i], Base_Corazon_R[i].head, Base_Corazon_R[i].tail, 
                                             Base_Corazon_R[i].roll, Base_Corazon_R[i].length, tengo_length = True)
                #FK_Corazon_L or FK_Corazon_R       
                FK_Corazon_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("FK_Corazon_L", 4, FK_Corazon_L)
                FK_Corazon_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("FK_Corazon_R", 4, FK_Corazon_R)
                if FK_Corazon_L or FK_Corazon_R:
                    for i in range(4):
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_L.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(FK_Corazon_L[i], Base_Corazon_L[i].head, Base_Corazon_L[i].tail, 
                                             Base_Corazon_L[i].roll, Base_Corazon_L[i].length, tengo_length = True)
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_R.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(FK_Corazon_R[i], Base_Corazon_R[i].head, Base_Corazon_R[i].tail, 
                                             Base_Corazon_R[i].roll, Base_Corazon_R[i].length, tengo_length = True)
                #SudDef_Corazon_L or SudDef_Corazon_R
                SudDef_Corazon_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SudDef_Corazon_L", 4, SudDef_Corazon_L)
                SudDef_Corazon_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SudDef_Corazon_R", 4, SudDef_Corazon_R)
                if SudDef_Corazon_L or SudDef_Corazon_R:
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_L.{i+1:03}") for i in range(4)):
                        for i in range(3):
                            Posicionar_Bones(SudDef_Corazon_L[i], Base_Corazon_L[i+1].head, Base_Corazon_L[i+1].tail, 
                                                 Base_Corazon_L[i+1].roll, Base_Corazon_L[i+1].length / 4, tengo_length = True)
                        pocioner_Bones_tail(SudDef_Corazon_L[3], Base_Corazon_L[3].head, Base_Corazon_L[3].tail, 
                                            Base_Corazon_L[3].roll, Base_Corazon_L[3].length / 4, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_R.{i+1:03}") for i in range(4)):    
                        for i in range(3):
                            Posicionar_Bones(SudDef_Corazon_R[i], Base_Corazon_R[i+1].head, Base_Corazon_R[i+1].tail, 
                                                 Base_Corazon_R[i+1].roll, Base_Corazon_R[i+1].length / 4, tengo_length = True) 
                        pocioner_Bones_tail(SudDef_Corazon_R[3], Base_Corazon_R[3].head, Base_Corazon_R[3].tail, 
                                            Base_Corazon_R[3].roll, Base_Corazon_R[3].length / 4, tengo_length = True)
                #SubFK_Corazon_L or SubFK_Corazon_R
                SubFK_Corazon_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SubFK_Corazon_L", 2, SubFK_Corazon_L)
                SubFK_Corazon_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SubFK_Corazon_R", 2, SubFK_Corazon_R)
                if SubFK_Corazon_L or SubFK_Corazon_R:
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(SubFK_Corazon_L[0], Base_Corazon_L[1].head, Base_Corazon_L[1].tail, 
                                        Base_Corazon_L[1].roll, Base_Corazon_L[1].length / 2, tengo_length = True)
                        Posicionar_Bones(SubFK_Corazon_L[1], Base_Corazon_L[1].head, Base_Corazon_L[1].tail, 
                                        Base_Corazon_L[1].roll, (Base_Corazon_L[1].length+
                                                                 Base_Corazon_L[2].length+
                                                                 Base_Corazon_L[3].length), tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Corazon_R.{i+1:03}") for i in range(4)):    
                        Posicionar_Bones(SubFK_Corazon_R[0], Base_Corazon_R[1].head, Base_Corazon_R[1].tail, 
                                        Base_Corazon_R[1].roll, Base_Corazon_R[1].length / 2, tengo_length = True)
                        Posicionar_Bones(SubFK_Corazon_R[1], Base_Corazon_R[1].head, Base_Corazon_R[1].tail, 
                                        Base_Corazon_R[1].roll, (Base_Corazon_R[1].length+
                                                                 Base_Corazon_R[2].length+
                                                                 Base_Corazon_R[3].length), tengo_length = True)
            Base_Anular_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("Base_Anular_L", 4, Base_Anular_L)
            Base_Anular_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("Base_Anular_R", 4, Base_Anular_R)
            if Base_Anular_L or Base_Anular_R:
                #Def_Anular_L or Def_Anular_R
                Def_Anular_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("Def_Anular_L", 4, Def_Anular_L)
                Def_Anular_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("Def_Anular_R", 4, Def_Anular_R)
                if Def_Anular_L or Def_Anular_R:
                    for i in range(4):
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_L.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(Def_Anular_L[i], Base_Anular_L[i].head, Base_Anular_L[i].tail, 
                                             Base_Anular_L[i].roll, Base_Anular_L[i].length, tengo_length = True)
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_R.{i+1:03}") for i in range(4)): 
                            Posicionar_Bones(Def_Anular_R[i], Base_Anular_R[i].head, Base_Anular_R[i].tail, 
                                             Base_Anular_R[i].roll, Base_Anular_R[i].length, tengo_length = True)
                #FK_Anular_L or FK_Anular_R       
                FK_Anular_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("FK_Anular_L", 4, FK_Anular_L)
                FK_Anular_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("FK_Anular_R", 4, FK_Anular_R)
                if FK_Anular_L or FK_Anular_R:
                    for i in range(4):
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_L.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(FK_Anular_L[i], Base_Anular_L[i].head, Base_Anular_L[i].tail, 
                                             Base_Anular_L[i].roll, Base_Anular_L[i].length, tengo_length = True)
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_R.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(FK_Anular_R[i], Base_Anular_R[i].head, Base_Anular_R[i].tail, 
                                             Base_Anular_R[i].roll, Base_Anular_R[i].length, tengo_length = True)
                #SudDef_Anular_L or SudDef_Anular_R
                SudDef_Anular_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SudDef_Anular_L", 4, SudDef_Anular_L)
                SudDef_Anular_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SudDef_Anular_R", 4, SudDef_Anular_R)
                if SudDef_Anular_L or SudDef_Anular_R:
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_L.{i+1:03}") for i in range(4)):
                        for i in range(3):
                            Posicionar_Bones(SudDef_Anular_L[i], Base_Anular_L[i+1].head, Base_Anular_L[i+1].tail, 
                                                 Base_Anular_L[i+1].roll, Base_Anular_L[i+1].length / 4, tengo_length = True)
                        pocioner_Bones_tail(SudDef_Anular_L[3], Base_Anular_L[3].head, Base_Anular_L[3].tail, 
                                            Base_Anular_L[3].roll, Base_Anular_L[3].length / 4, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_R.{i+1:03}") for i in range(4)):   
                        for i in range(3):
                            Posicionar_Bones(SudDef_Anular_R[i], Base_Anular_R[i+1].head, Base_Anular_R[i+1].tail, 
                                                 Base_Anular_R[i+1].roll, Base_Anular_R[i+1].length / 4, tengo_length = True) 
                        pocioner_Bones_tail(SudDef_Anular_R[3], Base_Anular_R[3].head, Base_Anular_R[3].tail, 
                                            Base_Anular_R[3].roll, Base_Anular_R[3].length / 4, tengo_length = True)
                #SubFK_Anular_L or SubFK_Anular_R
                SubFK_Anular_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SubFK_Anular_L", 2, SubFK_Anular_L)
                SubFK_Anular_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SubFK_Anular_R", 2, SubFK_Anular_R)
                if SubFK_Anular_L or SubFK_Anular_R:
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(SubFK_Anular_L[0], Base_Anular_L[1].head, Base_Anular_L[1].tail, 
                                        Base_Anular_L[1].roll, Base_Anular_L[1].length / 2, tengo_length = True)
                        Posicionar_Bones(SubFK_Anular_L[1], Base_Anular_L[1].head, Base_Anular_L[1].tail, 
                                        Base_Anular_L[1].roll, (Base_Anular_L[1].length+
                                                                Base_Anular_L[2].length+
                                                                Base_Anular_L[3].length), tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Anular_R.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(SubFK_Anular_R[0], Base_Anular_R[1].head, Base_Anular_R[1].tail, 
                                        Base_Anular_R[1].roll, Base_Anular_R[1].length / 2, tengo_length = True)
                        Posicionar_Bones(SubFK_Anular_R[1], Base_Anular_R[1].head, Base_Anular_R[1].tail, 
                                        Base_Anular_R[1].roll, (Base_Anular_R[1].length+
                                                                Base_Anular_R[2].length+
                                                                Base_Anular_R[3].length), tengo_length = True)
            Base_Miñique_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("Base_Miñique_L", 4, Base_Miñique_L)
            Base_Miñique_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("Base_Miñique_R", 4, Base_Miñique_R) 
            if Base_Miñique_L or Base_Miñique_R:
                #Def_Miñique_L or Def_Miñique_R
                Def_Miñique_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("Def_Miñique_L", 4, Def_Miñique_L)
                Def_Miñique_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("Def_Miñique_R", 4, Def_Miñique_R)
                if Def_Miñique_L or Def_Miñique_R:
                    for i in range(4):
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_L.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(Def_Miñique_L[i], Base_Miñique_L[i].head, Base_Miñique_L[i].tail, 
                                             Base_Miñique_L[i].roll, Base_Miñique_L[i].length, tengo_length = True)
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_R.{i+1:03}") for i in range(4)):    
                            Posicionar_Bones(Def_Miñique_R[i], Base_Miñique_R[i].head, Base_Miñique_R[i].tail, 
                                             Base_Miñique_R[i].roll, Base_Miñique_R[i].length, tengo_length = True)
                #FK_Miñique_L or FK_Miñique_R       
                FK_Miñique_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("FK_Miñique_L", 4, FK_Miñique_L)
                FK_Miñique_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("FK_Miñique_R", 4, FK_Miñique_R)
                if FK_Miñique_L or FK_Miñique_R:
                    for i in range(4):
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_L.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(FK_Miñique_L[i], Base_Miñique_L[i].head, Base_Miñique_L[i].tail, 
                                             Base_Miñique_L[i].roll, Base_Miñique_L[i].length, tengo_length = True)
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_R.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(FK_Miñique_R[i], Base_Miñique_R[i].head, Base_Miñique_R[i].tail, 
                                             Base_Miñique_R[i].roll, Base_Miñique_R[i].length, tengo_length = True)
                #SudDef_Miñique_L or SudDef_Miñique_R
                SudDef_Miñique_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SudDef_Miñique_L", 4, SudDef_Miñique_L)
                SudDef_Miñique_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SudDef_Miñique_R", 4, SudDef_Miñique_R)
                if SudDef_Miñique_L or SudDef_Miñique_R:
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_L.{i+1:03}") for i in range(4)):
                        for i in range(3):
                            Posicionar_Bones(SudDef_Miñique_L[i], Base_Miñique_L[i+1].head, Base_Miñique_L[i+1].tail, 
                                                 Base_Miñique_L[i+1].roll, Base_Miñique_L[i+1].length / 4, tengo_length = True)
                        pocioner_Bones_tail(SudDef_Miñique_L[3], Base_Miñique_L[3].head, Base_Miñique_L[3].tail, 
                                            Base_Miñique_L[3].roll, Base_Miñique_L[3].length / 4, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_R.{i+1:03}") for i in range(4)):
                        for i in range(3):
                            Posicionar_Bones(SudDef_Miñique_R[i], Base_Miñique_R[i+1].head, Base_Miñique_R[i+1].tail, 
                                                 Base_Miñique_R[i+1].roll, Base_Miñique_R[i+1].length / 4, tengo_length = True) 
                        pocioner_Bones_tail(SudDef_Miñique_R[3], Base_Miñique_R[3].head, Base_Miñique_R[3].tail, 
                                            Base_Miñique_R[3].roll, Base_Miñique_R[3].length / 4, tengo_length = True)
                #SubFK_Miñique_L or SubFK_Miñique_R
                SubFK_Miñique_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SubFK_Miñique_L", 2, SubFK_Miñique_L)
                SubFK_Miñique_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SubFK_Miñique_R", 2, SubFK_Miñique_R)
                if SubFK_Miñique_L or SubFK_Miñique_R:
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(SubFK_Miñique_L[0], Base_Miñique_L[1].head, Base_Miñique_L[1].tail, 
                                        Base_Miñique_L[1].roll, Base_Miñique_L[1].length / 2, tengo_length = True)
                        Posicionar_Bones(SubFK_Miñique_L[1], Base_Miñique_L[1].head, Base_Miñique_L[1].tail, 
                                        Base_Miñique_L[1].roll, (Base_Miñique_L[1].length+
                                                                 Base_Miñique_L[2].length+
                                                                 Base_Miñique_L[3].length), tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Miñique_R.{i+1:03}") for i in range(4)):  
                        Posicionar_Bones(SubFK_Miñique_R[0], Base_Miñique_R[1].head, Base_Miñique_R[1].tail, 
                                        Base_Miñique_R[1].roll, Base_Miñique_R[1].length / 2, tengo_length = True)
                        Posicionar_Bones(SubFK_Miñique_R[1], Base_Miñique_R[1].head, Base_Miñique_R[1].tail, 
                                        Base_Miñique_R[1].roll, (Base_Miñique_R[1].length+
                                                                 Base_Miñique_R[2].length+
                                                                 Base_Miñique_R[3].length), tengo_length = True)
            #Base_Pierna_L or Base_Pierna_R
            Base_Pierna_L = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                Encontral_Bones("Base_Pierna_L", 4, Base_Pierna_L)
            Base_Pierna_R = []
            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                Encontral_Bones("Base_Pierna_R", 4, Base_Pierna_R)
            if Base_Pierna_L or Base_Pierna_R:
                #Root_Pierna_L or Root_Pierna_R
                Root_Pierna_L = Bones_get.get("Root_Pierna_L")
                Root_Pierna_R = Bones_get.get("Root_Pierna_R")
                if Root_Pierna_L or Root_Pierna_R:
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):    
                        Posicionar_Bones(
                            Root_Pierna_L, 
                            Base_Pierna_L[0].head, 
                            Base_Pierna_L[0].tail, 
                            Base_Pierna_L[0].roll, 
                            Base_Pierna_L[0].length / 2, 
                            tengo_length = True
                            )
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(
                            Root_Pierna_R, 
                            Base_Pierna_R[0].head, 
                            Base_Pierna_R[0].tail, 
                            Base_Pierna_R[0].roll, 
                            Base_Pierna_R[0].length / 2, 
                            tengo_length = True
                            )
                #SUbDef_Pierna_UP_L or SUbDef_Pierna_UP_R
                SUbDef_Pierna_UP_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SUbDef_Pierna_UP_L", 4, SUbDef_Pierna_UP_L)
                SUbDef_Pierna_UP_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SUbDef_Pierna_UP_R", 4, SUbDef_Pierna_UP_R)
                if SUbDef_Pierna_UP_L or SUbDef_Pierna_UP_R:
                    #L
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(
                            SUbDef_Pierna_UP_L[0], 
                            Base_Pierna_L[0].head, 
                            ((Base_Pierna_L[0].tail + Base_Pierna_L[0].head) / 2), 
                            Base_Pierna_L[0].roll, 
                            Base_Pierna_L[0].length / 8, 
                            tengo_length = True
                            )
                        Posicionar_Bones(
                            SUbDef_Pierna_UP_L[1], 
                            ((Base_Pierna_L[0].tail + Base_Pierna_L[0].head) / 2), 
                            Base_Pierna_L[0].tail, 
                            Base_Pierna_L[0].roll, 
                            Base_Pierna_L[0].length / 8, 
                            tengo_length = True
                            )
                        for i in range(2):  
                            pocioner_Bones_tail(
                                SUbDef_Pierna_UP_L[i + 2], 
                                Base_Pierna_L[0].head, 
                                Base_Pierna_L[0].tail, 
                                Base_Pierna_L[0].roll, 
                                Base_Pierna_L[0].length / 8, 
                                tengo_length = True
                                )
                        #R 
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):  
                        Posicionar_Bones(
                            SUbDef_Pierna_UP_R[0], 
                            Base_Pierna_R[0].head, 
                            ((Base_Pierna_R[0].tail + Base_Pierna_R[0].head) / 2), 
                            Base_Pierna_R[0].roll, 
                            Base_Pierna_R[0].length / 8, 
                            tengo_length = True
                            )
                        Posicionar_Bones(
                            SUbDef_Pierna_UP_R[1], 
                            ((Base_Pierna_R[0].tail + Base_Pierna_R[0].head) / 2), 
                            Base_Pierna_R[0].tail, 
                            Base_Pierna_R[0].roll, 
                            Base_Pierna_R[0].length / 8, 
                            tengo_length = True
                            )
                        for i in range(2):  
                            pocioner_Bones_tail(
                                SUbDef_Pierna_UP_R[i + 2], 
                                Base_Pierna_R[0].head, 
                                Base_Pierna_R[0].tail, 
                                Base_Pierna_R[0].roll, 
                                Base_Pierna_R[0].length / 8, 
                                tengo_length = True
                                )
                #SUbDef_Pierna_DOWN_L or SUbDef_Pierna_DOWN_R
                SUbDef_Pierna_DOWN_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SUbDef_Pierna_DOWN_L", 4, SUbDef_Pierna_DOWN_L)
                SUbDef_Pierna_DOWN_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SUbDef_Pierna_DOWN_R", 4, SUbDef_Pierna_DOWN_R)
                if SUbDef_Pierna_DOWN_L or SUbDef_Pierna_DOWN_R:
                    #L
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(
                            SUbDef_Pierna_DOWN_L[0], 
                            Base_Pierna_L[1].head, 
                            ((Base_Pierna_L[1].tail + Base_Pierna_L[1].head) / 2), 
                            Base_Pierna_L[1].roll, 
                            Base_Pierna_L[1].length / 8, 
                            tengo_length = True
                            )
                        Posicionar_Bones(
                            SUbDef_Pierna_DOWN_L[1], 
                            ((Base_Pierna_L[1].tail + Base_Pierna_L[1].head) / 2), 
                            Base_Pierna_L[1].tail, 
                            Base_Pierna_L[1].roll, 
                            Base_Pierna_L[1].length / 8, 
                            tengo_length = True
                            )
                        for i in range(2):  
                            pocioner_Bones_tail(
                                SUbDef_Pierna_DOWN_L[i + 2], 
                                Base_Pierna_L[1].head, 
                                Base_Pierna_L[1].tail, 
                                Base_Pierna_L[1].roll, 
                                Base_Pierna_L[1].length / 8, 
                                tengo_length = True
                                )
                    #R 
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):        
                        Posicionar_Bones(
                            SUbDef_Pierna_DOWN_R[0], 
                            Base_Pierna_R[1].head, 
                            ((Base_Pierna_R[1].tail + Base_Pierna_R[1].head) / 2), 
                            Base_Pierna_R[1].roll, 
                            Base_Pierna_R[1].length / 8, 
                            tengo_length = True
                            )
                        Posicionar_Bones(
                            SUbDef_Pierna_DOWN_R[1], 
                            ((Base_Pierna_R[1].tail + Base_Pierna_R[1].head) / 2), 
                            Base_Pierna_R[1].tail, 
                            Base_Pierna_R[1].roll, 
                            Base_Pierna_R[1].length / 8, 
                            tengo_length = True
                            )
                        for i in range(2):  
                            pocioner_Bones_tail(
                                SUbDef_Pierna_DOWN_R[i + 2], 
                                Base_Pierna_R[1].head, 
                                Base_Pierna_R[1].tail, 
                                Base_Pierna_R[1].roll, 
                                Base_Pierna_R[1].length / 8, 
                                tengo_length = True
                                )
                #SUbDef_Pie_L or SUbDef_Pie_R
                SUbDef_Pie_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SUbDef_Pie_L", 3, SUbDef_Pie_L)
                SUbDef_Pie_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SUbDef_Pie_R", 3, SUbDef_Pie_R)
                if SUbDef_Pie_L or SUbDef_Pie_R:
                    #L
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                        for i in range(2):
                            Posicionar_Bones(
                                SUbDef_Pie_L[i], 
                                Base_Pierna_L[i+2].head, 
                                Base_Pierna_L[i+2].tail, 
                                Base_Pierna_L[i+2].roll, 
                                Base_Pierna_L[i+2].length / 4, 
                                tengo_length = True
                                )
                        pocioner_Bones_tail(
                            SUbDef_Pie_L[2], 
                            Base_Pierna_L[3].head, 
                            Base_Pierna_L[3].tail, 
                            Base_Pierna_L[3].roll, 
                            Base_Pierna_L[3].length / 4, 
                            tengo_length = True
                            )
                    #R
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                        for i in range(2):
                            Posicionar_Bones(
                                SUbDef_Pie_R[i], 
                                Base_Pierna_R[i+2].head, 
                                Base_Pierna_R[i+2].tail, 
                                Base_Pierna_R[i+2].roll, 
                                Base_Pierna_R[i+2].length / 4, 
                                tengo_length = True
                                )
                        pocioner_Bones_tail(
                            SUbDef_Pie_R[2], 
                            Base_Pierna_R[3].head, 
                            Base_Pierna_R[3].tail, 
                            Base_Pierna_R[3].roll, 
                            Base_Pierna_R[3].length / 4, 
                            tengo_length = True
                            )
                #Def_Pierna_UP_L or Def_Pierna_UP_L
                Def_Pierna_UP_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("Def_Pierna_UP_L", 2, Def_Pierna_UP_L)
                Def_Pierna_UP_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("Def_Pierna_UP_R", 2, Def_Pierna_UP_R)
                if Def_Pierna_UP_L or Def_Pierna_UP_R:
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(Def_Pierna_UP_L[0], Base_Pierna_L[0].head, (Base_Pierna_L[0].head + Base_Pierna_L[0].tail) / 2, 
                                         Base_Pierna_L[0].roll, Base_Pierna_L[0].length, tengo_length = False)
                        Posicionar_Bones(Def_Pierna_UP_L[1], (Base_Pierna_L[0].head + Base_Pierna_L[0].tail) / 2, Base_Pierna_L[0].tail , 
                                         Base_Pierna_L[0].roll, Base_Pierna_L[0].length, tengo_length = False)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(Def_Pierna_UP_R[0], Base_Pierna_R[0].head, (Base_Pierna_R[0].head + Base_Pierna_R[0].tail) / 2, 
                                         Base_Pierna_R[0].roll, Base_Pierna_R[0].length, tengo_length = False)
                        Posicionar_Bones(Def_Pierna_UP_R[1], (Base_Pierna_R[0].head + Base_Pierna_R[0].tail) / 2, Base_Pierna_R[0].tail , 
                                         Base_Pierna_R[0].roll, Base_Pierna_R[0].length, tengo_length = False)
                #Def_Pierna_DOWN_L or Def_Pierna_DOWN_L
                Def_Pierna_DOWN_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("Def_Pierna_DOWN_L", 2, Def_Pierna_DOWN_L)
                Def_Pierna_DOWN_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("Def_Pierna_DOWN_R", 2, Def_Pierna_DOWN_R)
                if Def_Pierna_DOWN_L or Def_Pierna_DOWN_R:
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(Def_Pierna_DOWN_L[0], Base_Pierna_L[1].head, (Base_Pierna_L[1].head + Base_Pierna_L[1].tail) / 2, 
                                         Base_Pierna_L[1].roll, Base_Pierna_L[1].length, tengo_length = False)
                        Posicionar_Bones(Def_Pierna_DOWN_L[1], (Base_Pierna_L[1].head + Base_Pierna_L[1].tail) / 2, Base_Pierna_L[1].tail , 
                                         Base_Pierna_L[1].roll, Base_Pierna_L[1].length, tengo_length = False)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(Def_Pierna_DOWN_R[0], Base_Pierna_R[1].head, (Base_Pierna_R[1].head + Base_Pierna_R[1].tail) / 2, 
                                         Base_Pierna_R[1].roll, Base_Pierna_R[1].length, tengo_length = False)
                        Posicionar_Bones(Def_Pierna_DOWN_R[1], (Base_Pierna_R[1].head + Base_Pierna_R[1].tail) / 2, Base_Pierna_R[1].tail , 
                                         Base_Pierna_R[1].roll, Base_Pierna_R[1].length, tengo_length = False)
                #Def_Pie_L or Def_Pie_R
                Def_Pie_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("Def_Pie_L", 2, Def_Pie_L)
                Def_Pie_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("Def_Pie_R", 2, Def_Pie_R)
                if Def_Pie_L or Def_Pie_R:
                    for i in range(2):
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(Def_Pie_L[i], Base_Pierna_L[i+2].head, Base_Pierna_L[i+2].tail, 
                                            Base_Pierna_L[i+2].roll, Base_Pierna_L[i+2].length, tengo_length = False)
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(Def_Pie_R[i], Base_Pierna_R[i+2].head, Base_Pierna_R[i+2].tail, 
                                            Base_Pierna_R[i+2].roll, Base_Pierna_R[i+2].length, tengo_length = False)
                #Base_Talon_L or Base_Talon_R
                Base_Talon_L = Bones_get.get("Base_Talon_L")
                Base_Talon_R = Bones_get.get("Base_Talon_R")
                DefBase_Talon_L = Bones_get.get("DefBase_Talon_L.001")
                DefBase_Talon_R = Bones_get.get("DefBase_Talon_R.001")
                if  Base_Talon_L or Base_Talon_R:
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(DefBase_Talon_L, Base_Talon_L.head, Base_Talon_L.tail, 
                                            Base_Talon_L.roll, Base_Talon_L.length, tengo_length = False)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(DefBase_Talon_R, Base_Talon_R.head, Base_Talon_R.tail, 
                                            Base_Talon_R.roll, Base_Talon_R.length, tengo_length = False)
                #Rot_Pierna_L or Rot_Pierna_R
                Rot_Pierna_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("Rot_Pierna_L", 4, Rot_Pierna_L)
                Rot_Pierna_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("Rot_Pierna_R", 4, Rot_Pierna_R)
                if Rot_Pierna_L or Rot_Pierna_R:
                    for i in range(4):
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(Rot_Pierna_L[i], Base_Pierna_L[i].head, Base_Pierna_L[i].tail, 
                                            Base_Pierna_L[i].roll, Base_Pierna_L[i].length, tengo_length = False)
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(Rot_Pierna_R[i], Base_Pierna_R[i].head, Base_Pierna_R[i].tail, 
                                            Base_Pierna_R[i].roll, Base_Pierna_R[i].length, tengo_length = False)
                #Control_Def_Pierna_L or Control_Def_Pierna_R
                Control_Def_Pierna_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("Control_Def_Pierna_L", 2, Control_Def_Pierna_L)
                Control_Def_Pierna_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("Control_Def_Pierna_R", 2, Control_Def_Pierna_R)
                if Control_Def_Pierna_L or Control_Def_Pierna_R:
                    for i in range(2):
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(Control_Def_Pierna_L[i], Base_Pierna_L[i].head, 
                                            Base_Pierna_L[i].tail, Base_Pierna_L[i].roll, Base_Pierna_L[i].length, tengo_length = False)
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(Control_Def_Pierna_R[i], Base_Pierna_R[i].head, 
                                            Base_Pierna_R[i].tail, Base_Pierna_R[i].roll, Base_Pierna_R[i].length, tengo_length = False)
                #SubControl_Def_Pierna_L or SubControl_Def_Pierna_R
                SubControl_Def_Pierna_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SubControl_Def_Pierna_L", 3, SubControl_Def_Pierna_L)
                SubControl_Def_Pierna_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SubControl_Def_Pierna_R", 3, SubControl_Def_Pierna_R)
                if SubControl_Def_Pierna_L or SubControl_Def_Pierna_R:
                    for i in range(2):
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):  
                            Posicionar_Bones(SubControl_Def_Pierna_L[i], Base_Pierna_L[i].head, 
                                            Base_Pierna_L[i].tail, Base_Pierna_L[i].roll, Base_Pierna_L[i].length / 4, tengo_length = True)
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(SubControl_Def_Pierna_R[i], Base_Pierna_R[i].head, 
                                            Base_Pierna_R[i].tail, Base_Pierna_R[i].roll, Base_Pierna_R[i].length / 4, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                        pocioner_Bones_tail(SubControl_Def_Pierna_L[2], Base_Pierna_L[1].head, 
                                            Base_Pierna_L[1].tail, Base_Pierna_L[1].roll, Base_Pierna_L[1].length / 4, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                        pocioner_Bones_tail(SubControl_Def_Pierna_R[2], Base_Pierna_R[1].head, 
                                            Base_Pierna_R[1].tail, Base_Pierna_R[1].roll, Base_Pierna_R[1].length / 4, tengo_length = True)
                #FK_Pierna_L or FK_Pierna_R
                FK_Pierna_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("FK_Pierna_L", 4, FK_Pierna_L)
                FK_Pierna_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("FK_Pierna_R", 4, FK_Pierna_R)
                if FK_Pierna_L or FK_Pierna_R:
                    for i in range(4):
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(FK_Pierna_L[i], Base_Pierna_L[i].head, Base_Pierna_L[i].tail, 
                                            Base_Pierna_L[i].roll, Base_Pierna_L[i].length, tengo_length = True)
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(FK_Pierna_R[i], Base_Pierna_R[i].head, Base_Pierna_R[i].tail, 
                                            Base_Pierna_R[i].roll, Base_Pierna_R[i].length, tengo_length = True)
                #IK_Pierna_L or IK_Pierna_R
                IK_Pierna_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("IK_Pierna_L", 4, IK_Pierna_L)
                IK_Pierna_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("IK_Pierna_R", 4, IK_Pierna_R)
                if IK_Pierna_L or IK_Pierna_R:
                    for i in range(4):
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(IK_Pierna_L[i], Base_Pierna_L[i].head, Base_Pierna_L[i].tail, 
                                            Base_Pierna_L[i].roll, Base_Pierna_L[i].length, tengo_length = True)
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(IK_Pierna_R[i], Base_Pierna_R[i].head, Base_Pierna_R[i].tail, 
                                            Base_Pierna_R[i].roll, Base_Pierna_R[i].length, tengo_length = True)
                #SudIK_Pierna_L or SudIK_Pierna_R
                SudIK_Pierna_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SudIK_Pierna_L", 5, SudIK_Pierna_L)
                SudIK_Pierna_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("SudIK_Pierna_R", 5, SudIK_Pierna_R)
                if SudIK_Pierna_L or SudIK_Pierna_R:
                    for i in range(2):
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(SudIK_Pierna_L[i], Base_Pierna_L[0].head, Base_Pierna_L[2].head, 
                                            Base_Pierna_L[0].roll, Base_Pierna_L[0].length / 2, tengo_length = True)
                        if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                            Posicionar_Bones(SudIK_Pierna_R[i], Base_Pierna_R[0].head, Base_Pierna_R[2].head, 
                                            Base_Pierna_R[0].roll, Base_Pierna_R[0].length / 2, tengo_length = True)
                        if SudIK_Pierna_L[2] or SudIK_Pierna_R[2]:
                            #L
                            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                                SudIK_Pierna_L[2].head = Base_Pierna_L[1].head
                                Pocion_Normal = Base_Pierna_L[0].z_axis.normalized()
                                Pocion_Normal_1 = Base_Pierna_L[1].z_axis.normalized()
                                Normales = (Pocion_Normal + Pocion_Normal_1) / 2
                                SudIK_Pierna_L[2].tail = Base_Pierna_L[1].head + (Normales * -1)
                                SudIK_Pierna_L[2].length = 2
                                new_head = (SudIK_Pierna_L[2].head + SudIK_Pierna_L[2].tail) / 2
                                SudIK_Pierna_L[2].head = new_head
                                SudIK_Pierna_L[2].length = SudIK_Pierna_L[0].length
                            #R
                            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):   
                                SudIK_Pierna_R[2].head = Base_Pierna_R[1].head
                                Pocion_Normal = Base_Pierna_R[0].z_axis.normalized()
                                Pocion_Normal_1 = Base_Pierna_R[1].z_axis.normalized()
                                Normales = (Pocion_Normal + Pocion_Normal_1) / 2
                                SudIK_Pierna_R[2].tail = Base_Pierna_R[1].head + (Normales * -1)
                                SudIK_Pierna_R[2].length = 2
                                new_head = (SudIK_Pierna_R[2].head + SudIK_Pierna_R[2].tail) / 2
                                SudIK_Pierna_R[2].head = new_head
                                SudIK_Pierna_R[2].length = SudIK_Pierna_R[0].length
                        if SudIK_Pierna_L[3] or SudIK_Pierna_R[3] or SudIK_Pierna_L[4] or SudIK_Pierna_L[4]:
                            #L
                            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                                SudIK_Pierna_L[3].head = Base_Pierna_L[2].head
                                Pocion_Normal = Base_Pierna_L[2].z_axis.normalized()
                                SudIK_Pierna_L[3].tail = Base_Pierna_L[2].head + (Pocion_Normal * -1)
                                SudIK_Pierna_L[3].tail.z = SudIK_Pierna_L[3].head.z
                                SudIK_Pierna_L[3].length = Base_Pierna_L[2].length / 2
                                SudIK_Pierna_L[3].roll = 0 
                            #R
                            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):    
                                SudIK_Pierna_R[3].head = Base_Pierna_R[2].head
                                Pocion_Normal = Base_Pierna_R[2].z_axis.normalized()
                                SudIK_Pierna_R[3].tail = Base_Pierna_R[2].head + (Pocion_Normal * -1)
                                SudIK_Pierna_R[3].tail.z = SudIK_Pierna_R[3].head.z
                                SudIK_Pierna_R[3].length = Base_Pierna_R[2].length / 2
                                SudIK_Pierna_R[3].roll = 0 
                            #L
                            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):    
                                SudIK_Pierna_L[4].head = Base_Pierna_L[2].head
                                Pocion_Normal = Base_Pierna_L[2].z_axis.normalized()
                                SudIK_Pierna_L[4].tail = Base_Pierna_L[2].head + (Pocion_Normal)
                                SudIK_Pierna_L[4].tail.z = SudIK_Pierna_L[4].head.z
                                SudIK_Pierna_L[4].length = Base_Pierna_L[2].length / 2
                                SudIK_Pierna_L[4].roll = 0 
                            #R
                            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):  
                                SudIK_Pierna_R[4].head = Base_Pierna_R[2].head
                                Pocion_Normal = Base_Pierna_R[2].z_axis.normalized()
                                SudIK_Pierna_R[4].tail = Base_Pierna_R[2].head + (Pocion_Normal)
                                SudIK_Pierna_R[4].tail.z = SudIK_Pierna_R[4].head.z
                                SudIK_Pierna_R[4].length = Base_Pierna_R[2].length / 2
                                SudIK_Pierna_R[4].roll = 0 
                #Rot_IK_Pierna_L or Rot_IK_Pierna_R
                Rot_IK_Pierna_L = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                    Encontral_Bones("Rot_IK_Pierna_L", 6, Rot_IK_Pierna_L)
                Rot_IK_Pierna_R = []
                if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                    Encontral_Bones("Rot_IK_Pierna_R", 6, Rot_IK_Pierna_R)
                if Rot_IK_Pierna_L or Rot_IK_Pierna_R:
                    #ROt_Primeros
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(Rot_IK_Pierna_L[0], Base_Pierna_L[3].head, Base_Pierna_L[3].tail, 
                                            Base_Pierna_L[3].roll, Base_Pierna_L[3].length / 2, tengo_length = True)
                        pocioner_Bones_tail(Rot_IK_Pierna_L[1], Base_Pierna_L[3].head,  Base_Pierna_L[3].tail, 
                                             Base_Pierna_L[3].roll,  Base_Pierna_L[3].length / 2, tengo_length = True)
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(Rot_IK_Pierna_R[0], Base_Pierna_R[3].head, Base_Pierna_R[3].tail, 
                                            Base_Pierna_R[3].roll, Base_Pierna_R[3].length / 2, tengo_length = True)
                        pocioner_Bones_tail(Rot_IK_Pierna_R[1], Base_Pierna_R[3].head,  Base_Pierna_R[3].tail, 
                                             Base_Pierna_R[3].roll,  Base_Pierna_R[3].length / 2, tengo_length = True)
                    for i in range(5):
                    #ROt_Plantas
                        if Rot_IK_Pierna_L[2] or Rot_IK_Pierna_R[2]:
                            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                                Rot_IK_Pierna_L[2].head = (Base_Talon_L.head + Base_Talon_L.tail) / 2
                                Normal = Base_Talon_L.x_axis.normalized()
                                Rot_IK_Pierna_L[2].tail += (Normal *-1)
                                Rot_IK_Pierna_L[2].head = Base_Pierna_L[3].tail
                                Rot_IK_Pierna_L[2].length = Base_Pierna_L[2].length / 2 
                                Rot_IK_Pierna_L[2].roll = 0 
                            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                                Rot_IK_Pierna_R[2].head = (Base_Talon_R.head + Base_Talon_R.tail) / 2
                                Normal = Base_Talon_R.x_axis.normalized()
                                Rot_IK_Pierna_R[2].tail += (Normal)
                                Rot_IK_Pierna_R[2].head = Base_Pierna_R[3].tail
                                Rot_IK_Pierna_R[2].length = Base_Pierna_R[2].length / 2 
                                Rot_IK_Pierna_R[2].roll = 0 
                        if Rot_IK_Pierna_L[3] or Rot_IK_Pierna_R[3] or Rot_IK_Pierna_L[4] or Rot_IK_Pierna_R[4]:
                            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                                Rot_IK_Pierna_L[3].head = Base_Talon_L.tail
                                Normal = Base_Talon_L.x_axis.normalized()
                                Rot_IK_Pierna_L[3].tail += Normal * -1
                                Rot_IK_Pierna_L[3].length =  Base_Pierna_L[2].length / 2 
                            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                                Rot_IK_Pierna_R[3].head = Base_Talon_R.tail
                                Normal = Base_Talon_R.x_axis.normalized()
                                Rot_IK_Pierna_R[3].tail += Normal
                                Rot_IK_Pierna_R[3].length =  Base_Pierna_R[2].length / 2 
                            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                                Rot_IK_Pierna_L[4].head = Base_Talon_L.head
                                Normal = Base_Talon_L.x_axis.normalized()
                                Rot_IK_Pierna_L[4].tail += Normal * -1
                                Rot_IK_Pierna_L[4].length =  Base_Pierna_L[2].length / 2 
                            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                                Rot_IK_Pierna_R[4].head = Base_Talon_R.head
                                Normal = Base_Talon_R.x_axis.normalized()
                                Rot_IK_Pierna_R[4].tail += Normal
                                Rot_IK_Pierna_R[4].length =  Base_Pierna_R[2].length / 2 
                        if Rot_IK_Pierna_L[5] or Rot_IK_Pierna_R[5]:
                            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):
                                Rot_IK_Pierna_L[5].head = (Base_Talon_L.tail + Base_Talon_L.head) / 2
                                Normal = Base_Talon_L.x_axis.normalized()
                                Rot_IK_Pierna_L[5].tail += Normal *-1
                                Rot_IK_Pierna_L[5].length =  Base_Pierna_L[2].length / 2 
                            if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                                Rot_IK_Pierna_R[5].head = (Base_Talon_R.tail + Base_Talon_R.head) / 2
                                Normal = Base_Talon_R.x_axis.normalized()
                                Rot_IK_Pierna_R[5].tail += Normal
                                Rot_IK_Pierna_R[5].length =  Base_Pierna_R[2].length / 2 
                #Cont_Rot_IK_Pierna_L or Cont_Rot_IK_Pierna_R
                Cont_Rot_IK_Pierna_L = Bones_get.get("Cont_Rot_IK_Pierna_L")
                Cont_Rot_IK_Pierna_R = Bones_get.get("Cont_Rot_IK_Pierna_R")
                if Cont_Rot_IK_Pierna_L or Cont_Rot_IK_Pierna_R:
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_L.{i+1:03}") for i in range(4)):  
                        Posicionar_Bones(
                            Cont_Rot_IK_Pierna_L, Rot_IK_Pierna_L[5].head, 
                            Rot_IK_Pierna_L[5].tail, Rot_IK_Pierna_L[5].roll, 
                            Rot_IK_Pierna_L[5].length, tengo_length = True
                            )
                        Cont_Rot_IK_Pierna_L.head.z = (Base_Talon_L.head.z + Base_Pierna_L[2].head.z) / 2
                        Cont_Rot_IK_Pierna_L.tail.z = (Base_Talon_L.head.z + Base_Pierna_L[2].head.z) / 2
                    if all(bpy.context.active_object.data.edit_bones.get(f"Base_Pierna_R.{i+1:03}") for i in range(4)):
                        Posicionar_Bones(
                            Cont_Rot_IK_Pierna_R, Rot_IK_Pierna_R[5].head, 
                            Rot_IK_Pierna_R[5].tail, Rot_IK_Pierna_R[5].roll, 
                            Rot_IK_Pierna_R[5].length, tengo_length = True
                            )
                        Cont_Rot_IK_Pierna_R.head.z = (Base_Talon_R.head.z + Base_Pierna_R[2].head.z) / 2
                        Cont_Rot_IK_Pierna_R.tail.z = (Base_Talon_R.head.z + Base_Pierna_R[2].head.z) / 2
        #pose mode 
        bpy.ops.object.mode_set(mode='POSE')
        pose_Bones_get = Armature.pose.bones

        def pose_Encontral_Bones(Nombre_Bone_Base, repeticiones, append):
            for i in range(repeticiones):
                Nombre_Bone = f"{Nombre_Bone_Base}.{(i+1):03}"
                hueso = pose_Bones_get.get(Nombre_Bone)
                append.append(hueso)           
        #Pose_View_Columna
        Pose_Control_Down_Columna = []
        if all(pose_Bones_get.get(f"Control_Down_Columna.{i+1:03}") for i in range(2)):
            pose_Encontral_Bones("Control_Down_Columna", 2, Pose_Control_Down_Columna)
        if Pose_Control_Down_Columna:
            for i in range(2):
                Pose_Control_Down_Columna[i].custom_shape_translation[1] = Pose_Control_Down_Columna[i].length / 2
        #Control_UP_Columna
        Pose_Control_UP_Columna = []
        if all(pose_Bones_get.get(f"Control_UP_Columna.{i+1:03}") for i in range(2)):
            pose_Encontral_Bones("Control_UP_Columna", 2, Pose_Control_UP_Columna)
        if Pose_Control_UP_Columna:
            for i in range(2):
                Pose_Control_UP_Columna[i].custom_shape_translation[1] = Pose_Control_UP_Columna[i].length / 2
        #Control_Cuello
        if pose_Bones_get.get("Control_Cuello.001"):
            pose_Bones_get.get("Control_Cuello.001").custom_shape_translation[1] = pose_Bones_get.get("Control_Cuello.001").length / 2
        #Control_Cabeza
        if pose_Bones_get.get("Control_Cabeza.001"):
            pose_Bones_get.get("Control_Cabeza.001").custom_shape_translation[1] = pose_Bones_get.get("Control_Cabeza.001").length
        #Hombros
        if pose_Bones_get.get("Hombros"):
            pose_Bones_get.get("Hombros").custom_shape_translation[1] = pose_Bones_get.get("Hombros").length / 2
        #Cadera
        if pose_Bones_get.get("Cadera"):
            pose_Bones_get.get("Cadera").custom_shape_translation[1] = pose_Bones_get.get("Cadera").length / 2
        #SudIK_Pierna_L.004
        if pose_Bones_get.get("SudIK_Pierna_L.004"):
            pose_Bones_get.get("SudIK_Pierna_L.004").custom_shape_translation[2] = (
                (pose_Bones_get.get("Base_Pierna_L.003").length / 2) * -1
                )
            pose_Bones_get.get("SudIK_Pierna_L.004").custom_shape_translation[1] = (
                (pose_Bones_get.get("Base_Pierna_L.003").length / 2)
                )
        #SudIK_Pierna_R.004
        if pose_Bones_get.get("SudIK_Pierna_R.004"):
            pose_Bones_get.get("SudIK_Pierna_R.004").custom_shape_translation[2] = (
                (pose_Bones_get.get("Base_Pierna_R.003").length / 2) * -1
                )
            pose_Bones_get.get("SudIK_Pierna_R.004").custom_shape_translation[1] = (
                (pose_Bones_get.get("Base_Pierna_R.003").length / 2)
                )
        #Control_FK_Brazo_L
        Pose_Control_FK_Brazo_L = []
        if all(pose_Bones_get.get(f"Control_FK_Brazo_L.{i+1:03}") for i in range(3)):
            pose_Encontral_Bones("Control_FK_Brazo_L", 3, Pose_Control_FK_Brazo_L)
        if Pose_Control_FK_Brazo_L:
            for i in range(len(Pose_Control_FK_Brazo_L)):
                Pose_Control_FK_Brazo_L[i].custom_shape_translation[1] = Pose_Control_FK_Brazo_L[i].length / 2
        #Control_FK_Brazo_R
        Pose_Control_FK_Brazo_R = []
        if all(pose_Bones_get.get(f"Control_FK_Brazo_R.{i+1:03}") for i in range(3)):  
            pose_Encontral_Bones("Control_FK_Brazo_R", 3, Pose_Control_FK_Brazo_R)
        if Pose_Control_FK_Brazo_R:
            for i in range(len(Pose_Control_FK_Brazo_R)):
                Pose_Control_FK_Brazo_R[i].custom_shape_translation[1] = Pose_Control_FK_Brazo_R[i].length / 2
        #FK_Pierna_L
        Pose_FK_Pierna_L = []
        if all(pose_Bones_get.get(f"FK_Pierna_L.{i+1:03}") for i in range(4)):
            pose_Encontral_Bones("FK_Pierna_L", 4, Pose_FK_Pierna_L)
        if Pose_FK_Pierna_L:
            for i in range(len(Pose_FK_Pierna_L)):
                Pose_FK_Pierna_L[i].custom_shape_translation[1] = Pose_FK_Pierna_L[i].length / 2
        #FK_Pierna_R
        Pose_FK_Pierna_R = []
        if all(pose_Bones_get.get(f"FK_Pierna_R.{i+1:03}") for i in range(4)):
            pose_Encontral_Bones("FK_Pierna_R", 4, Pose_FK_Pierna_R)
        if Pose_FK_Pierna_R:
            for i in range(len(Pose_FK_Pierna_L)):
                Pose_FK_Pierna_R[i].custom_shape_translation[1] = Pose_FK_Pierna_R[i].length / 2
        #Control_IK_Brazo_L.003     
        Control_IK_Brazo_L_003 = pose_Bones_get.get("Control_IK_Brazo_L.003")
        if Control_IK_Brazo_L_003:
            Control_IK_Brazo_L_003.custom_shape_translation[1] = pose_Bones_get.get("Base_Brazo_L.003").length
        #Control_IK_Brazo_R.003
        Control_IK_Brazo_R_003 = pose_Bones_get.get("Control_IK_Brazo_R.003")
        if Control_IK_Brazo_R_003:
            Control_IK_Brazo_L_003.custom_shape_translation[1] = pose_Bones_get.get("Base_Brazo_R.003").length
        #SubControl_IK_Brazo_L.001
        SubControl_IK_Brazo_L_001 = pose_Bones_get.get("SubControl_IK_Brazo_L.001")
        if SubControl_IK_Brazo_L_001 :
            SubControl_IK_Brazo_L_001.custom_shape_translation[1] = pose_Bones_get.get("Base_Brazo_L.001").length
        #SubControl_IK_Brazo_R.001
        SubControl_IK_Brazo_R_001 = pose_Bones_get.get("SubControl_IK_Brazo_R.001")
        if SubControl_IK_Brazo_R_001 :
            SubControl_IK_Brazo_R_001.custom_shape_translation[1] = pose_Bones_get.get("Base_Brazo_R.001").length
        #SudIK_Pierna_L.002
        SudIK_Pierna_L_002 = pose_Bones_get.get("SudIK_Pierna_L.002")
        if SudIK_Pierna_L_002 :
            SudIK_Pierna_L_002.custom_shape_translation[1] = pose_Bones_get.get("Base_Pierna_L.001").length
        #SudIK_Pierna_R.002
        SudIK_Pierna_R_002 = pose_Bones_get.get("SudIK_Pierna_R.002")
        if SudIK_Pierna_R_002 :
            SudIK_Pierna_R_002.custom_shape_translation[1] = pose_Bones_get.get("Base_Pierna_R.001").length
        #Control_Hombros_L.001
        Control_Hombros_L_001 = pose_Bones_get.get("Control_Hombros_L.001")
        if Control_Hombros_L_001:
            Control_Hombros_L_001.custom_shape_translation[1] = pose_Bones_get.get("Base_Hombro_L.002").length
        #Control_Hombros_R.001
        Control_Hombros_R_001 = pose_Bones_get.get("Control_Hombros_R.001")
        if Control_Hombros_R_001:
            Control_Hombros_R_001.custom_shape_translation[1] = pose_Bones_get.get("Base_Hombro_R.002").length
        #FK_Purgar_L
        Pose_FK_Purgar_L = []
        if all(pose_Bones_get.get(f"FK_Purgar_L.{i+1:03}") for i in range(3)):
            pose_Encontral_Bones("FK_Purgar_L", 3, Pose_FK_Purgar_L)
        if Pose_FK_Purgar_L:
            for i in range(len(Pose_FK_Purgar_L)):
                Pose_FK_Purgar_L[i].custom_shape_translation[1] = Pose_FK_Purgar_L[i].length / 2
        #FK_Indice_L
        Pose_FK_Indice_L = []
        if all(pose_Bones_get.get(f"FK_Indice_L.{i+1:03}") for i in range(4)):
            pose_Encontral_Bones("FK_Indice_L", 4, Pose_FK_Indice_L)
        if Pose_FK_Indice_L:
            for i in range(len(Pose_FK_Indice_L)):
                Pose_FK_Indice_L[i].custom_shape_translation[1] = Pose_FK_Indice_L[i].length / 2
        #FK_Corazon_L
        Pose_FK_Corazon_L = []
        if all(pose_Bones_get.get(f"FK_Corazon_L.{i+1:03}") for i in range(4)):
            pose_Encontral_Bones("FK_Corazon_L", 4, Pose_FK_Corazon_L)
        if Pose_FK_Corazon_L:
            for i in range(len(Pose_FK_Corazon_L)):
                Pose_FK_Corazon_L[i].custom_shape_translation[1] = Pose_FK_Corazon_L[i].length / 2
        #FK_Anular_L
        Pose_FK_Anular_L = []
        if all(pose_Bones_get.get(f"FK_Anular_L.{i+1:03}") for i in range(4)):
            pose_Encontral_Bones("FK_Anular_L", 4, Pose_FK_Anular_L)
        if Pose_FK_Anular_L:
            for i in range(len(Pose_FK_Anular_L)):
                Pose_FK_Anular_L[i].custom_shape_translation[1] = Pose_FK_Anular_L[i].length / 2
        #FK_Miñique_L
        Pose_FK_Miñique_L = []
        if all(pose_Bones_get.get(f"FK_Miñique_L.{i+1:03}") for i in range(4)):
            pose_Encontral_Bones("FK_Miñique_L", 4, Pose_FK_Miñique_L)
        if Pose_FK_Miñique_L:
            for i in range(len(Pose_FK_Miñique_L)):
                Pose_FK_Miñique_L[i].custom_shape_translation[1] = Pose_FK_Miñique_L[i].length / 2
        #FK_Purgar_R
        Pose_FK_Purgar_R = []
        if all(pose_Bones_get.get(f"FK_Purgar_R.{i+1:03}") for i in range(3)):
            pose_Encontral_Bones("FK_Purgar_R", 3, Pose_FK_Purgar_R)
        if Pose_FK_Purgar_R:
            for i in range(len(Pose_FK_Purgar_R)):
                Pose_FK_Purgar_R[i].custom_shape_translation[1] = Pose_FK_Purgar_R[i].length / 2
        #FK_Indice_R
        Pose_FK_Indice_R = []
        if all(pose_Bones_get.get(f"FK_Indice_R.{i+1:03}") for i in range(4)):
            pose_Encontral_Bones("FK_Indice_R", 4, Pose_FK_Indice_R)
        if Pose_FK_Indice_R:
            for i in range(len(Pose_FK_Indice_R)):
                Pose_FK_Indice_R[i].custom_shape_translation[1] = Pose_FK_Indice_R[i].length / 2
        #FK_Corazon_R
        Pose_FK_Corazon_R = []
        if all(pose_Bones_get.get(f"FK_Corazon_R.{i+1:03}") for i in range(4)):
            pose_Encontral_Bones("FK_Corazon_R", 4, Pose_FK_Corazon_R)
        if Pose_FK_Corazon_R:
            for i in range(len(Pose_FK_Corazon_R)):
                Pose_FK_Corazon_R[i].custom_shape_translation[1] = Pose_FK_Corazon_R[i].length / 2
        #FK_AnuRar_R
        Pose_FK_Anular_R = []
        if all(pose_Bones_get.get(f"FK_Anular_R.{i+1:03}") for i in range(4)):
            pose_Encontral_Bones("FK_Anular_R", 4, Pose_FK_Anular_R)
        if Pose_FK_Anular_R:
            for i in range(len(Pose_FK_Anular_R)):
                Pose_FK_Anular_R[i].custom_shape_translation[1] = Pose_FK_Anular_R[i].length / 2
        #FK_Miñique_R
        Pose_FK_Miñique_R = []
        if all(pose_Bones_get.get(f"FK_Miñique_R.{i+1:03}") for i in range(4)):
            pose_Encontral_Bones("FK_Miñique_R", 4, Pose_FK_Miñique_R)
        if Pose_FK_Miñique_R:
            for i in range(len(Pose_FK_Miñique_R)):
                Pose_FK_Miñique_R[i].custom_shape_translation[1] = Pose_FK_Miñique_R[i].length / 2
        if bpy.context.active_object or bpy.context.active_object.type == 'ARMATURE':
            armature = bpy.context.active_object
            for bone in armature.pose.bones:
                for constraint in bone.constraints:
                    if constraint.type == 'STRETCH_TO':
                        constraint.rest_length = 0
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Operator001_E1F25(bpy.types.Operator):
    bl_idname = "sna.operator001_e1f25"
    bl_label = "Operator.001"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        before_data = list(bpy.data.collections)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'SAVE_RIG_CREATOR.blend') + r'\Collection', filename='RIG_CREATOR', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.collections)))
        appended_5457A = None if not new_data else new_data[0]
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Operator003_D6735(bpy.types.Operator):
    bl_idname = "sna.operator003_d6735"
    bl_label = "Operator.003"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        before_data = list(bpy.data.collections)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'SAVE_RIG_CREATOR.blend') + r'\Collection', filename='RIG_CREATOR_PIERNA', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.collections)))
        appended_A07D1 = None if not new_data else new_data[0]
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_PT_RIG_CREATOR_403CA(bpy.types.Panel):
    bl_label = 'RIG CREATOR'
    bl_idname = 'SNA_PT_RIG_CREATOR_403CA'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'WINDOW'
    bl_context = ''
    bl_order = 0
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        row_18DBF = layout.row(heading='', align=False)
        row_18DBF.alert = False
        row_18DBF.enabled = True
        row_18DBF.active = True
        row_18DBF.use_property_split = False
        row_18DBF.use_property_decorate = False
        row_18DBF.scale_x = 1.0
        row_18DBF.scale_y = 1.0
        row_18DBF.alignment = 'Left'.upper()
        row_18DBF.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_18DBF.label(text='RIG_ADD', icon_value=101)
        grid_3A03A = layout.grid_flow(columns=-114, row_major=False, even_columns=False, even_rows=False, align=False)
        grid_3A03A.enabled = True
        grid_3A03A.active = True
        grid_3A03A.use_property_split = False
        grid_3A03A.use_property_decorate = True
        grid_3A03A.alignment = 'Left'.upper()
        grid_3A03A.scale_x = 1.0
        grid_3A03A.scale_y = 1.0
        if not True: grid_3A03A.operator_context = "EXEC_DEFAULT"
        op = grid_3A03A.operator('sna.operator001_e1f25', text='RIG Humano base', icon_value=241, emboss=False, depress=False)
        op = grid_3A03A.operator('sna.operator004_c1ca1', text='RIG Humano  Torzo', icon_value=174, emboss=False, depress=False)
        op = grid_3A03A.operator('sna.operator003_d6735', text='RIG Humano  Pierna', icon_value=174, emboss=False, depress=False)
        op = grid_3A03A.operator('sna.operator002_59bac', text='RIG Humano  Brazo', icon_value=174, emboss=False, depress=False)


class SNA_OT_Operator004_C1Ca1(bpy.types.Operator):
    bl_idname = "sna.operator004_c1ca1"
    bl_label = "Operator.004"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        before_data = list(bpy.data.collections)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'SAVE_RIG_CREATOR.blend') + r'\Collection', filename='RIG_CREATOR_TORZO', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.collections)))
        appended_E30C1 = None if not new_data else new_data[0]
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Operator002_59Bac(bpy.types.Operator):
    bl_idname = "sna.operator002_59bac"
    bl_label = "Operator.002"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        before_data = list(bpy.data.collections)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'SAVE_RIG_CREATOR.blend') + r'\Collection', filename='RIG_CREATOR_BRAZO', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.collections)))
        appended_E3366 = None if not new_data else new_data[0]
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def sna_add_to_view3d_mt_armature_add_F69DD(self, context):
    if not (False):
        layout = self.layout
        layout.popover('SNA_PT_RIG_CREATOR_403CA', text='RIG_CREATOR', icon_value=241)


class SNA_PT_RIG_CREATOR_98B31(bpy.types.Panel):
    bl_label = 'RIG CREATOR'
    bl_idname = 'SNA_PT_RIG_CREATOR_98B31'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'RIG CREATOR'
    bl_order = 0
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not ((not property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')]", globals(), locals())))

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        grid_DF793 = layout.grid_flow(columns=6, row_major=False, even_columns=False, even_rows=False, align=True)
        grid_DF793.enabled = True
        grid_DF793.active = True
        grid_DF793.use_property_split = False
        grid_DF793.use_property_decorate = False
        grid_DF793.alignment = 'Expand'.upper()
        grid_DF793.scale_x = 1.0
        grid_DF793.scale_y = 1.399999976158142
        if not True: grid_DF793.operator_context = "EXEC_DEFAULT"
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')].collections[2].is_visible", globals(), locals()):
            grid_DF793.prop(bpy.data.armatures[eval('bpy.context.active_object.name')].collections[2], 'is_visible', text=bpy.data.armatures[eval('bpy.context.active_object.name')].collections[2].name, icon_value=0, emboss=True, toggle=True)
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')].collections[3].is_visible", globals(), locals()):
            grid_DF793.prop(bpy.data.armatures[eval('bpy.context.active_object.name')].collections[3], 'is_visible', text='', icon_value=320, emboss=True, toggle=True)
        layout.separator(factor=1.0)
        grid_17F32 = layout.grid_flow(columns=-361, row_major=False, even_columns=False, even_rows=False, align=False)
        grid_17F32.enabled = True
        grid_17F32.active = True
        grid_17F32.use_property_split = False
        grid_17F32.use_property_decorate = False
        grid_17F32.alignment = 'Expand'.upper()
        grid_17F32.scale_x = 1.0
        grid_17F32.scale_y = 1.0
        if not True: grid_17F32.operator_context = "EXEC_DEFAULT"
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')]", globals(), locals()):
            row_8BD45 = grid_17F32.row(heading='', align=False)
            row_8BD45.alert = False
            row_8BD45.enabled = True
            row_8BD45.active = True
            row_8BD45.use_property_split = False
            row_8BD45.use_property_decorate = False
            row_8BD45.scale_x = 1.0
            row_8BD45.scale_y = 1.0
            row_8BD45.alignment = 'Center'.upper()
            row_8BD45.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_8BD45.label(text='Bone Collections', icon_value=0)
        grid_5F7B2 = grid_17F32.grid_flow(columns=2, row_major=False, even_columns=True, even_rows=False, align=False)
        grid_5F7B2.enabled = True
        grid_5F7B2.active = True
        grid_5F7B2.use_property_split = False
        grid_5F7B2.use_property_decorate = False
        grid_5F7B2.alignment = 'Expand'.upper()
        grid_5F7B2.scale_x = 0.0
        grid_5F7B2.scale_y = 1.399999976158142
        if not True: grid_5F7B2.operator_context = "EXEC_DEFAULT"
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')].collections[4].is_visible", globals(), locals()):
            grid_5F7B2.prop(bpy.data.armatures[eval('bpy.context.active_object.name')].collections[4], 'is_visible', text=bpy.data.armatures[eval('bpy.context.active_object.name')].collections[4].name, icon_value=0, emboss=True, toggle=True)
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')].collections[5].is_visible", globals(), locals()):
            grid_5F7B2.prop(bpy.data.armatures[eval('bpy.context.active_object.name')].collections[5], 'is_visible', text=bpy.data.armatures[eval('bpy.context.active_object.name')].collections[5].name, icon_value=0, emboss=True, toggle=True)
        grid_17F32.separator(factor=1.0)
        grid_EB657 = grid_17F32.grid_flow(columns=6, row_major=False, even_columns=True, even_rows=True, align=False)
        grid_EB657.enabled = True
        grid_EB657.active = True
        grid_EB657.use_property_split = False
        grid_EB657.use_property_decorate = False
        grid_EB657.alignment = 'Expand'.upper()
        grid_EB657.scale_x = 1.0
        grid_EB657.scale_y = 1.399999976158142
        if not True: grid_EB657.operator_context = "EXEC_DEFAULT"
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[6].name].is_visible", globals(), locals()):
            grid_EB657.prop(bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[6].name], 'is_visible', text=bpy.data.armatures[eval('bpy.context.active_object.name')].collections[6].name, icon_value=0, emboss=True, toggle=True)
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[7].name].is_visible", globals(), locals()):
            grid_EB657.prop(bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[7].name], 'is_visible', text=bpy.data.armatures[eval('bpy.context.active_object.name')].collections[7].name, icon_value=0, emboss=True, toggle=True)
        grid_17F32.separator(factor=1.0)
        grid_C6FB7 = grid_17F32.grid_flow(columns=2, row_major=False, even_columns=False, even_rows=False, align=False)
        grid_C6FB7.enabled = True
        grid_C6FB7.active = True
        grid_C6FB7.use_property_split = False
        grid_C6FB7.use_property_decorate = False
        grid_C6FB7.alignment = 'Expand'.upper()
        grid_C6FB7.scale_x = 1.0
        grid_C6FB7.scale_y = 0.800000011920929
        if not True: grid_C6FB7.operator_context = "EXEC_DEFAULT"
        grid_D0B42 = grid_C6FB7.grid_flow(columns=-158, row_major=False, even_columns=False, even_rows=False, align=True)
        grid_D0B42.enabled = True
        grid_D0B42.active = True
        grid_D0B42.use_property_split = False
        grid_D0B42.use_property_decorate = False
        grid_D0B42.alignment = 'Expand'.upper()
        grid_D0B42.scale_x = 1.0
        grid_D0B42.scale_y = 1.399999976158142
        if not True: grid_D0B42.operator_context = "EXEC_DEFAULT"
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[8].name].is_visible", globals(), locals()):
            grid_D0B42.prop(bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[8].name], 'is_visible', text=bpy.data.armatures[eval('bpy.context.active_object.name')].collections[8].name, icon_value=0, emboss=True, toggle=True)
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[9].name].is_visible", globals(), locals()):
            grid_D0B42.prop(bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[9].name], 'is_visible', text=bpy.data.armatures[eval('bpy.context.active_object.name')].collections[9].name, icon_value=0, emboss=True, toggle=True)
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[10].name].is_visible", globals(), locals()):
            grid_D0B42.prop(bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[10].name], 'is_visible', text=bpy.data.armatures[eval('bpy.context.active_object.name')].collections[10].name, icon_value=0, emboss=True, toggle=True)
        grid_F9D92 = grid_C6FB7.grid_flow(columns=-158, row_major=False, even_columns=False, even_rows=False, align=True)
        grid_F9D92.enabled = True
        grid_F9D92.active = True
        grid_F9D92.use_property_split = False
        grid_F9D92.use_property_decorate = False
        grid_F9D92.alignment = 'Expand'.upper()
        grid_F9D92.scale_x = 1.0
        grid_F9D92.scale_y = 1.399999976158142
        if not True: grid_F9D92.operator_context = "EXEC_DEFAULT"
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[11].name].is_visible", globals(), locals()):
            grid_F9D92.prop(bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[11].name], 'is_visible', text=bpy.data.armatures[eval('bpy.context.active_object.name')].collections[11].name, icon_value=0, emboss=True, toggle=True)
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[12].name].is_visible", globals(), locals()):
            grid_F9D92.prop(bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[12].name], 'is_visible', text=bpy.data.armatures[eval('bpy.context.active_object.name')].collections[12].name, icon_value=0, emboss=True, toggle=True)
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[13].name].is_visible", globals(), locals()):
            grid_F9D92.prop(bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[13].name], 'is_visible', text=bpy.data.armatures[eval('bpy.context.active_object.name')].collections[13].name, icon_value=0, emboss=True, toggle=True)
        grid_17F32.separator(factor=1.0)
        grid_2788C = grid_17F32.grid_flow(columns=2, row_major=False, even_columns=False, even_rows=False, align=False)
        grid_2788C.enabled = True
        grid_2788C.active = True
        grid_2788C.use_property_split = False
        grid_2788C.use_property_decorate = False
        grid_2788C.alignment = 'Expand'.upper()
        grid_2788C.scale_x = 1.0
        grid_2788C.scale_y = 0.800000011920929
        if not True: grid_2788C.operator_context = "EXEC_DEFAULT"
        grid_99A20 = grid_2788C.grid_flow(columns=-158, row_major=False, even_columns=False, even_rows=False, align=True)
        grid_99A20.enabled = True
        grid_99A20.active = True
        grid_99A20.use_property_split = False
        grid_99A20.use_property_decorate = False
        grid_99A20.alignment = 'Expand'.upper()
        grid_99A20.scale_x = 1.0
        grid_99A20.scale_y = 1.399999976158142
        if not True: grid_99A20.operator_context = "EXEC_DEFAULT"
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[14].name].is_visible", globals(), locals()):
            grid_99A20.prop(bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[14].name], 'is_visible', text=bpy.data.armatures[eval('bpy.context.active_object.name')].collections[14].name, icon_value=0, emboss=True, toggle=True)
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[15].name].is_visible", globals(), locals()):
            grid_99A20.prop(bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[15].name], 'is_visible', text=bpy.data.armatures[eval('bpy.context.active_object.name')].collections[15].name, icon_value=0, emboss=True, toggle=True)
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[16].name].is_visible", globals(), locals()):
            grid_99A20.prop(bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[16].name], 'is_visible', text=bpy.data.armatures[eval('bpy.context.active_object.name')].collections[16].name, icon_value=0, emboss=True, toggle=True)
        grid_55AF0 = grid_2788C.grid_flow(columns=-158, row_major=False, even_columns=False, even_rows=False, align=True)
        grid_55AF0.enabled = True
        grid_55AF0.active = True
        grid_55AF0.use_property_split = False
        grid_55AF0.use_property_decorate = False
        grid_55AF0.alignment = 'Expand'.upper()
        grid_55AF0.scale_x = 1.0
        grid_55AF0.scale_y = 1.399999976158142
        if not True: grid_55AF0.operator_context = "EXEC_DEFAULT"
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[17].name].is_visible", globals(), locals()):
            grid_55AF0.prop(bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[17].name], 'is_visible', text=bpy.data.armatures[eval('bpy.context.active_object.name')].collections[17].name, icon_value=0, emboss=True, toggle=True)
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[18].name].is_visible", globals(), locals()):
            grid_55AF0.prop(bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[18].name], 'is_visible', text=bpy.data.armatures[eval('bpy.context.active_object.name')].collections[18].name, icon_value=0, emboss=True, toggle=True)
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[19].name].is_visible", globals(), locals()):
            grid_55AF0.prop(bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[19].name], 'is_visible', text=bpy.data.armatures[eval('bpy.context.active_object.name')].collections[19].name, icon_value=0, emboss=True, toggle=True)
        grid_17F32.separator(factor=1.0)
        grid_BF8D7 = grid_17F32.grid_flow(columns=6, row_major=False, even_columns=True, even_rows=False, align=False)
        grid_BF8D7.enabled = True
        grid_BF8D7.active = True
        grid_BF8D7.use_property_split = False
        grid_BF8D7.use_property_decorate = False
        grid_BF8D7.alignment = 'Expand'.upper()
        grid_BF8D7.scale_x = 0.0
        grid_BF8D7.scale_y = 1.399999976158142
        if not True: grid_BF8D7.operator_context = "EXEC_DEFAULT"
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[20].name].is_visible", globals(), locals()):
            grid_BF8D7.prop(bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[20].name], 'is_visible', text=bpy.data.armatures[eval('bpy.context.active_object.name')].collections[20].name, icon_value=0, emboss=True, toggle=True)
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[21].name].is_visible", globals(), locals()):
            grid_BF8D7.prop(bpy.data.armatures[eval('bpy.context.active_object.name')].collections[bpy.data.armatures[eval('bpy.context.active_object.name')].collections[21].name], 'is_visible', text=bpy.data.armatures[eval('bpy.context.active_object.name')].collections[21].name, icon_value=0, emboss=True, toggle=True)
        layout.separator(factor=1.0)
        grid_3BEF6 = layout.grid_flow(columns=-361, row_major=False, even_columns=False, even_rows=False, align=False)
        grid_3BEF6.enabled = True
        grid_3BEF6.active = True
        grid_3BEF6.use_property_split = False
        grid_3BEF6.use_property_decorate = False
        grid_3BEF6.alignment = 'Expand'.upper()
        grid_3BEF6.scale_x = 1.0
        grid_3BEF6.scale_y = 1.0
        if not True: grid_3BEF6.operator_context = "EXEC_DEFAULT"
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')]", globals(), locals()):
            row_F30AC = grid_3BEF6.row(heading='', align=False)
            row_F30AC.alert = False
            row_F30AC.enabled = True
            row_F30AC.active = True
            row_F30AC.use_property_split = False
            row_F30AC.use_property_decorate = False
            row_F30AC.scale_x = 1.0
            row_F30AC.scale_y = 1.0
            row_F30AC.alignment = 'Center'.upper()
            row_F30AC.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_F30AC.label(text='Properties', icon_value=0)
        grid_2F37D = grid_3BEF6.grid_flow(columns=2, row_major=False, even_columns=True, even_rows=False, align=False)
        grid_2F37D.enabled = True
        grid_2F37D.active = True
        grid_2F37D.use_property_split = False
        grid_2F37D.use_property_decorate = False
        grid_2F37D.alignment = 'Expand'.upper()
        grid_2F37D.scale_x = 1.0
        grid_2F37D.scale_y = 1.399999976158142
        if not True: grid_2F37D.operator_context = "EXEC_DEFAULT"
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')]['Cabeza_Global_Local']", globals(), locals()):
            attr_984F6 = '["' + str('Cabeza_Global_Local' + '"]') 
            grid_2F37D.prop(bpy.data.armatures[eval('bpy.context.active_object.name')], attr_984F6, text='Cabeza Global Local', icon_value=0, emboss=True, slider=True)
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')]['Ojos_Global_Local']", globals(), locals()):
            attr_11F05 = '["' + str('Ojos_Global_Local' + '"]') 
            grid_2F37D.prop(bpy.data.armatures[eval('bpy.context.active_object.name')], attr_11F05, text='Ojos Global Local', icon_value=0, emboss=True, slider=True)
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')]", globals(), locals()):
            grid_3BEF6.separator(factor=1.0)
            row_7318E = grid_3BEF6.row(heading='', align=False)
            row_7318E.alert = False
            row_7318E.enabled = True
            row_7318E.active = True
            row_7318E.use_property_split = False
            row_7318E.use_property_decorate = False
            row_7318E.scale_x = 1.0
            row_7318E.scale_y = 1.0
            row_7318E.alignment = 'Center'.upper()
            row_7318E.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_7318E.label(text='Brazo', icon_value=0)
        grid_89D20 = grid_3BEF6.grid_flow(columns=2, row_major=False, even_columns=True, even_rows=False, align=False)
        grid_89D20.enabled = True
        grid_89D20.active = True
        grid_89D20.use_property_split = False
        grid_89D20.use_property_decorate = False
        grid_89D20.alignment = 'Expand'.upper()
        grid_89D20.scale_x = 1.0
        grid_89D20.scale_y = 1.5
        if not True: grid_89D20.operator_context = "EXEC_DEFAULT"
        grid_6F33D = grid_89D20.grid_flow(columns=-159, row_major=False, even_columns=False, even_rows=False, align=True)
        grid_6F33D.enabled = True
        grid_6F33D.active = True
        grid_6F33D.use_property_split = False
        grid_6F33D.use_property_decorate = False
        grid_6F33D.alignment = 'Expand'.upper()
        grid_6F33D.scale_x = 1.0
        grid_6F33D.scale_y = 1.0
        if not True: grid_6F33D.operator_context = "EXEC_DEFAULT"
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')]['Brazo_IK_FK_R']", globals(), locals()):
            attr_8E51D = '["' + str('Brazo_IK_FK_R' + '"]') 
            grid_6F33D.prop(bpy.data.armatures[eval('bpy.context.active_object.name')], attr_8E51D, text='IK_FK_R', icon_value=0, emboss=True, slider=True)
        grid_E88B6 = grid_6F33D.grid_flow(columns=2, row_major=False, even_columns=True, even_rows=False, align=True)
        grid_E88B6.enabled = True
        grid_E88B6.active = True
        grid_E88B6.use_property_split = False
        grid_E88B6.use_property_decorate = False
        grid_E88B6.alignment = 'Expand'.upper()
        grid_E88B6.scale_x = 1.0
        grid_E88B6.scale_y = 0.699999988079071
        if not True: grid_E88B6.operator_context = "EXEC_DEFAULT"
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')]['Brazo_IK_Stretch_R']", globals(), locals()):
            attr_64672 = '["' + str('Brazo_IK_Stretch_R' + '"]') 
            grid_E88B6.prop(bpy.data.armatures[eval('bpy.context.active_object.name')], attr_64672, text='Stretch_R', icon_value=0, emboss=True, toggle=True)
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')]['Brazo_Rot_Mov_R']", globals(), locals()):
            attr_22393 = '["' + str('Brazo_Rot_Mov_R' + '"]') 
            grid_E88B6.prop(bpy.data.armatures[eval('bpy.context.active_object.name')], attr_22393, text='Rot_Mov_R', icon_value=0, emboss=True, toggle=True)
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')]['Global_Local_Brazo_R']", globals(), locals()):
            grid_F8A79 = grid_6F33D.grid_flow(columns=-93, row_major=False, even_columns=True, even_rows=False, align=True)
            grid_F8A79.enabled = True
            grid_F8A79.active = True
            grid_F8A79.use_property_split = False
            grid_F8A79.use_property_decorate = False
            grid_F8A79.alignment = 'Expand'.upper()
            grid_F8A79.scale_x = 1.0
            grid_F8A79.scale_y = 0.699999988079071
            if not True: grid_F8A79.operator_context = "EXEC_DEFAULT"
            attr_E3C10 = '["' + str('Global_Local_Brazo_R' + '"]') 
            grid_F8A79.prop(bpy.data.armatures[eval('bpy.context.active_object.name')], attr_E3C10, text='Global_Local', icon_value=0, emboss=True)
            box_87806 = grid_F8A79.box()
            box_87806.alert = False
            box_87806.enabled = True
            box_87806.active = True
            box_87806.use_property_split = False
            box_87806.use_property_decorate = False
            box_87806.alignment = 'Expand'.upper()
            box_87806.scale_x = 1.0
            box_87806.scale_y = 1.0
            if not True: box_87806.operator_context = "EXEC_DEFAULT"
            row_A68DB = box_87806.row(heading='', align=False)
            row_A68DB.alert = False
            row_A68DB.enabled = True
            row_A68DB.active = True
            row_A68DB.use_property_split = False
            row_A68DB.use_property_decorate = False
            row_A68DB.scale_x = 1.0
            row_A68DB.scale_y = 0.800000011920929
            row_A68DB.alignment = 'Center'.upper()
            row_A68DB.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_A68DB.label(text=('Root_Brazo' if (bpy.data.armatures[eval('bpy.context.active_object.name')]['Global_Local_Brazo_R'] == 4) else ('Hombro' if (bpy.data.armatures[eval('bpy.context.active_object.name')]['Global_Local_Brazo_R'] == 3) else ('Hombros' if (bpy.data.armatures[eval('bpy.context.active_object.name')]['Global_Local_Brazo_R'] == 2) else ('Root_Cadera' if (bpy.data.armatures[eval('bpy.context.active_object.name')]['Global_Local_Brazo_R'] == 1) else 'Root_Move')))) + '_R', icon_value=0)
        grid_11F62 = grid_89D20.grid_flow(columns=-136, row_major=False, even_columns=False, even_rows=False, align=True)
        grid_11F62.enabled = True
        grid_11F62.active = True
        grid_11F62.use_property_split = False
        grid_11F62.use_property_decorate = False
        grid_11F62.alignment = 'Expand'.upper()
        grid_11F62.scale_x = 1.0
        grid_11F62.scale_y = 1.0
        if not True: grid_11F62.operator_context = "EXEC_DEFAULT"
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')]['Brazo_IK_FK_L']", globals(), locals()):
            attr_402B0 = '["' + str('Brazo_IK_FK_L' + '"]') 
            grid_11F62.prop(bpy.data.armatures[eval('bpy.context.active_object.name')], attr_402B0, text='IK_FK_L', icon_value=0, emboss=True, slider=True)
        grid_8C467 = grid_11F62.grid_flow(columns=2, row_major=False, even_columns=True, even_rows=False, align=True)
        grid_8C467.enabled = True
        grid_8C467.active = True
        grid_8C467.use_property_split = False
        grid_8C467.use_property_decorate = False
        grid_8C467.alignment = 'Expand'.upper()
        grid_8C467.scale_x = 1.0
        grid_8C467.scale_y = 0.699999988079071
        if not True: grid_8C467.operator_context = "EXEC_DEFAULT"
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')]['Brazo_IK_Stretch_L']", globals(), locals()):
            attr_B0253 = '["' + str('Brazo_IK_Stretch_L' + '"]') 
            grid_8C467.prop(bpy.data.armatures[eval('bpy.context.active_object.name')], attr_B0253, text='Stretch_L', icon_value=0, emboss=True, toggle=True)
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')]['Brazo_Rot_Mov_L']", globals(), locals()):
            attr_73646 = '["' + str('Brazo_Rot_Mov_L' + '"]') 
            grid_8C467.prop(bpy.data.armatures[eval('bpy.context.active_object.name')], attr_73646, text='Rot_Mov_L', icon_value=0, emboss=True, toggle=True)
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')]['Global_Local_Brazo_L']", globals(), locals()):
            grid_36BBF = grid_11F62.grid_flow(columns=-93, row_major=False, even_columns=True, even_rows=False, align=True)
            grid_36BBF.enabled = True
            grid_36BBF.active = True
            grid_36BBF.use_property_split = False
            grid_36BBF.use_property_decorate = False
            grid_36BBF.alignment = 'Expand'.upper()
            grid_36BBF.scale_x = 1.0
            grid_36BBF.scale_y = 0.699999988079071
            if not True: grid_36BBF.operator_context = "EXEC_DEFAULT"
            attr_17CDE = '["' + str('Global_Local_Brazo_L' + '"]') 
            grid_36BBF.prop(bpy.data.armatures[eval('bpy.context.active_object.name')], attr_17CDE, text='Global_Local', icon_value=0, emboss=True)
            box_BDD34 = grid_36BBF.box()
            box_BDD34.alert = False
            box_BDD34.enabled = True
            box_BDD34.active = True
            box_BDD34.use_property_split = False
            box_BDD34.use_property_decorate = False
            box_BDD34.alignment = 'Expand'.upper()
            box_BDD34.scale_x = 1.0
            box_BDD34.scale_y = 1.0
            if not True: box_BDD34.operator_context = "EXEC_DEFAULT"
            row_86563 = box_BDD34.row(heading='', align=False)
            row_86563.alert = False
            row_86563.enabled = True
            row_86563.active = True
            row_86563.use_property_split = False
            row_86563.use_property_decorate = False
            row_86563.scale_x = 1.0
            row_86563.scale_y = 0.800000011920929
            row_86563.alignment = 'Center'.upper()
            row_86563.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_86563.label(text=('Root_Brazo' if (bpy.data.armatures[eval('bpy.context.active_object.name')]['Global_Local_Brazo_L'] == 4) else ('Hombro' if (bpy.data.armatures[eval('bpy.context.active_object.name')]['Global_Local_Brazo_L'] == 3) else ('Hombros' if (bpy.data.armatures[eval('bpy.context.active_object.name')]['Global_Local_Brazo_L'] == 2) else ('Root_Cadera' if (bpy.data.armatures[eval('bpy.context.active_object.name')]['Global_Local_Brazo_L'] == 1) else 'Root_Move')))) + '_L', icon_value=0)
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')]", globals(), locals()):
            grid_3BEF6.separator(factor=1.0)
            row_69EF6 = grid_3BEF6.row(heading='', align=False)
            row_69EF6.alert = False
            row_69EF6.enabled = True
            row_69EF6.active = True
            row_69EF6.use_property_split = False
            row_69EF6.use_property_decorate = False
            row_69EF6.scale_x = 1.0
            row_69EF6.scale_y = 1.0
            row_69EF6.alignment = 'Center'.upper()
            row_69EF6.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_69EF6.label(text='Pierna', icon_value=0)
        grid_57D5B = grid_3BEF6.grid_flow(columns=2, row_major=False, even_columns=True, even_rows=False, align=False)
        grid_57D5B.enabled = True
        grid_57D5B.active = True
        grid_57D5B.use_property_split = False
        grid_57D5B.use_property_decorate = False
        grid_57D5B.alignment = 'Expand'.upper()
        grid_57D5B.scale_x = 1.0
        grid_57D5B.scale_y = 1.5
        if not True: grid_57D5B.operator_context = "EXEC_DEFAULT"
        grid_289B1 = grid_57D5B.grid_flow(columns=-159, row_major=False, even_columns=False, even_rows=False, align=True)
        grid_289B1.enabled = True
        grid_289B1.active = True
        grid_289B1.use_property_split = False
        grid_289B1.use_property_decorate = False
        grid_289B1.alignment = 'Expand'.upper()
        grid_289B1.scale_x = 1.0
        grid_289B1.scale_y = 1.0
        if not True: grid_289B1.operator_context = "EXEC_DEFAULT"
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')]['Pierna_IK_Fk_R']", globals(), locals()):
            attr_BD4D8 = '["' + str('Pierna_IK_Fk_R' + '"]') 
            grid_289B1.prop(bpy.data.armatures[eval('bpy.context.active_object.name')], attr_BD4D8, text='IK_FK_R', icon_value=0, emboss=True, slider=True)
        grid_EAA86 = grid_289B1.grid_flow(columns=2, row_major=False, even_columns=True, even_rows=False, align=True)
        grid_EAA86.enabled = True
        grid_EAA86.active = True
        grid_EAA86.use_property_split = False
        grid_EAA86.use_property_decorate = False
        grid_EAA86.alignment = 'Expand'.upper()
        grid_EAA86.scale_x = 1.0
        grid_EAA86.scale_y = 0.699999988079071
        if not True: grid_EAA86.operator_context = "EXEC_DEFAULT"
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')]['Pierna_IK_Stretch_R']", globals(), locals()):
            attr_CCE20 = '["' + str('Pierna_IK_Stretch_R' + '"]') 
            grid_EAA86.prop(bpy.data.armatures[eval('bpy.context.active_object.name')], attr_CCE20, text='Stretch_R', icon_value=0, emboss=True, toggle=True)
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')]['Pierna_Rot_Mov_R']", globals(), locals()):
            attr_EA50F = '["' + str('Pierna_Rot_Mov_R' + '"]') 
            grid_EAA86.prop(bpy.data.armatures[eval('bpy.context.active_object.name')], attr_EA50F, text='Rot_Mov_R', icon_value=0, emboss=True, toggle=True)
        grid_F3A8D = grid_57D5B.grid_flow(columns=-136, row_major=False, even_columns=False, even_rows=False, align=True)
        grid_F3A8D.enabled = True
        grid_F3A8D.active = True
        grid_F3A8D.use_property_split = False
        grid_F3A8D.use_property_decorate = False
        grid_F3A8D.alignment = 'Expand'.upper()
        grid_F3A8D.scale_x = 1.0
        grid_F3A8D.scale_y = 1.0
        if not True: grid_F3A8D.operator_context = "EXEC_DEFAULT"
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')]['Pierna_IK_Fk_L']", globals(), locals()):
            attr_29AFA = '["' + str('Pierna_IK_Fk_L' + '"]') 
            grid_F3A8D.prop(bpy.data.armatures[eval('bpy.context.active_object.name')], attr_29AFA, text='IK_FK_L', icon_value=0, emboss=True, slider=True)
        grid_4F1DF = grid_F3A8D.grid_flow(columns=2, row_major=False, even_columns=True, even_rows=False, align=True)
        grid_4F1DF.enabled = True
        grid_4F1DF.active = True
        grid_4F1DF.use_property_split = False
        grid_4F1DF.use_property_decorate = False
        grid_4F1DF.alignment = 'Expand'.upper()
        grid_4F1DF.scale_x = 1.0
        grid_4F1DF.scale_y = 0.699999988079071
        if not True: grid_4F1DF.operator_context = "EXEC_DEFAULT"
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')]['Pierna_IK_Stretch_L']", globals(), locals()):
            attr_58D51 = '["' + str('Pierna_IK_Stretch_L' + '"]') 
            grid_4F1DF.prop(bpy.data.armatures[eval('bpy.context.active_object.name')], attr_58D51, text='Stretch_L', icon_value=0, emboss=True, toggle=True)
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')]['Pierna_Rot_Mov_L']", globals(), locals()):
            attr_6756C = '["' + str('Pierna_Rot_Mov_L' + '"]') 
            grid_4F1DF.prop(bpy.data.armatures[eval('bpy.context.active_object.name')], attr_6756C, text='Rot_Mov_L', icon_value=0, emboss=True, toggle=True)
        if property_exists("bpy.data.armatures[eval('bpy.context.active_object.name')]", globals(), locals()):
            layout.separator(factor=1.0)
            box_52769 = layout.box()
            box_52769.alert = False
            box_52769.enabled = True
            box_52769.active = True
            box_52769.use_property_split = False
            box_52769.use_property_decorate = False
            box_52769.alignment = 'Expand'.upper()
            box_52769.scale_x = 1.0
            box_52769.scale_y = 1.0
            if not True: box_52769.operator_context = "EXEC_DEFAULT"
            row_4E67A = box_52769.row(heading='', align=False)
            row_4E67A.alert = False
            row_4E67A.enabled = True
            row_4E67A.active = True
            row_4E67A.use_property_split = False
            row_4E67A.use_property_decorate = False
            row_4E67A.scale_x = 1.0
            row_4E67A.scale_y = 1.0
            row_4E67A.alignment = 'Center'.upper()
            row_4E67A.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_4E67A.label(text=eval('bpy.context.active_object.name'), icon_value=0)


def sna_paneles_8FEB4(layout_function, ):
    row_102C5 = layout_function.row(heading='', align=False)
    row_102C5.alert = False
    row_102C5.enabled = True
    row_102C5.active = True
    row_102C5.use_property_split = False
    row_102C5.use_property_decorate = False
    row_102C5.scale_x = 1.0
    row_102C5.scale_y = 1.0
    row_102C5.alignment = 'Left'.upper()
    row_102C5.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_102C5.prop(bpy.context.scene, 'sna_ver_stretch_to', text='TO RESET STRETCH_TO', icon_value=(46 if bpy.context.scene.sna_ver_stretch_to else 45), emboss=False)
    if bpy.context.scene.sna_ver_stretch_to:
        op = layout_function.operator('sna.operator_e7326', text='TO RESET ', icon_value=495, emboss=True, depress=False)


class SNA_OT_Operator_E7326(bpy.types.Operator):
    bl_idname = "sna.operator_e7326"
    bl_label = "Operator"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        for bone in bpy.context.selected_pose_bones:
            for constraint in bone.constraints:
                if constraint.type == 'STRETCH_TO':
                    constraint.rest_length = 0
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def register():
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.types.Scene.sna_bone_1 = bpy.props.StringProperty(name='Bone_1', description='', default='', subtype='NONE', maxlen=0)
    bpy.types.Scene.sna_bone_2 = bpy.props.StringProperty(name='Bone_2', description='', default='', subtype='NONE', maxlen=0)
    bpy.types.Scene.sna_bone_3 = bpy.props.StringProperty(name='Bone_3', description='', default='', subtype='NONE', maxlen=0)
    bpy.types.Scene.sna_name_controladores = bpy.props.StringProperty(name='Name_Controladores', description='', default='', subtype='NONE', maxlen=0)
    bpy.types.Scene.sna_ik_rot_c = bpy.props.FloatProperty(name='IK_ROt_C', description='', default=0.0, subtype='NONE', unit='ROTATION', min=-180.0, max=180.0, step=3, precision=3)
    bpy.types.Scene.sna_ver = bpy.props.BoolProperty(name='VER', description='', default=False)
    bpy.types.Scene.sna_ik_fk_1 = bpy.props.FloatProperty(name='IK_FK_1', description='', options={'ANIMATABLE'}, default=0.0, subtype='FACTOR', unit='NONE', min=0.0, max=1.0, step=3, precision=3)
    bpy.types.Scene.sna_ik_fk_2 = bpy.props.FloatProperty(name='IK_FK_2', description='', options={'ANIMATABLE'}, default=0.0, subtype='FACTOR', unit='NONE', min=0.0, max=1.0, step=3, precision=3)
    bpy.types.Scene.sna_bool_rol_fk = bpy.props.BoolProperty(name='Bool_ROl_FK', description='', default=False)
    bpy.types.Scene.sna_parent = bpy.props.BoolProperty(name='Parent', description='', default=True)
    bpy.types.Scene.sna_segments = bpy.props.BoolProperty(name='Segments', description='', default=False)
    bpy.types.Scene.sna_name_fk = bpy.props.StringProperty(name='Name_FK', description='', default='FK_', subtype='NONE', maxlen=0)
    bpy.types.Scene.sna_name_control = bpy.props.StringProperty(name='Name_Control', description='', default='CONTROL_', subtype='NONE', maxlen=0)
    bpy.types.Scene.sna_dedo = bpy.props.BoolProperty(name='DEdo', description='', default=False)
    bpy.types.Scene.sna_ver_def = bpy.props.BoolProperty(name='Ver_DEF', description='', default=False)
    bpy.types.Scene.sna_parent_only_control = bpy.props.BoolProperty(name='Parent_only_Control', description='', default=True)
    bpy.types.Scene.sna_segments_only_control = bpy.props.BoolProperty(name='Segments_Only_COntrol', description='', default=True)
    bpy.types.Scene.sna_control_only = bpy.props.StringProperty(name='CONTROL_only', description='', default='CONTROL_', subtype='NONE', maxlen=0)
    bpy.types.Scene.sna_duplicar_only_control = bpy.props.BoolProperty(name='DUplicar_Only_Control', description='', default=False)
    bpy.types.Scene.sna_sin_select = bpy.props.BoolProperty(name='Sin_SElect', description='', default=False)
    bpy.types.Scene.sna_ver_ik = bpy.props.BoolProperty(name='ver_IK', description='', default=False)
    bpy.types.Scene.sna_ik_ = bpy.props.StringProperty(name='IK_', description='', default='IK_', subtype='NONE', maxlen=0)
    bpy.types.Scene.sna_pole_angle = bpy.props.FloatProperty(name='Pole_angle', description='', default=-1.5707999467849731, subtype='ANGLE', unit='NONE', min=-180.0, max=180.0, step=3, precision=3)
    bpy.types.Scene.sna_strech_ik = bpy.props.BoolProperty(name='Strech_IK', description='', default=True)
    bpy.types.Scene.sna_tengo_pole_target = bpy.props.BoolProperty(name='Tengo_Pole_target', description='', default=True)
    bpy.types.Scene.sna_damped_track_off = bpy.props.BoolProperty(name='DAMPED_TRACK_off', description='', default=True)
    bpy.types.Scene.sna_copy_transforms = bpy.props.BoolProperty(name='Copy Transforms', description='', default=False)
    bpy.types.Scene.sna_ver_fk = bpy.props.BoolProperty(name='Ver_FK', description='', default=False)
    bpy.types.Scene.sna_fk = bpy.props.StringProperty(name='Fk', description='', default='FK_', subtype='NONE', maxlen=0)
    bpy.types.Scene.sna_view_object = bpy.props.BoolProperty(name='VIEW_OBJECT', description='', default=True)
    bpy.types.Scene.sna_copy_transforms_fk = bpy.props.BoolProperty(name='Copy Transforms_FK', description='', default=True)
    bpy.types.Scene.sna_cuantos_interaciones = bpy.props.IntProperty(name='Cuantos_interaciones', description='', default=1, subtype='NONE', min=0)
    bpy.types.Scene.sna_ultimo = bpy.props.BoolProperty(name='Ultimo', description='', default=False)
    bpy.types.Scene.sna_ver_stretch_to = bpy.props.BoolProperty(name='ver STRETCH_TO', description='', default=False)
    bpy.types.Scene.sna_chain_ver = bpy.props.BoolProperty(name='Chain_Ver', description='', default=False)
    bpy.types.Scene.sna_arm = bpy.props.BoolProperty(name='ARM', description='', default=False)
    bpy.types.Scene.sna_reset_rig_creator = bpy.props.BoolProperty(name='Reset_Rig_creator', description='', default=False)
    bpy.utils.register_class(SNA_OT_Operator_6Afd6)
    bpy.utils.register_class(SNA_OT_Operator_5B117)
    bpy.utils.register_class(SNA_OT_Operator_F577F)
    bpy.utils.register_class(SNA_PT_RIG_CREATOR_B0A49)
    bpy.utils.register_class(SNA_OT_Operator_5Eecc)
    bpy.utils.register_class(SNA_OT_Operator_01Bc7)
    bpy.utils.register_class(SNA_OT_Operator_Efb58)
    bpy.utils.register_class(SNA_OT_Operator_973E8)
    bpy.utils.register_class(SNA_OT_Operator001_E1F25)
    bpy.utils.register_class(SNA_OT_Operator003_D6735)
    bpy.utils.register_class(SNA_PT_RIG_CREATOR_403CA)
    bpy.utils.register_class(SNA_OT_Operator004_C1Ca1)
    bpy.utils.register_class(SNA_OT_Operator002_59Bac)
    bpy.types.VIEW3D_MT_armature_add.append(sna_add_to_view3d_mt_armature_add_F69DD)
    bpy.utils.register_class(SNA_PT_RIG_CREATOR_98B31)
    bpy.utils.register_class(SNA_OT_Operator_E7326)
    kc = bpy.context.window_manager.keyconfigs.addon
    km = kc.keymaps.new(name='Window', space_type='EMPTY')
    kmi = km.keymap_items.new('wm.call_panel', 'C', 'PRESS',
        ctrl=True, alt=True, shift=True, repeat=False)
    kmi.properties.name = 'SNA_PT_RIG_CREATOR_B0A49'
    kmi.properties.keep_open = True
    addon_keymaps['3E83B'] = (km, kmi)


def unregister():
    global _icons
    bpy.utils.previews.remove(_icons)
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    del bpy.types.Scene.sna_reset_rig_creator
    del bpy.types.Scene.sna_arm
    del bpy.types.Scene.sna_chain_ver
    del bpy.types.Scene.sna_ver_stretch_to
    del bpy.types.Scene.sna_ultimo
    del bpy.types.Scene.sna_cuantos_interaciones
    del bpy.types.Scene.sna_copy_transforms_fk
    del bpy.types.Scene.sna_view_object
    del bpy.types.Scene.sna_fk
    del bpy.types.Scene.sna_ver_fk
    del bpy.types.Scene.sna_copy_transforms
    del bpy.types.Scene.sna_damped_track_off
    del bpy.types.Scene.sna_tengo_pole_target
    del bpy.types.Scene.sna_strech_ik
    del bpy.types.Scene.sna_pole_angle
    del bpy.types.Scene.sna_ik_
    del bpy.types.Scene.sna_ver_ik
    del bpy.types.Scene.sna_sin_select
    del bpy.types.Scene.sna_duplicar_only_control
    del bpy.types.Scene.sna_control_only
    del bpy.types.Scene.sna_segments_only_control
    del bpy.types.Scene.sna_parent_only_control
    del bpy.types.Scene.sna_ver_def
    del bpy.types.Scene.sna_dedo
    del bpy.types.Scene.sna_name_control
    del bpy.types.Scene.sna_name_fk
    del bpy.types.Scene.sna_segments
    del bpy.types.Scene.sna_parent
    del bpy.types.Scene.sna_bool_rol_fk
    del bpy.types.Scene.sna_ik_fk_2
    del bpy.types.Scene.sna_ik_fk_1
    del bpy.types.Scene.sna_ver
    del bpy.types.Scene.sna_ik_rot_c
    del bpy.types.Scene.sna_name_controladores
    del bpy.types.Scene.sna_bone_3
    del bpy.types.Scene.sna_bone_2
    del bpy.types.Scene.sna_bone_1
    bpy.utils.unregister_class(SNA_OT_Operator_6Afd6)
    bpy.utils.unregister_class(SNA_OT_Operator_5B117)
    bpy.utils.unregister_class(SNA_OT_Operator_F577F)
    bpy.utils.unregister_class(SNA_PT_RIG_CREATOR_B0A49)
    bpy.utils.unregister_class(SNA_OT_Operator_5Eecc)
    bpy.utils.unregister_class(SNA_OT_Operator_01Bc7)
    bpy.utils.unregister_class(SNA_OT_Operator_Efb58)
    bpy.utils.unregister_class(SNA_OT_Operator_973E8)
    bpy.utils.unregister_class(SNA_OT_Operator001_E1F25)
    bpy.utils.unregister_class(SNA_OT_Operator003_D6735)
    bpy.utils.unregister_class(SNA_PT_RIG_CREATOR_403CA)
    bpy.utils.unregister_class(SNA_OT_Operator004_C1Ca1)
    bpy.utils.unregister_class(SNA_OT_Operator002_59Bac)
    bpy.types.VIEW3D_MT_armature_add.remove(sna_add_to_view3d_mt_armature_add_F69DD)
    bpy.utils.unregister_class(SNA_PT_RIG_CREATOR_98B31)
    bpy.utils.unregister_class(SNA_OT_Operator_E7326)
